'use strict';

function otw_sticky( node ){

	this.type = '';
	
	this.position = '';
	
	this.effect = 'slide';
	
	this.effect_speed = 1000;
	
	this.node = node;
	
	this.wrapper = node.parents( '.otw-sticky-wrapoer' );
	
	this.admin_bar_size = 0;
	
	this.hide_value = 0;
	
	this.show_value = 0;
	
	this.push_content = false;
	
	this.push_show_value = 0;
	
	this.push_hide_value = 0;
	
	this.background = false;
	
	this.fixed = '';
	
	this.show_button = '';
	
	this.show_button_pos = 0;
	
	this.hide_button = '';
	
	this.hide_button_pos = 0;
	
	this.disabled = false;
	
	this.visible = true;
	
	var oSelf = this;
	
	setTimeout( function(){
		oSelf.init();
	}, 1000 );
}

otw_sticky.prototype.init = function(){
	
	if( this.node.hasClass( 'otw-full-bar' ) ){
		this.type = 'full-bar';
	};
	
	if( this.node.hasClass( 'otw-top-sticky' ) ){
		this.position = 'top';
	};
	
	if( this.node.hasClass( 'otw-bottom-sticky' ) ){
		this.position = 'bottom';
	};
	
	if( this.node.hasClass( 'otw-left-sticky' ) ){
		this.position = 'left';
	};
	
	if( this.node.hasClass( 'otw-right-sticky' ) ){
		this.position = 'right';
	};
	
	if( this.node.hasClass( 'otw-push-content' ) ){
		this.push_content = true;
	}
	
	if( this.node.hasClass( 'otw-with-ovbackground' ) ){
		this.background = true;
	}
	
	if( this.node.hasClass( 'scrolling-position' ) ){
		this.fixed = 'scrolling';
	}
	
	if( this.wrapper.hasClass( 'otw-show-sticky-delay' ) || this.wrapper.hasClass( 'otw-show-sticky-loads' ) || this.wrapper.hasClass( 'otw-show-sticky-seconds' ) || this.node.hasClass( 'otw-show-sticky-mouse' ) || this.node.hasClass( 'otw-show-sticky-wooab' ) || this.node.hasClass( 'otw-show-sticky-scroll' ) || this.node.hasClass( 'otw-show-sticky-scrollto' ) || this.node.hasClass( 'otw-show-sticky-clickon' ) ){
		this.visible = false;
	}
	
	if( this.node.hasClass( 'otw-fade-animation' ) ){
		this.effect = 'fade';
	}
	
	this.show_button = this.node.find( '.otw-show-man-label' );
	
	this.hide_button = this.node.find( '.otw-hide-man-label' );
	
	var admin_bar = jQuery( '#wpadminbar' );
	
	if( admin_bar.size() ){
	
		this.admin_bar_size = admin_bar.height();
	}
	
	switch( this.position ){
		
		case 'left':
				this.node.css( 'visibility', 'hidden' );
				this.node.css( 'display', 'block' );
				
				this.node.css( 'top', this.admin_bar_size );
				
				this.recalculate_settings();
				
				if( this.show_button && this.show_button.size() && this.show_button.hasClass( 'otw-btn-vertical' ) ){
					this.show_button.css( 'top', - ( this.show_button.height()  ) );
				}
				
				if( this.visible ){
					this.node.css( 'visibility', 'visible' );
				}
			break;
		case 'right':
				this.node.css( 'visibility', 'hidden' );
				this.node.css( 'display', 'block' );
				
				this.node.css( 'top', this.admin_bar_size );
				
				this.recalculate_settings();
				
				this.node.css( 'right', this.hide_value );
				
				if( this.visible ){
					this.node.css( 'visibility', 'visible' );
				}
			break;
		case 'top':
				this.node.css( 'visibility', 'hidden' );
				this.node.css( 'display', 'block' );
				
				this.recalculate_settings();
				
				this.node.css( 'top', this.hide_value );
				
				if( this.show_button && this.show_button.size() && this.show_button.hasClass( 'otw-btn-vertical' ) ){
					this.show_button.css( 'right', -( this.show_button.width() ) );
				}
				
				if( this.visible ){
					this.node.css( 'visibility', 'visible' );
				}
			break;
		case 'bottom':
				
				this.node.css( 'visibility', 'hidden' );
				this.node.css( 'display', 'block' );
				
				this.recalculate_settings();
				
				this.node.css( 'bottom', this.hide_value );
				
				if( this.show_button && this.show_button.size() && this.show_button.hasClass( 'otw-btn-vertical' ) ){
					this.show_button.css( 'right', this.show_button.outerHeight() + 30 );
				}
				
				if( this.show_button && this.show_button.size() ){
					this.show_button.css( 'margin-top', this.show_button_pos );
				}
				
				if( this.hide_button && this.hide_button.size() ){
					this.hide_button.css( 'margin-top', this.hide_button_pos );
				}
				
				if( this.visible ){
					this.node.css( 'visibility', 'visible' );
				}
				
			break;
	}
	
	var oSelf = this;
	
	this.node.find( '.otw-show-man-label' ).on( 'click',  function(){
		oSelf.open_sticky();
	} );
	
	this.node.find( '.otw-hide-man-label' ).on( 'click',  function(){
		oSelf.close_sticky();
	} );
	
	if( this.node.hasClass( 'otw_no_device_large' ) && ( jQuery( 'html, body' ).width() > 767 ) ){
		this.node.css( 'display', 'none' );
		this.disabled = true;
	}
	if( this.node.hasClass( 'otw_no_device_small' ) && ( jQuery( 'html, body' ).width() <= 767 ) ){
		this.node.css( 'display', 'none' );
		this.disabled = true;
	}
}

otw_sticky.prototype.open_sticky = function(){
	
	if( this.disabled ){
		return;
	}
	
	if( this.node.css( 'visibility' ) == 'hidden' ){
		this.node.css( 'visibility', 'visible' );
	}
	
	var oSelf = this;
	
	this.recalculate_settings();
	
	if( this.push_content ){
		this.prepare_push_content();
	}
	
	if( this.background ){
		this.show_background();
	}
	
	switch( this.position ){
		
		case 'left':
				switch( this.effect ){
				
					case 'slide':
							this.open_left = function(){
								
								oSelf.hide_button.css( 'margin-left', - ( oSelf.hide_button_pos + oSelf.node.width() ) );
								
								oSelf.node.addClass( 'otw-opening-sticky' );
								oSelf.node.removeClass( 'otw-hide-sticky' );
								
								oSelf.hide_button.animate( { 'margin-left': oSelf.hide_button_pos }, oSelf.effect_speed );
								
								oSelf.node.animate( { right: oSelf.show_value }, oSelf.effect_speed, function(){
									oSelf.opened_sticky();
								} );
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).animate( { 'margin-left': oSelf.push_show_value  }, oSelf.effect_speed );
								}
							}
							
							this.show_button.animate( { 'margin-left':  -( oSelf.show_button_pos + oSelf.node.width() ) }, oSelf.effect_speed / 2, function(){ oSelf.open_left() } );
						
						break;
					case 'fade':
							this.node.css( 'display', 'none' );
							this.node.css( 'right', this.show_value );
							this.node.fadeIn( this.effect_speed );
							
							this.opened_sticky();
							
							if( this.push_content ){
								jQuery( '#otw-push-wrapper' ).css( 'margin-left', this.push_show_value );
							}
						break;
					default:
							this.node.css( 'right', this.show_value );
							this.opened_sticky();
						break;
					
				}
			break;
		case 'right':
				switch( this.effect ){
				
					case 'slide':
							this.open_right = function(){
								
								oSelf.hide_button.css( 'margin-right', - ( oSelf.hide_button_pos + oSelf.node.width() ) );
								
								oSelf.node.addClass( 'otw-opening-sticky' );
								oSelf.node.removeClass( 'otw-hide-sticky' );
								
								oSelf.hide_button.animate( { 'margin-right': oSelf.hide_button_pos }, oSelf.effect_speed );
								
								oSelf.node.animate( { right: oSelf.show_value }, oSelf.effect_speed, function(){
									oSelf.opened_sticky();
								} );
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).animate( { 'margin-left': oSelf.push_show_value  }, oSelf.effect_speed );
								};
							}
							if( this.show_button.hasClass( 'otw-btn-vertical' ) ){
								this.show_button.animate( { 'margin-left':  ( this.show_button_pos + this.node.width() ) }, this.effect_speed / 2, function(){ oSelf.open_right() } );
							}else{
								this.show_button.animate( { 'margin-right':  -( this.show_button_pos + this.node.width() ) }, this.effect_speed / 2, function(){ oSelf.open_right() } );
							}
						break;
					case 'fade':
							this.node.css( 'display', 'none' );
							this.node.css( 'right', this.show_value );
							this.node.fadeIn( this.effect_speed );
							
							this.opened_sticky();
							
							if( this.push_content ){
								jQuery( '#otw-push-wrapper' ).css( 'margin-left', this.push_show_value );
							}
						break;
					default:
							this.node.css( 'right', this.show_value );
							this.opened_sticky();
						break;
					
				}
			break;
		case 'top':
				switch( this.effect ){
				
					case 'slide':
							this.open_top = function(){
								
								oSelf.hide_button.css( 'margin-top', - ( oSelf.hide_button_pos + oSelf.node.height() ) );
								
								oSelf.node.addClass( 'otw-opening-sticky' );
								oSelf.node.removeClass( 'otw-hide-sticky' );
								
								oSelf.hide_button.animate( { 'margin-top': oSelf.hide_button_pos }, oSelf.effect_speed );
								
								oSelf.node.animate( { top: oSelf.show_value }, oSelf.effect_speed, function(){
									oSelf.opened_sticky();
								} );
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).animate( { 'margin-top': oSelf.push_show_value  }, oSelf.effect_speed );
								}
							}
							this.show_button.animate( { 'margin-top':  - ( this.show_button_pos + this.node.height() ) }, this.effect_speed / 2, function(){ oSelf.open_top() } );
						break;
					case 'fade':
							this.node.css( 'display', 'none' );
							this.node.css( 'top', this.show_value );
							this.node.fadeIn( this.effect_speed );
							
							this.opened_sticky();
							
							if( this.push_content ){
								jQuery( '#otw-push-wrapper' ).css( 'margin-top', this.push_show_value );
							}
						break;
					default:
							this.node.css( 'top', this.show_value );
							this.opened_sticky();
						break;
					
				}
			break;
		case 'bottom':
				var show_value = this.show_value;
				
				if( this.fixed == 'scrolling' ){
					jQuery( 'body' ).scrollTop( jQuery(document).height() );
					setTimeout(function() {
						jQuery( 'body' ).scrollTop( jQuery(document).height() ); },
					20 );
					this.node.css( 'visibility', 'hidden' );
					this.node.css( 'position', 'absolute' );
					
					show_value = - this.node.height();
				}
				switch( this.effect ){
				
					case 'slide':
					
							this.open_bottom = function(){
							
								if( oSelf.fixed == 'scrolling' ){
									oSelf.node.css( 'visibility', 'visible' );
								}
								
								oSelf.hide_button.css( 'margin-top', oSelf.hide_button_pos + oSelf.node.height() );
								
								oSelf.node.addClass( 'otw-opening-sticky' );
								oSelf.node.removeClass( 'otw-hide-sticky' );
								
								oSelf.hide_button.animate( { 'margin-top': oSelf.hide_button_pos }, oSelf.effect_speed );
								
								oSelf.node.animate( { bottom: show_value }, oSelf.effect_speed, function(){
									oSelf.opened_sticky();
								} );
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).css( 'position', 'relative' );
									jQuery( '#otw-push-wrapper' ).height( jQuery( '#otw-push-wrapper-inner' ).height() );
									jQuery( '#otw-push-wrapper-inner' ).css( 'position', 'absolute' );
									jQuery( '#otw-push-wrapper-inner' ).animate( { 'top': - oSelf.push_show_value  }, oSelf.effect_speed );
								}
							}
							
							this.show_button.animate( { 'margin-top': this.show_button_pos + this.node.height() }, this.effect_speed / 2, function(){ oSelf.open_bottom() } );
						break;
					case 'fade':
							
							this.node.css( 'display', 'none' );
							if( this.fixed == 'scrolling' ){
								this.node.css( 'visibility', 'visible' );
							}
							this.node.css( 'bottom', this.show_value );
							this.node.fadeIn( this.effect_speed );
							
							if( this.push_content ){
								jQuery( '#otw-push-wrapper' ).css( 'position', 'relative' );
								jQuery( '#otw-push-wrapper' ).height( jQuery( '#otw-push-wrapper-inner' ).height() );
								jQuery( '#otw-push-wrapper-inner' ).css( 'position', 'absolute' );
								jQuery( '#otw-push-wrapper-inner' ).css( 'top', - this.push_show_value );
							}
							this.opened_sticky();
						break;
					default:
							this.node.css( 'bottom', this.show_value );
							this.opened_sticky();
						break;
					
				}
			break;
	}
};
otw_sticky.prototype.opened_sticky = function(){
	
	
	this.node.removeClass( 'otw-opening-sticky' );
	this.node.removeClass( 'otw-hide-sticky' );
	this.node.addClass( 'otw-show-sticky' );
	
	if( this.fixed == 'scrolling' ){
		this.node.css( 'position', 'absolute' );
	}
	
}
otw_sticky.prototype.recalculate_settings = function(){
	
	switch( this.position ){
		
		case 'left':
				this.hide_value = '100%';
				
				this.push_show_value = this.node.width();
				
				this.show_value = jQuery( 'body' ).width() - this.node.width();
			break;
		case 'right':
				this.hide_value = - this.node.width();
				
				this.push_show_value = - this.node.width();
			break;
		case 'top':
				this.hide_value = - ( this.node.height() - this.admin_bar_size + 2 );
				
				this.show_value = this.admin_bar_size;
				
				this.push_show_value = ( this.node.outerHeight() );
			break;
		case 'bottom':
				this.hide_value = - ( this.node.height() );
				
				this.push_show_value = ( this.node.height() );
				
				if( this.show_button && this.show_button.size() ){
					this.show_button_pos = this.hide_value - this.show_button.outerHeight();
				}
				
				if( this.hide_button && this.hide_button.size() ){
					this.hide_button_pos = this.hide_value - this.hide_button.outerHeight();
				}
			break;
	}
}
otw_sticky.prototype.close_sticky = function(){
	
	var oSelf = this;
	
	this.recalculate_settings();
	
	switch( this.position ){
		
		case 'left':
				switch( this.effect ){
					
					case 'slide':
							this.hide_button.animate( { 'margin-left': -( this.hide_button_pos + this.node.height() + this.hide_button.outerHeight() ) }, this.effect_speed );
							
							this.node.animate( { right: this.hide_value }, this.effect_speed, function(){
								oSelf.closed_sticky();
								oSelf.show_button.animate( { 'margin-left': oSelf.show_button_pos }, oSelf.effect_speed );
							} );
							
							if( this.push_content ){
								
								jQuery( '#otw-push-wrapper' ).animate( { 'margin-left':  this.push_hide_value  }, this.effect_speed );
							}
						break;
					case 'fade':
							this.node.fadeOut( this.effect_speed, function(){
								oSelf.node.css( 'right', oSelf.hide_value );
								oSelf.node.css( 'display', 'block' );
								
								oSelf.closed_sticky();
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).css( 'margin-left', oSelf.push_hide_value );
								}
							} );
						break;
					default:
							this.node.css( 'right', this.hide_value );
							this.closed_sticky();
						break;
				}
			break;
		case 'right':
				switch( this.effect ){
					
					case 'slide':
							this.hide_button.animate( { 'margin-right': -( this.hide_button_pos + this.node.height() + this.hide_button.outerHeight() ) }, this.effect_speed );
							
							this.node.animate( { right: this.hide_value }, this.effect_speed, function(){
								
								oSelf.closed_sticky();
								
								if( oSelf.show_button.hasClass( 'otw-btn-vertical' ) ){
									oSelf.show_button.animate( { 'margin-left': oSelf.show_button_pos }, oSelf.effect_speed );
								}else{
									oSelf.show_button.animate( { 'margin-right': oSelf.show_button_pos }, oSelf.effect_speed );
								}
							} );
							
							if( this.push_content ){
								jQuery( '#otw-push-wrapper' ).animate( { 'margin-left':  this.push_hide_value  }, this.effect_speed );
							}
						break;
					case 'fade':
							this.node.fadeOut( this.effect_speed, function(){
								oSelf.node.css( 'right', oSelf.hide_value );
								oSelf.node.css( 'display', 'block' );
								
								oSelf.closed_sticky();
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).css( 'margin-left', oSelf.push_hide_value );
								}
							} );
						break;
					default:
							this.node.css( 'right', this.hide_value );
							this.closed_sticky();
						break;
				}
			break;
		case 'top':
				switch( this.effect ){
					
					case 'slide':
							this.hide_button.animate( { 'margin-top': -( this.hide_button_pos + this.node.height() + this.hide_button.outerHeight() ) }, this.effect_speed );
							this.node.animate( { top: this.hide_value }, this.effect_speed, function(){
									
								oSelf.closed_sticky();
								oSelf.show_button.animate( { 'margin-top': oSelf.show_button_pos }, oSelf.effect_speed );
							} );
							
							if( this.push_content ){
								jQuery( '#otw-push-wrapper' ).animate( { 'margin-top':  this.push_hide_value  }, this.effect_speed );
							}
						break;
					case 'fade':
							this.node.fadeOut( this.effect_speed, function(){
								oSelf.node.css( 'top', oSelf.hide_value );
								oSelf.node.css( 'display', 'block' );
								
								oSelf.closed_sticky();
								
								if( oSelf.push_content ){
									jQuery( '#otw-push-wrapper' ).css( 'margin-top', oSelf.push_hide_value );
								}
							} );
						break;
					default:
							this.node.css( 'top', this.hide_value );
							this.closed_sticky();
						break;
				}
			break;
		case 'bottom':
				
				switch( this.effect ){
					
					case 'slide':
							this.hide_button.animate( { 'margin-top': this.hide_button_pos + this.node.height() + this.hide_button.outerHeight() }, this.effect_speed );
							
							this.node.animate( { bottom: this.hide_value }, this.effect_speed, function(){
								
								oSelf.closed_sticky();
								oSelf.show_button.animate( { 'margin-top': oSelf.show_button_pos }, oSelf.effect_speed );
							} );
							
							if( this.push_content ){
								
								jQuery( '#otw-push-wrapper' ).height( 'auto' );
								jQuery( '#otw-push-wrapper-inner' ).css( 'position', 'inherit' );
								jQuery( '#otw-push-wrapper-inner' ).animate( { 'top': this.push_hide_value  }, this.effect_speed );
							}
						break;
					case 'fade':
							
							this.node.fadeOut( this.effect_speed, function(){
								oSelf.node.css( 'bottom', oSelf.hide_value );
								oSelf.node.css( 'display', 'block' );
								
								oSelf.closed_sticky();
								
								if( oSelf.push_content ){
								
									jQuery( '#otw-push-wrapper' ).height( 'auto' );
									jQuery( '#otw-push-wrapper-inner' ).css( 'position', 'inherit' );
									jQuery( '#otw-push-wrapper-inner' ).css( 'top', oSelf.push_hide_value );
								}
							} );
						break;
					default:
							this.node.css( 'bottom', this.hide_value );
							this.closed_sticky();
						break;
				}
			break;
	}
	
	if( this.background ){
		this.hide_background();
	}
}
otw_sticky.prototype.closed_sticky = function(){
	
	this.node.removeClass( 'otw-show-sticky' );
	this.node.addClass( 'otw-hide-sticky' );
	
	if( this.fixed == 'scrolling' ){
		this.node.css( 'position', 'fixed' );
	}
}
otw_sticky.prototype.show_background = function(){

	var background_class = '';
	var background_style = '';
	
	var classes = this.node.attr( 'class' ).split( /\s+/ );
	
	for( var cC = 0; cC < classes.length; cC++ ){
		
		if( classes[cC].match( /^otw\-overlay\-pattern\-([0-9]+)$/ ) ){
			if( background_class.length ){
				background_class = background_class + ' ' + classes[cC];
			}else{
				background_class = classes[cC];
			}
		}else if( classes[cC].match( /^otw_no_device_small$/ ) ){
			if( background_class.length ){
				background_class = background_class + ' ' + classes[cC];
			}else{
				background_class = classes[cC];
			}
		}
	};
	
	if( this.node.attr( 'data-style' ) && this.node.attr( 'data-style' ).length ){
		background_style = this.node.attr( 'data-style' );
	};
	
	if( jQuery( '#otw-overwray-background-wrapper' ).size() == 0 ){
		jQuery( 'body' ).append( '<div id="otw-overwray-background-wrapper"></div>' );
	}
	jQuery( '#otw-overwray-background-wrapper' ).show();
	
	if( background_class.length ){
		jQuery( '#otw-overwray-background-wrapper' ).attr( 'class', background_class );
	}else{
		jQuery( '#otw-overwray-background-wrapper' ).removeAttr( 'class' );
	}
	
	if( background_style.length ){
		jQuery( '#otw-overwray-background-wrapper' ).attr( 'style', background_style );
	}else{
		jQuery( '#otw-overwray-background-wrapper' ).removeAttr( 'style' );
	}
}

otw_sticky.prototype.hide_background = function(){
	
	if( jQuery( '#otw-overwray-background-wrapper' ).size() > 0 ){
		jQuery( '#otw-overwray-background-wrapper' ).hide();
	}
};

otw_sticky.prototype.prepare_push_content = function(){
		
	if( jQuery( '#otw-push-wrapper' ).size() == 0 ){
		jQuery( 'body' ).wrapInner( '<div id="otw-push-wrapper"><div id="otw-push-wrapper-inner"></div></div>' );
		jQuery( '#otw-push-wrapper-inner' ).css( 'width', jQuery( 'body' ).width() + 'px' );
		
		jQuery( window ).resize( function(){
			jQuery( '#otw-push-wrapper-inner' ).css( 'width', jQuery( 'body' ).width() + 'px' );
		});
	};
}