<?php
/**
 * Init function
 */
if( !function_exists( 'otw_pc_admin_init' ) ){
	
	function otw_pc_admin_init(){
		global $otw_pc_overlay_object;
		
		if( isset( $otw_pc_overlay_object->create_nav_menu ) && $otw_pc_overlay_object->create_nav_menu ){
			$otw_pc_overlay_object->action_meta_metaboxes();
		}
	}
}
/**
 * Init function
 */
if( !function_exists( 'otw_pc_init' ) ){
	
	function otw_pc_init(){
		
		global $otw_pc_plugin_url, $otw_sbm_widget_settings, $otw_pc_grid_manager_component, $otw_pc_shortcode_component, $otw_pc_shortcode_object, $otw_pc_form_component, $otw_pc_validator_component, $otw_pc_form_object, $otw_pc_js_version, $otw_pc_css_version, $otw_pc_grid_manager_object, $wp_pc_int_items, $otw_pc_overlay_component, $otw_pc_overlay_object, $otw_pc_factory_component, $otw_pc_factory_object, $otw_pc_plugin_id;
		
		if( is_admin() ){
			
			add_action('admin_menu', 'otw_pc_init_admin_menu' );
			
			add_action('admin_print_styles', 'otw_pc_enqueue_admin_styles' );
			
			add_action('admin_enqueue_scripts', 'otw_pc_enqueue_admin_scripts');
			
			add_filter( 'otwfcr_notice', 'otw_pc_factory_message' );
		}
		else
		{
			otw_pc_enqueue_styles();
			
			otw_pc_enqueue_scripts();
		}
		
		otw_pc_add_items();
		
		//get the imported shortcodes
		$otw_pc_import_shortcodes = get_option('otw_import_shortcodes');
		
		if (!is_array($otw_pc_import_shortcodes)){
			$otw_pc_import_shortcodes = array();
		}
		
		$custom_post_types = get_post_types( array(  'public'   => true, '_builtin' => false ), 'object' );
		
		if( is_array( $custom_post_types ) ){
			foreach( $custom_post_types as $c_key => $c_cust ){
				
				if( otw_pc_installed_plugin( 'bbpress' ) && $c_key == 'reply' ){
					//skip reply they appear on same pages as topics
				}else{
					$wp_pc_int_items[ 'cpt_'. $c_cust->name ] = array( array(), $c_cust->label, esc_html__( 'All ', 'otw_pc' ).$c_cust->labels->name );
				}
			}
		}
		
		$custom_taxonomies = get_taxonomies( array(  'public'   => true, '_builtin' => false ), 'object' );
		
		if( is_array( $custom_taxonomies ) ){
			foreach( $custom_taxonomies as $c_cust ){
				$wp_pc_int_items[ 'ctx_'. $c_cust->name ] = array( array(), $c_cust->label.' '.__( 'archives', 'otw_pc' ),__( 'All ', 'otw_pc' ).$c_cust->label.' '.__('archives', 'otw_pc' ) );
				foreach( $c_cust->object_type as $c_object ){
					
					if( $c_object_info = get_post_type_object( $c_object ) ){
						$wp_pc_int_items[ $c_object.'_in_ctx_'. $c_cust->name ] = array( array(), esc_html__( 'All', 'otw_pc' ).' '.$c_object_info->labels->name.' '.__( 'from taxonomy', 'otw_pc' ).' '.$c_cust->label, esc_html__( 'All', 'otw_pc' ).' '.$c_object_info->labels->name.' '.__( 'from taxonomy', 'otw_pc' ).' '.$c_cust->label );
					}
				}
				
			}
		}
		
		//otw grid manager component
		$otw_pc_grid_manager_component = otw_load_component( 'otw_overlay_grid_manager' );
		$otw_pc_grid_manager_object = otw_get_component( $otw_pc_grid_manager_component );
		$otw_pc_grid_manager_object->js_version = $otw_pc_js_version;
		$otw_pc_grid_manager_object->css_version = $otw_pc_css_version;
		$otw_pc_grid_manager_object->text_info = esc_html__( 'Add some rows and columns in the rows. Then you will be able to add shortcode in the columns. Once you build your layout you can save it so you can use it for another page.', 'otw_pc' );
		
		include_once( plugin_dir_path( __FILE__ ).'otw_labels/otw_pc_grid_manager_object.labels.php' );
		$otw_pc_grid_manager_object->init();
		
		$otw_pc_factory_component = otw_load_component( 'otw_factory' );
		$otw_pc_factory_object = otw_get_component( $otw_pc_factory_component );
		$otw_pc_factory_object->add_plugin( $otw_pc_plugin_id, dirname( dirname( __FILE__ ) ).'/otw_popping_content.php', array( 'menu_parent' => 'otw-pc', 'lc_name' => esc_html__( 'License Manager', 'otw_pc' ), 'menu_key' => 'otw-pc' ) );
		
		include_once( plugin_dir_path( __FILE__ ).'otw_labels/otw_pc_factory_object.labels.php' );
		$otw_pc_factory_object->init();
		
		//shortcode component
		if( $otw_pc_factory_object->is_plugin_active( $otw_pc_plugin_id ) ){
			
			$otw_pc_shortcode_component = otw_load_component( 'otw_overlay_shortcode' );
			$otw_pc_shortcode_object = otw_get_component( $otw_pc_shortcode_component );
			$otw_pc_shortcode_object->js_version = $otw_pc_js_version;
			$otw_pc_shortcode_object->css_version = $otw_pc_css_version;
			
			$otw_pc_shortcode_object->add_default_external_lib( 'css', 'style', get_stylesheet_directory_uri().'/style.css', 'live_preview', 10 );
			
			$otw_pc_shortcode_object->shortcodes['icon_box'] = array('title' => esc_html__('Icon Box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -12, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			
			$otw_pc_shortcode_object->shortcodes['info_list'] = array('title' => esc_html__('Info List', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -11, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['flipbox'] = array('title' => esc_html__(' Flip Box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -10, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['countdown'] = array('title' => esc_html__('Count Down', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -9, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['progressbar'] = array('title' => esc_html__('Progress Bar', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -8, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['animatedimg'] = array('title' => esc_html__('Animated Image', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -7, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['gallery'] = array('title' => esc_html__('Gallery', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -6, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['clientslider'] = array('title' => esc_html__('Clients Slider', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -5, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['animatedtestimonials'] = array('title' => esc_html__('Testimonial Animated', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -4, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['testimonialsslider'] = array('title' => esc_html__('Testimonials Slider', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -3, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['promotion'] = array('title' => esc_html__('Promotion', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -2, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['contactuspage'] = array('title' => esc_html__('Contact Us Page', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => -1, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['button'] = array('title' => esc_html__('Button', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 0, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['icon_link'] = array('title' => esc_html__('Icon Link', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 1, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['info_box'] = array('title' => esc_html__('Info Box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 2, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['dropcap'] = array('title' => esc_html__('Dropcaps', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 3, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['quote'] = array('title' => esc_html__('Quote', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 4, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['highlight'] = array('title' => esc_html__('Highlight', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 5, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['abbreviation'] = array('title' => esc_html__('Abbreviation', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 6, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['tabslayout'] = array('title' => esc_html__('Tabs Layout', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 7, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['content_toggle'] = array('title' => esc_html__('Content toggle', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 8, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['accordion'] = array('title' => esc_html__('Accordion', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 9, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['faq'] = array('title' => esc_html__('FAQ', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 10, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['contact_form'] = array('title' => esc_html__('Contact Form', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 11, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['services'] = array('title' => esc_html__('Services', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 12, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['about_us'] = array('title' => esc_html__('About us', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 13, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['image_style'] = array('title' => esc_html__('Image style', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 14, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['unordered_list'] = array('title' => esc_html__('Unordered list', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 15, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['ordered_list'] = array('title' => esc_html__('Ordered list', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 16, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['divider'] = array('title' => esc_html__('Divider', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 17, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			
			$otw_pc_shortcode_object->shortcodes['social_icons'] = array('title' => esc_html__('Social Icons', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 18, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_tweet'] = array('title' => esc_html__('Tweet', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 20, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_twitter_follow'] = array('title' => esc_html__('Twitter Follow', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 21, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['twitter_stream'] = array('title' => esc_html__('Twitter Stream', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 22, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['flickr'] = array('title' => esc_html__('Flickr', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 23, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_digg'] = array('title' => esc_html__('Digg', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 24, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_facebook_like'] = array('title' => esc_html__('Facebook Like button', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 25, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_facebook_share'] = array('title' => esc_html__('Facebook share button', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 26, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_facebook_likebox'] = array('title' => esc_html__('Facebook Like box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 25, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_linkedin_share'] = array('title' => esc_html__('Share on Linkedin', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 27, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['social_google_plus'] = array('title' => esc_html__('Google +1 Button', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'social_buttons', 'order' => 28, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			
			$social_buttons_chilren = array('social_icons', 'social_tweet', 'social_twitter_follow', 'flickr', 'twitter_stream', 'social_digg', 'social_facebook_like', 'social_facebook_share', 'social_facebook_likebox', 'social_linkedin_share', 'social_google_plus');
			
			$otw_pc_shortcode_object->shortcodes['social_buttons'] = array('title' => esc_html__('Social', 'otw_pc'), 'enabled' => true, 'children' => $social_buttons_chilren, 'parent' => false, 'order' => 119, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			
			$otw_pc_shortcode_object->shortcodes['message_box'] = array('title' => esc_html__('Message box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 121, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['content_box'] = array('title' => esc_html__('Content box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 122, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['clients'] = array('title' => esc_html__('Clients', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 123, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['testimonials'] = array('title' => esc_html__('Testimonials', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 124, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['html_editor'] = array('title' => esc_html__('HTML Editor', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 125, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['plain_text'] = array('title' => esc_html__('Plain Text', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 126, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['wp_embed_content'] = array('title' => esc_html__('WP Embed Content', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 127, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['blog_author_info'] = array('title' => esc_html__('Blog Author Info', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 128, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			
			$otw_pc_shortcode_object->shortcodes['post_tabs'] = array('title' => esc_html__('Post Tabs', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 130, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['scroll_to_top'] = array('title' => esc_html__('Scroll to Top', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 132, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['price_box'] = array('title' => esc_html__('Price box', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 133, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['price_table'] = array('title' => esc_html__('Price table', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 134, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			$otw_pc_shortcode_object->shortcodes['sortable_table'] = array('title' => esc_html__('Sortable table', 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => false, 'order' => 135, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			
			$import_shortcode_order = 10001;
			$imported_shortcodes_children = array();
			
			foreach ($otw_pc_import_shortcodes as $cs_key => $cs_data){
				$otw_pc_shortcode_object->shortcodes['import_shortcode_' . $cs_key] = array('title' => esc_html__($cs_data['title'], 'otw_pc'), 'enabled' => true, 'children' => false, 'parent' => 'imported_shortcodes', 'order' => $import_shortcode_order++, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
				$imported_shortcodes_children[] = 'import_shortcode_' . $cs_key;
			}
			
			if (count($imported_shortcodes_children)){
				$otw_pc_shortcode_object->shortcodes['imported_shortcodes'] = array('title' => esc_html__('Imported Shortcodes', 'otw_pc'), 'enabled' => true, 'children' => $imported_shortcodes_children, 'parent' => false, 'order' => $import_shortcode_order, 'path' => dirname(__FILE__) . '/otw_components/otw_overlay_shortcode/', 'url' => $otw_pc_plugin_url . 'include/otw_components/otw_overlay_shortcode/');
			}
			
			include_once( plugin_dir_path( __FILE__ ).'otw_labels/otw_pc_shortcode_object.labels.php' );
			$otw_pc_shortcode_object->init();
		}
		
		//form component
		$otw_pc_form_component = otw_load_component( 'otw_form' );
		$otw_pc_form_object = otw_get_component( $otw_pc_form_component );
		$otw_pc_form_object->js_version = $otw_pc_js_version;
		$otw_pc_form_object->css_version = $otw_pc_css_version;
		
		global $wp_filesystem;
		
		if( otw_init_filesystem() ){
			
			if( $wp_filesystem->is_file( plugin_dir_path( __FILE__ ).'otw_labels/otw_pc_form_object.labels.php' ) ){
				
				include_once( plugin_dir_path( __FILE__ ).'otw_labels/otw_pc_form_object.labels.php' );
				
			}
		}
		
		$otw_pc_form_object->init();
		
		//overlay component
		if( $otw_pc_factory_object->is_plugin_active( $otw_pc_plugin_id ) ){
			
			$otw_pc_overlay_component = otw_load_component( 'otw_overlay' );
			$otw_pc_overlay_object = otw_get_component( $otw_pc_overlay_component );
			$otw_pc_overlay_object->js_version = $otw_pc_js_version;
			$otw_pc_overlay_object->css_version = $otw_pc_css_version;
			$otw_pc_overlay_object->grid_manager_component_object = $otw_pc_grid_manager_object;
			$otw_pc_overlay_object->create_nav_menu = true;
			include_once( plugin_dir_path( __FILE__ ).'otw_labels/otw_pc_overlay_object.labels.php' );
			$otw_pc_overlay_object->init();
		}
		
		//validator component
		$otw_pc_validator_component = otw_load_component( 'otw_validator' );
		$otw_pc_validator_object = otw_get_component( $otw_pc_validator_component );
		$otw_pc_validator_object->js_version = $otw_pc_js_version;
		$otw_pc_validator_object->css_version = $otw_pc_css_version;
		$otw_pc_validator_object->init();
		
		if( $otw_pc_factory_object->is_plugin_active( $otw_pc_plugin_id ) ){
			include_once( 'otw_pc_process_actions.php' );
		}
	}
}
/**
 * include needed styles
 */
if( !function_exists( 'otw_pc_enqueue_styles' ) ){
	function otw_pc_enqueue_styles(){
		global $otw_pc_plugin_url, $otw_pc_css_version, $otw_pc_custom_css_path, $otw_pc_custom_css_url, $wp_filesystem;
		
		if( !is_admin() && otw_init_filesystem() ){
			
			if( $wp_filesystem->exists( $otw_pc_custom_css_path ) ){
				
				wp_register_style('otw_pc_custom.css', $otw_pc_custom_css_url );
				wp_enqueue_style('otw_pc_custom.css');
			}
		}
	}
}

/**
 * include needed scripts
 */
if( !function_exists( 'otw_pc_enqueue_scripts' ) ){
	function otw_pc_enqueue_scripts(){
		global $otw_pc_plugin_url, $otw_pc_js_version;
		
		if( !is_admin() ){
		
		}
	}
}
/**
 * Admin styles
 */
if( !function_exists( 'otw_pc_enqueue_admin_styles' ) ){
	
	function otw_pc_enqueue_admin_styles(){
		
		global $otw_pc_plugin_url, $otw_pc_css_version;
		
		wp_enqueue_style( 'otw_pc_admin', $otw_pc_plugin_url.'/css/otw_pc_admin.css', array( 'thickbox' ), $otw_pc_css_version );
	}
}

/**
 * Admin scripts
 */
if( !function_exists( 'otw_pc_enqueue_admin_scripts' ) ){
	
	function otw_pc_enqueue_admin_scripts( $requested_page ){
		
		global $otw_pc_plugin_url, $otw_pc_js_version, $otw_pc_shortcode_object, $otw_pc_grid_manager_object;
		
		if( ( $requested_page == 'popping-content_page_otw-pc-manage' ) || ( preg_match( "/page_otw-pc-manage$/", $requested_page ) ) ){
			
			$otw_pc_grid_manager_object->include_admin_scripts();
			$otw_pc_shortcode_object->include_admin_scripts();
			
			wp_enqueue_style('thickbox');
			wp_enqueue_script('thickbox');
			wp_enqueue_script('media-models');
			wp_enqueue_script('media-upload');
			wp_enqueue_media();
			wp_enqueue_script("otw_pc_manage_overlay_admin", $otw_pc_plugin_url.'/js/otw_manage_overlay_admin.js'  , array( 'jquery', 'jquery-ui-sortable' ), $otw_pc_js_version );
		}
	}
	
}

/**
 * Init admin menu
 */
if( !function_exists( 'otw_pc_init_admin_menu' ) ){
	
	function otw_pc_init_admin_menu(){
		
		global $otw_pc_plugin_url, $otw_pc_factory_object, $otw_pc_plugin_id;
		
		add_menu_page(__('Popping Content', 'otw_pc'), esc_html__('Popping Content', 'otw_pc'), 'manage_options', 'otw-pc', 'otw_pc_list', $otw_pc_plugin_url.'/images/otw-menu-icon.png');
		
		if( $otw_pc_factory_object->is_plugin_active( $otw_pc_plugin_id ) ){
			add_submenu_page( 'otw-pc', esc_html__('All Overlays', 'otw_pc'), esc_html__('All Overlays', 'otw_pc'), 'manage_options', 'otw-pc', 'otw_pc_list' );
			add_submenu_page( 'otw-pc', esc_html__('Manage Overlay', 'otw_pc'), esc_html__('Add Overlay', 'otw_pc'), 'manage_options', 'otw-pc-manage', 'otw_pc_manage' );
			add_submenu_page( __FILE__, esc_html__('Overlay action', 'otw_pc'), esc_html__('Overlay action', 'otw_pc'), 'manage_options', 'otw-pc-action', 'otw_pc_action' );
			add_submenu_page('otw-pc', esc_html__('Imported shortcodes', 'otw_pc'), esc_html__('Imported shortcodes', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes', 'otw_pc_import_shortcodes');
			add_submenu_page('otw-pc', esc_html__('Import shortcodes', 'otw_pc'), esc_html__('Import shortcodes', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes-manage', 'otw_pc_import_shortcodes_manage');
			add_submenu_page( 'otw-pc', esc_html__('Plugin Options', 'otw_pc'), esc_html__('Plugin Options', 'otw_pc'), 'manage_options', 'otw-pc-options', 'otw_pc_options' );
			$menu_hook_1 = add_submenu_page(__FILE__, esc_html__('Imported Shortcode Delete', 'otw_pc'), esc_html__('Imported Shortcode Delete', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes-delete', 'otw_pc_import_shortcodes_delete');
			$menu_hook_2 = add_submenu_page(__FILE__, esc_html__('Imported Shortcode Fields', 'otw_pc'), esc_html__('Imported Shortcode Fields', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes-fields', 'otw_pc_import_shortcodes_fields');
			$menu_hook_3 = add_submenu_page(__FILE__, esc_html__('Add Imported Shortcode Field', 'otw_pc'), esc_html__('Add Imported Shortcode Field', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes-fields-manage', 'otw_pc_import_shortcodes_fields_manage');
			$menu_hook_4 = add_submenu_page(__FILE__, esc_html__('Delete Shortcode Field', 'otw_pc'), esc_html__('Delete Imported Shortcode Field', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes-fields-delete', 'otw_pc_import_shortcodes_fields_delete');
			$menu_hook_5 = add_submenu_page(__FILE__, esc_html__('Add Imported Shortcode Field Options', 'otw_pc'), esc_html__('Add Imported Shortcode Field Options', 'otw_pc'), 'manage_options', 'otw-pc-import-shortcodes-fields-options', 'otw_pc_import_shortcodes_fields_options');
			
			add_action('load-' . $menu_hook_1, 'otw_open_pc_menu');
			add_action('load-' . $menu_hook_2, 'otw_open_pc_menu');
			add_action('load-' . $menu_hook_3, 'otw_open_pc_menu');
			add_action('load-' . $menu_hook_4, 'otw_open_pc_menu');
			add_action('load-' . $menu_hook_5, 'otw_open_pc_menu');
		}
	}
}

/**
 * Get overlays
 */
if( !function_exists( 'otw_get_overlays' ) ){
	function otw_get_overlays(){
		
		$otw_overlays = get_option( 'otw_overlays' );
		
		if( !is_array( $otw_overlays ) ){
			$otw_overlays = array();
		}
		return $otw_overlays;
	}
}

/**
 * Save overlays
 */
if( !function_exists( 'otw_save_overlays' ) ){
	function otw_save_overlays( $otw_overlays ){
		
		return update_option( 'otw_overlays', $otw_overlays );
	}
}

/**
 * Get next overlay id
 */
if( !function_exists( 'otw_get_next_overlay_id' ) ){
	function otw_get_next_overlay_id(){
		$next_id = 0;
		$existing_overlays = otw_get_overlays();
		
		if( is_array( $existing_overlays ) && count( $existing_overlays ) ){
			
			foreach( $existing_overlays as $key => $s_data ){
			
				if( preg_match( "/^otw\-overlay\-([0-9]+)$/", $key, $matches ) ){
				
					if( $matches[1] > $next_id ){
						$next_id = $matches[1];
					}
				}
			}
		}
		return $next_id + 1;
	}
}

/** calls page where to create new overlay
  *
  */
function otw_pc_manage(){
	require_once( 'otw_pc_manage.php' );
}

/** calls page where to list all overlays
  *
  */
function otw_pc_list(){
	require_once( 'otw_pc_list.php' );
}

/** plugin options
  *
  */
function otw_pc_options(){
	require_once( 'otw_pc_options.php' );
}


function otw_pc_items_by_type(){
	require_once( 'otw_pc_items_by_type.php' );
	die;
}

/** calls page where to process overlay actions
  *
  */
function otw_pc_action(){
	require_once( 'otw_pc_overlays_action.php' );
}

if( !function_exists( 'otw_pc_get_item_sort_options' ) ){
	function otw_pc_get_item_sort_options( $item_type ){
	
		$sort_options = array();
		
		switch( $item_type ){
		
			case 'page':
			case 'post':
					$sort_options['a_z'] = esc_html__( 'Alphabetically: A-Z', 'otw_pc' );
					$sort_options['z_a'] = esc_html__( 'Alphabetically: Z-A', 'otw_pc' );
					$sort_options['date_latest'] = esc_html__( 'Latest created', 'otw_pc' );
					$sort_options['date_oldest'] = esc_html__( 'Oldest created', 'otw_pc' );
					$sort_options['modified_latest'] = esc_html__( 'Latest Modified', 'otw_pc' );
					$sort_options['modified_oldest'] = esc_html__( 'Oldest Modified', 'otw_pc' );
				break;
			case 'templatehierarchy':
			case 'pagetemplate':
			case 'archive':
			case 'author_archive':
			case 'userroles':
			case 'wpmllanguages':
			case 'bbp_page':
			case 'buddypress_page':
					$sort_options['a_z'] = esc_html__( 'Alphabetically: A-Z', 'otw_pc' );
					$sort_options['z_a'] = esc_html__( 'Alphabetically: Z-A', 'otw_pc' );
				break;
			default:
					if( preg_match( "/^cpt_(.*)$/", $item_type, $matches ) ){
						$sort_options['a_z'] = esc_html__( 'Alphabetically: A-Z', 'otw_pc' );
						$sort_options['z_a'] = esc_html__( 'Alphabetically: Z-A', 'otw_pc' );
						$sort_options['date_latest'] = esc_html__( 'Latest created', 'otw_pc' );
						$sort_options['date_oldest'] = esc_html__( 'Oldest created', 'otw_pc' );
						$sort_options['modified_latest'] = esc_html__( 'Latest Modified', 'otw_pc' );
						$sort_options['modified_oldest'] = esc_html__( 'Oldest Modified', 'otw_pc' );
					}else{
						$sort_options['a_z'] = esc_html__( 'Alphabetically: A-Z', 'otw_pc' );
						$sort_options['z_a'] = esc_html__( 'Alphabetically: Z-A', 'otw_pc' );
						$sort_options['date_latest'] = esc_html__( 'Latest created', 'otw_pc' );
						$sort_options['date_oldest'] = esc_html__( 'Oldest created', 'otw_pc' );
					}
				break;
		}
		return $sort_options;
	}
}

if( !function_exists( 'otw_pc_wp_item_exclude' ) ){
	function otw_pc_wp_item_exclude( $exclude_object, $type, $overlay_data ){
		
		if( isset( $overlay_data['exclude_posts_for'] ) && isset( $overlay_data['exclude_posts_for'][ $type ] )  && strlen( trim( $overlay_data['exclude_posts_for'][ $type ] ) ) ){
			return $overlay_data['exclude_posts_for'][ $type ];
		}
		return '';
	}
}

if (!function_exists( "otw_pc_get_filtered_items" )){
	function otw_pc_get_filtered_items( $type, $filter, $overlay_id, $displayed_items = 20, $id_in_list = array(), $id_not_in_list = array(), $show = 'all', $order = 'a_z', $current_page = 0 ){
		
		global $string_filter, $id_list_filter;
		
		$string_filter = $filter;
		$id_list_filter = $id_in_list;
		$pager_data = array();
		
		switch( $type )
		{
			case 'page':
					$args = array();
					$args['post_type']      = $type;
					$args['posts_per_page'] = -1;
					if( count( $id_list_filter ) ){
						$args['post__in']       = $id_list_filter;
					}
					if( $string_filter ){
						add_filter( 'posts_where', 'otw_pc_post_by_title' );
					}
					
					if( otw_pc_installed_plugin( 'buddypress' ) ){
						
						global $bp;
						
						if( isset( $bp->pages->activity ) && $bp->pages->activity->id ){
							$id_not_in_list[] = $bp->pages->activity->id;
						}
						if( isset( $bp->pages->members ) && $bp->pages->members->id ){
							$id_not_in_list[] = $bp->pages->members->id;
						}
					}
					
					if( count( $id_not_in_list ) ){
						$args['post__not_in'] = $id_not_in_list;
					}
					
					$the_query = new WP_Query( $args );
					
					$all_items = count( $the_query->posts );
					
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$args['offset'] = $pager_data['first'];
					$args['posts_per_page'] = ($displayed_items)?$displayed_items:-1;
					
					switch( $order )
					{
						case 'a_z':
								$args['orderby']        = 'title';
								$args['order']          = 'ASC';
							break;
						case 'z_a':
								$args['orderby']        = 'title';
								$args['order']          = 'DESC';
							break;
						case 'date_latest':
								$args['orderby']        = 'date';
								$args['order']          = 'DESC';
							break;
						case 'date_oldest':
								$args['orderby']        = 'date';
								$args['order']          = 'ASC';
							break;
						case 'modified_latest':
								$args['orderby']        = 'modified';
								$args['order']          = 'DESC';
							break;
						case 'modified_oldest':
								$args['orderby']        = 'modified';
								$args['order']          = 'ASC';
							break;
						default:
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
					}
					
					$the_query = new WP_Query( $args );
					
					if( $string_filter ){
						remove_filter('posts_where', 'otw_pc_post_by_title');
					}
					
					return array( $all_items, $the_query->posts, $pager_data );
				break;
			case 'post':
					$args = array();
					$args['post_type']      = $type;
					$args['posts_per_page'] = -1;
					if( count( $id_list_filter ) ){
						$args['post__in']       = $id_list_filter;
					}
					if( $string_filter ){
						add_filter( 'posts_where', 'otw_pc_post_by_title' );
					}
					
					if( count( $id_not_in_list ) ){
						$args['post__not_in'] = $id_not_in_list;
					}
					
					$the_query = new WP_Query( $args );
					
					$all_items = count( $the_query->posts );
					
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$args['offset'] = $pager_data['first'];
					$args['posts_per_page'] = ($displayed_items)?$displayed_items:-1;
					
					switch( $order )
					{
						case 'a_z':
								$args['orderby']        = 'title';
								$args['order']          = 'ASC';
							break;
						case 'z_a':
								$args['orderby']        = 'title';
								$args['order']          = 'DESC';
							break;
						case 'date_latest':
								$args['orderby']        = 'date';
								$args['order']          = 'DESC';
							break;
						case 'date_oldest':
								$args['orderby']        = 'date';
								$args['order']          = 'ASC';
							break;
						case 'modified_latest':
								$args['orderby']        = 'modified';
								$args['order']          = 'DESC';
							break;
						case 'modified_oldest':
								$args['orderby']        = 'modified';
								$args['order']          = 'ASC';
							break;
						default:
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
					}
					
					$the_query = new WP_Query( $args );
					
					if( $string_filter ){
						remove_filter('posts_where', 'otw_pc_post_by_title');
					}
					
					return array( $all_items, $the_query->posts, $pager_data );
				break;
			case 'category':
			case 'postsincategory':
					//first get all
					$args = array();
					$args['type']            = 'post';
					$args['hide_empty']      = 0;
					$args['number']          = 0;
					
					if( count( $id_list_filter ) ){
						sort( $id_list_filter );
						$args['include']  = $id_list_filter;
					}
					
					if( $string_filter ){
						$args['search'] = $string_filter;
					}
					
					if( count( $id_not_in_list ) ){
						sort( $id_not_in_list );
						$args['exclude'] = $id_not_in_list;
					}
					
					$all_items = count( get_categories( $args ) );
					
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$args['offset'] = $pager_data['first'];
					$args['number']          = ($displayed_items)?$displayed_items:0;
					
					switch( $order )
					{
						case 'a_z':
								$args['orderby']        = 'name';
								$args['order']          = 'ASC';
							break;
						case 'z_a':
								$args['orderby']        = 'name';
								$args['order']          = 'DESC';
							break;
						case 'date_latest':
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
						case 'date_oldest':
								$args['orderby']        = 'ID';
								$args['order']          = 'ASC';
							break;
						default:
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
					}
					return array( $all_items, get_categories( $args ), $pager_data );
				break;
			case 'posttag':
			case 'postsintag':
					$args = array();
					$args['hide_empty']      = 0;
					$args['number']          = 0;
					
					if( count( $id_list_filter ) ){
						sort( $id_list_filter );
						$args['include']  = $id_list_filter;
					}
					
					if( $string_filter ){
						$args['search'] = $string_filter;
					}
					
					if( count( $id_not_in_list ) ){
						sort( $id_not_in_list );
						$args['exclude'] = $id_not_in_list;
					}
					
					$all_items = count( get_terms( 'post_tag', $args ) );
					
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$args['offset'] 	 = $pager_data['first'];
					$args['number']          = ($displayed_items)?$displayed_items:0;
					
					switch( $order )
					{
						case 'a_z':
								$args['orderby']        = 'name';
								$args['order']          = 'ASC';
							break;
						case 'z_a':
								$args['orderby']        = 'name';
								$args['order']          = 'DESC';
							break;
						case 'date_latest':
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
						case 'date_oldest':
								$args['orderby']        = 'ID';
								$args['order']          = 'ASC';
							break;
						default:
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
					}
					return array( $all_items, get_terms( 'post_tag', $args ), $pager_data );
				break;
			case 'author_archive':
					$args = array();
					$args['number']          = 0;
					
					if( count( $id_list_filter ) ){
						sort( $id_list_filter );
						$args['include']  = $id_list_filter;
					}
					
					if( $string_filter ){
						$args['search'] = '*'.$string_filter.'*';
					}
					
					if( count( $id_not_in_list ) ){
						sort( $id_not_in_list );
						$args['exclude'] = $id_not_in_list;
					}
					
					$all_items = count( get_users( $args ) );
					
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$args['offset'] 	 = $pager_data['first'];
					$args['number']          = ($displayed_items)?$displayed_items:0;
					
					switch( $order )
					{
						case 'a_z':
								$args['orderby']        = 'login';
								$args['order']          = 'ASC';
							break;
						case 'z_a':
								$args['orderby']        = 'login';
								$args['order']          = 'DESC';
							break;
						case 'date_latest':
								$args['orderby']        = 'registered';
								$args['order']          = 'DESC';
							break;
						case 'date_oldest':
								$args['orderby']        = 'registered';
								$args['order']          = 'ASC';
							break;
						default:
								$args['orderby']        = 'ID';
								$args['order']          = 'DESC';
							break;
					}
					
					return array( $all_items, get_users( $args ), $pager_data );
				break;
			case 'customposttype':
			case 'templatehierarchy':
			case 'archive':
					$all_items = otw_pc_get_wp_items( $type );
					$items = array();
					foreach( $all_items as $item_key => $item_object ){
					
						if( $string_filter ){
							if( ( stripos( $item_object->name, $string_filter ) === false ) ){
								continue;
							}
						}
						
						if( count( $id_list_filter ) && !in_array( $item_object->ID, $id_list_filter ) && !in_array( 'all', $id_list_filter ) ){
							continue;
						}
						if( count( $id_not_in_list ) && ( in_array( $item_object->ID, $id_not_in_list ) || in_array( 'all', $id_not_in_list ) ) ){
							continue;
						}
						$items[] = $item_object;
					}
					$all_items = count( $items );
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$sort_args = array();
					switch( $order )
					{
						case 'a_z':
								$sort_args['name'] = 'ASC';
							break;
						case 'z_a':
								$sort_args['name'] = 'DESC';
							break;
						default:
								$sort_args['name'] = 'ASC';
							break;
					}
					
					if( count( $items ) ){
						
						$items = otw_pc_asort( $items, $sort_args );
						if( $displayed_items ){
							$items = array_slice( $items, $pager_data['first'], $displayed_items );
						}
					}
					
					return array( $all_items, $items, $pager_data );
				break;
			case 'pagetemplate':
					$all_items = otw_pc_get_wp_items( $type );
					$items = array();
					foreach( $all_items as $item_key => $item_object ){
					
						if( $string_filter ){
							if( ( stripos( $item_object->name, $string_filter ) === false ) ){
								continue;
							}
						}
						if( count( $id_list_filter ) && !in_array( $item_object->script, $id_list_filter ) && !in_array( 'all', $id_list_filter ) ){
							continue;
						}
						if( count( $id_not_in_list ) && ( in_array( $item_object->script, $id_not_in_list ) || in_array( 'all', $id_not_in_list ) ) ){
							continue;
						}
						$items[] = $item_object;
					}
					$all_items = count( $items );
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					$sort_args = array();
					switch( $order )
					{
						case 'a_z':
								$sort_args['name'] = 'ASC';
							break;
						case 'z_a':
								$sort_args['name'] = 'DESC';
							break;
						default:
								$sort_args['name'] = 'ASC';
							break;
					}
					
					if( count( $items ) ){
						
						$items = otw_asort( $items, $sort_args );
						if( $displayed_items ){
							$items = array_slice( $items, $pager_data['first'], $displayed_items );
						}
					}
					
					return array( $all_items, $items, $pager_data );
				break;
			case 'userroles':
					$items = array();
					$wp_roles = new WP_Roles;
					$all_items = $wp_roles->get_names();
					$all_items['notlogged'] = esc_html__( 'Not Logged in', 'otw_pc' );
					
					foreach( $all_items as $u_role_code => $u_role_name ){
						
						if( $string_filter ){
							
							if( ( stripos( $u_role_name, $string_filter ) === false ) ){
								continue;
							}
						}
						
						
						$item = new stdClass();
						$item->ID = $u_role_code;
						if( $u_role_code != 'notlogged' ){
							$item->name = esc_html__( 'Logged in as ', 'otw_pc' ).$u_role_name;
						}else{
							$item->name = $u_role_name;
						}
						
						if( count( $id_list_filter ) && !in_array( $item->ID, $id_list_filter ) && !in_array( 'all', $id_list_filter ) ){
							continue;
						}
						if( count( $id_not_in_list ) && ( in_array( $item->ID, $id_not_in_list ) || in_array( 'all', $id_not_in_list ) ) ){
							continue;
						}
						
						$items[] = $item;
						
					}
					$all_items = count( $items );
					$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
					
					switch( $order )
					{
						case 'a_z':
								$sort_args['name'] = 'ASC';
							break;
						case 'z_a':
								$sort_args['name'] = 'DESC';
							break;
						default:
								$sort_args['name'] = 'ASC';
							break;
					}
					
					if( count( $items ) ){
						
						$items = otw_pc_asort( $items, $sort_args );
						if( $displayed_items ){
							$items = array_slice( $items, $pager_data['first'], $displayed_items );
						}
					}
					
					return array( $all_items, $items, $pager_data );
				break;
			case 'wpmllanguages':
					if( otw_pc_installed_plugin( 'wpml' ) ){
						
						$wpml_languages = icl_get_languages( 'skip_missing=0' );
						
						$all_items = count( $wpml_languages );
						
						$items = array();
						foreach( $wpml_languages as $wpml_lang ){
							
							if( $string_filter ){
								
								if( ( stripos( $wpml_lang['translated_name'], $string_filter ) === false ) && ( stripos( $wpml_lang['translated_name'], $string_filter ) === false ) ){
									continue;
								}
							}
							
							$item = new stdClass();
							$item->ID = $wpml_lang['language_code'];
							$item->name = '<img src="'.esc_attr( $wpml_lang['country_flag_url'] ).'" alt="'.esc_attr( $wpml_lang['language_code'] ).'" border="0"/>&nbsp;'.$wpml_lang['native_name'];
							
							if( count( $id_list_filter ) && !in_array( $item->ID, $id_list_filter ) && !in_array( 'all', $id_list_filter ) ){
								continue;
							}
							if( count( $id_not_in_list ) && ( in_array( $item->ID, $id_not_in_list ) || in_array( 'all', $id_not_in_list ) ) ){
								continue;
							}
							
							$items[] = $item;
						}
						
						$all_items = count( $items );
						$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
						
						switch( $order )
						{
							case 'a_z':
									$sort_args['name'] = 'ASC';
								break;
							case 'z_a':
									$sort_args['name'] = 'DESC';
								break;
							default:
									$sort_args['name'] = 'ASC';
								break;
						}
						
						if( count( $items ) ){
							
							$items = otw_pc_asort( $items, $sort_args );
							if( $displayed_items ){
								$items = array_slice( $items, $pager_data['first'], $displayed_items );
							}
						}
						return array( $all_items, $items, $pager_data );
					}
				break;
			case 'bbp_page':
					if( otw_pc_installed_plugin( 'bbpress' ) ){
						
						$bbp_pages = array();
						
						$bbp_pages[] = array( 'id' => 'forums', 'name' => esc_html__( 'Forums', 'otw_pc' ) );
						$bbp_pages[] = array( 'id' => 'noreplies', 'name' => esc_html__( 'Topics no reply', 'otw_pc' ) );
						$bbp_pages[] = array( 'id' => 'mostpopular', 'name' => esc_html__( 'Topics popular', 'otw_pc' ) );
						$bbp_pages[] = array( 'id' => 'search', 'name' => esc_html__( 'Search', 'otw_pc' ) );
						$bbp_pages[] = array( 'id' => 'singleuser', 'name' => esc_html__( 'User pages', 'otw_pc' ) );
						
						$all_items = count( $bbp_pages );
						
						$items = array();
						foreach( $bbp_pages as $bbp_page ){
							
							if( $string_filter ){
								
								if( stripos( $bbp_page['name'], $string_filter ) === false ){
									continue;
								}
							}
							
							$item = new stdClass();
							$item->ID = $bbp_page['id'];
							$item->name = $bbp_page['name'];
							
							if( count( $id_list_filter ) && !in_array( $item->ID, $id_list_filter ) && !in_array( 'all', $id_list_filter ) ){
								continue;
							}
							if( count( $id_not_in_list ) && ( in_array( $item->ID, $id_not_in_list ) || in_array( 'all', $id_not_in_list ) ) ){
								continue;
							}
							
							$items[] = $item;
						}
						
						$all_items = count( $items );
						$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
						
						switch( $order )
						{
							case 'a_z':
									$sort_args['name'] = 'ASC';
								break;
							case 'z_a':
									$sort_args['name'] = 'DESC';
								break;
							default:
									$sort_args['name'] = 'ASC';
								break;
						}
						
						if( count( $items ) ){
							
							$items = otw_pc_asort( $items, $sort_args );
							if( $displayed_items ){
								$items = array_slice( $items, $pager_data['first'], $displayed_items );
							}
						}
						
						return array( $all_items, $items, $pager_data );
					}
				break;
			case 'buddypress_page':
					if( otw_pc_installed_plugin( 'buddypress' ) ){
						global $bp;
						$buddypress_pages = array();
						
						if( isset( $bp->pages->activity ) && $bp->pages->activity->id ){
							$buddypress_pages[] = array( 'id' => $bp->pages->activity->id, 'name' => $bp->pages->activity->title.' '.__( 'page', 'otw_pc' ) );
						}
						if( isset( $bp->pages->members ) && $bp->pages->members->id ){
							$buddypress_pages[] = array( 'id' => $bp->pages->members->id, 'name' => $bp->pages->members->title.' '.__( 'pages', 'otw_pc' ) );
						}
						
						$all_items = count( $buddypress_pages );
						
						$items = array();
						foreach( $buddypress_pages as $buddypress_page ){
							
							if( $string_filter ){
								
								if( stripos( $buddypress_page['name'], $string_filter ) === false ){
									continue;
								}
							}
							
							$item = new stdClass();
							$item->ID = $buddypress_page['id'];
							$item->name = $buddypress_page['name'];
							
							if( count( $id_list_filter ) && !in_array( $item->ID, $id_list_filter ) && !in_array( 'all', $id_list_filter ) ){
								continue;
							}
							if( count( $id_not_in_list ) && ( in_array( $item->ID, $id_not_in_list ) || in_array( 'all', $id_not_in_list ) ) ){
								continue;
							}
							
							$items[] = $item;
						}
						
						$all_items = count( $items );
						$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
						
						switch( $order )
						{
							case 'a_z':
									$sort_args['name'] = 'ASC';
								break;
							case 'z_a':
									$sort_args['name'] = 'DESC';
								break;
							default:
									$sort_args['name'] = 'ASC';
								break;
						}
						
						if( count( $items ) ){
							
							$items = otw_pc_asort( $items, $sort_args );
							if( $displayed_items ){
								$items = array_slice( $items, $pager_data['first'], $displayed_items );
							}
						}
						
						return array( $all_items, $items, $pager_data );
					}
					
				break;
			default:
					
					if( preg_match( "/^cpt_(.*)$/", $type, $matches ) ){
						
						$args = array();
						$args['post_type']      = $matches[1];
						$args['posts_per_page'] = -1;
						
						if( count( $id_list_filter ) ){
							$args['post__in']       = $id_list_filter;
						}
						
						if( $string_filter ){
							add_filter( 'posts_where', 'otw_pc_post_by_title' );
						}
						
						if( count( $id_not_in_list ) ){
							$args['post__not_in'] = $id_not_in_list;
						}
						
						$the_query = new WP_Query( $args );
						
						$all_items = count( $the_query->posts );
						
						$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
						
						$args['posts_per_page'] = ($displayed_items)?$displayed_items:-1;
						
						switch( $order )
						{
							case 'a_z':
									$args['orderby']        = 'title';
									$args['order']          = 'ASC';
								break;
							case 'z_a':
									$args['orderby']        = 'title';
									$args['order']          = 'DESC';
								break;
							case 'date_latest':
									$args['orderby']        = 'date';
									$args['order']          = 'DESC';
								break;
							case 'date_oldest':
									$args['orderby']        = 'date';
									$args['order']          = 'ASC';
								break;
							case 'modified_latest':
									$args['orderby']        = 'modified';
									$args['order']          = 'DESC';
								break;
							case 'modified_oldest':
									$args['orderby']        = 'modified';
									$args['order']          = 'ASC';
								break;
								
							default:
									$args['orderby']        = 'ID';
									$args['order']          = 'DESC';
								break;
						}
						
						$the_query = new WP_Query( $args );
						
						if( $string_filter ){
							remove_filter('posts_where', 'otw_pc_post_by_title');
						}
						
						return array( $all_items, $the_query->posts, $pager_data );
					}elseif( preg_match( "/^ctx_(.*)$/", $type, $matches ) ){
						
						$args = array();
						$args['hide_empty']      = 0;
						$args['number']          = 0;
						
						if( count( $id_list_filter ) ){
							sort( $id_list_filter );
							$args['include']  = $id_list_filter;
						}
						
						if( $string_filter ){
							$args['search'] = $string_filter;
						}
						
						if( count( $id_not_in_list ) ){
							sort( $id_not_in_list );
							$args['exclude'] = $id_not_in_list;
						}
						
						$all_items = count( get_terms( $matches[1], $args ) );
						
						$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
						
						$args['offset'] = $pager_data['first'];
						$args['number']          = ($displayed_items)?$displayed_items:0;
						
						switch( $order )
						{
							case 'a_z':
									$args['orderby']        = 'name';
									$args['order']          = 'ASC';
								break;
							case 'z_a':
									$args['orderby']        = 'name';
									$args['order']          = 'DESC';
								break;
							case 'date_latest':
									$args['orderby']        = 'ID';
									$args['order']          = 'DESC';
								break;
							case 'date_oldest':
									$args['orderby']        = 'ID';
									$args['order']          = 'ASC';
								break;
							default:
									$args['orderby']        = 'ID';
									$args['order']          = 'DESC';
								break;
						}
						
						return array( $all_items, get_terms( $matches[1], $args ), $pager_data );
					}elseif( preg_match( "/(.*)_in_ctx_(.*)$/", $type, $matches ) ){
						
						$args = array();
						$args['hide_empty']      = 0;
						$args['number']          = 0;
						
						if( count( $id_list_filter ) ){
							sort( $id_list_filter );
							$args['include']  = $id_list_filter;
						}
						
						if( $string_filter ){
							$args['search'] = $string_filter;
						}
						
						if( count( $id_not_in_list ) ){
							sort( $id_not_in_list );
							$args['exclude'] = $id_not_in_list;
						}
						
						$all_items = count( get_terms( $matches[2], $args ) );
						
						$pager_data = otw_pc_get_pager_data( $all_items, $displayed_items, $current_page );
						
						$args['offset'] = $pager_data['first'];
						$args['number']          = ($displayed_items)?$displayed_items:0;
						
						switch( $order )
						{
							case 'a_z':
									$args['orderby']        = 'name';
									$args['order']          = 'ASC';
								break;
							case 'z_a':
									$args['orderby']        = 'name';
									$args['order']          = 'DESC';
								break;
							case 'date_latest':
									$args['orderby']        = 'ID';
									$args['order']          = 'DESC';
								break;
							case 'date_oldest':
									$args['orderby']        = 'ID';
									$args['order']          = 'ASC';
								break;
							default:
									$args['orderby']        = 'ID';
									$args['order']          = 'DESC';
								break;
						}
						return array( $all_items, get_terms( $matches[2], $args ), $pager_data );
					}
				break;
		}
		
		return array();
	}
}

/** get wp items based on type
  * @param string
  * @return array
  */
if( !function_exists( 'otw_pc_get_wp_items' ) ){
	function otw_pc_get_wp_items( $item_type ){
		switch( $item_type ){
			case 'page':
					$pages = get_pages();
					$pages = otw_group_items( $pages, 'ID', 'post_parent', 0 );
					return $pages;
				break;
			case 'post':
					return get_posts( array( 'numberposts' => -1 )  );
				break;
			case 'postsincategory':
					$categories = get_categories(array('hide_empty' => 0));
					$categories = otw_group_items( $categories, 'cat_ID', 'parent', 0 );
					return $categories;
				break;
			case 'postsintag':
					return get_terms( 'post_tag', '&orderby=name&hide_empty=0' );
				break;
			case 'category':
					$categories = get_categories(array('hide_empty' => 0));
					$categories = otw_group_items( $categories, 'cat_ID', 'parent', 0 );
					
					return $categories;
				break;
			case 'posttag':
					return get_terms( 'post_tag', '&orderby=name&hide_empty=0' );
				break;
			case 'pagetemplate':
					$templates = array();
					$all_templates = get_page_templates();
					
					if( is_array( $all_templates ) && count( $all_templates ) )
					{
						foreach( $all_templates as $page_template_name => $page_template_script )
						{
							$tplObject = new stdClass();
							$tplObject->name = $page_template_name;
							$tplObject->script = $page_template_script;
							$templates[] = $tplObject;
						}
					}
					return $templates;
				break;
			case 'archive':
					$archive_types = array();
					$a_types = array( 'daily' => esc_html__('Daily', 'otw_pc'), 'monthly' => esc_html__('Monthly', 'otw_pc'), 'yearly' => esc_html__('Yearly', 'otw_pc') );

					foreach( $a_types as $a_type => $a_name )
					{
						$aObject = new stdClass();
						$aObject->ID = $a_type;
						$aObject->name = $a_name;
						$archive_types[] = $aObject;
					}
					return $archive_types;
				break;
			case 'customposttype':
					return get_post_types( array(  'public'   => true, '_builtin' => false ), 'object' );
				break;
			case 'templatehierarchy':
					$h_types = array();
					$a_types = array(
							'home'        =>    esc_html__('Home', 'otw_pc'),
							'front'       =>    esc_html__('Front Page', 'otw_pc'),
							'404'         =>    esc_html__('Error 404 Page', 'otw_pc'),
							'search'      =>    esc_html__('Search', 'otw_pc'),
							'date'        =>    esc_html__('Date', 'otw_pc'),
							'author'      =>    esc_html__('Author', 'otw_pc'),
							'category'    =>    esc_html__('Category', 'otw_pc'),
							'tag'         =>    esc_html__('Tag', 'otw_pc'),
							'taxonomy'    =>    esc_html__('Taxonomy', 'otw_pc'),
							'archive'     =>    esc_html__('Archive', 'otw_pc'),
							'single'      =>    esc_html__('Singular', 'otw_pc'),
							'attachment'  =>    esc_html__('Attachment', 'otw_pc'),
							'page'        =>    esc_html__('Page', 'otw_pc')
						);

					foreach( $a_types as $a_type => $a_name )
					{
						$aObject = new stdClass();
						$aObject->ID = $a_type;
						$aObject->name = $a_name;
						$h_types[] = $aObject;
					}
					return $h_types;
				break;
			default:
					if( preg_match( "/^cpt_(.*)$/", $item_type, $matches ) ){
						return get_posts( array( 'post_type' =>  $matches[1], 'numberposts' => -1 )  );
					}elseif( preg_match( "/^ctx_(.*)$/", $item_type, $matches ) ){
						return get_terms( $matches[1], '&orderby=name&hide_empty=0' );
					}
				break;
		}
	}
}

/**
 * Build pager data
 *
 * @param integer total items
 * @param integer total items returned for with limit
 * @param integer limit
 * @param integer current page
 * @return array
 */
if( !function_exists( 'otw_pc_get_pager_data' ) ){
	function otw_pc_get_pager_data( $total_items, $items_limit, $current_page  ){
		$pager_data = array();
		
		$pager_data['current'] = $current_page;
		$pager_data['links'] = array();
		$pager_data['links']['next'] = false;
		$pager_data['links']['prev'] = false;
		$pager_data['links']['first']= false;
		$pager_data['links']['last'] = false;
		$pager_data['links']['page'] = array();
		$pager_data['first'] = 0;
		
		if( $items_limit ){
			
			if( ( $total_items %  $items_limit ) == 0 ){
				$pager_data['pages'] = $total_items / $items_limit;
			}else{
				$pager_data['pages'] = $total_items / $items_limit;
				$pager_data['pages'] = (int)$pager_data['pages'] + 1;
			}
			
			if( $pager_data['current'] >= $pager_data['pages'] ){
				$pager_data['current'] = 0;
			}
			
			$pager_data['first'] = $pager_data['current'] * $items_limit;
			$pager_data['last']  = $pager_data['first'] + $items_limit - 1;
			
			if( $pager_data['pages'] > 1 ){
				
				if( $pager_data['current'] < ( $pager_data['pages'] - 1 ) ){
					$pager_data['links']['next'] = $pager_data['current'] + 1;
					$pager_data['links']['last'] = ( $pager_data['pages'] - 1 );
				}
			}
			if( $pager_data['current'] > 0 ){
				$pager_data['links']['first'] = 0;
				$pager_data['links']['prev'] = $pager_data['current'] - 1;
			}
			
			$l_size = 3;
			if( $pager_data['pages'] > 1 ){
				$pager_data['links']['page'][] = $pager_data['current'];
				//build page numbe links
				for( $cP = 1; $cP <= $l_size; $cP++ ){
					
					if( ( $pager_data['current'] - $cP ) >= 0 ){
						$pager_data['links']['page'][] = $pager_data['current'] - $cP;
					}elseif( ( $pager_data['current'] + $l_size + $cP ) < $pager_data['pages'] ){
						$pager_data['links']['page'][] = $pager_data['current'] + $l_size + $cP;
					}
					
					if( ( $pager_data['current'] + $cP ) < $pager_data['pages'] ){
						$pager_data['links']['page'][] = $pager_data['current'] + $cP;
					}elseif( ( $pager_data['current'] - $l_size - $cP ) >= 0 ){
						$pager_data['links']['page'][] = $pager_data['current'] - $l_size - $cP;
					}
				}
				sort( $pager_data['links']['page'] );
			}
		}
		return $pager_data;
	}
}

/**
 * Array sort
 */
if( !function_exists( 'otw_pc_asort' ) ){
	function otw_pc_asort( $array, $settings ){
		
		global $otw_pc_asort_fields;
		
		$otw_pc_asort_fields = $settings;
		uasort( $array, 'otw_pc_asort_compare' );
		
		return $array;
	}
}
if( !function_exists( 'otw_pc_asort_compare' ) ){
	function otw_pc_asort_compare( $item_1, $item_2 ){
		
		global $otw_pc_asort_fields;
		
		foreach( $otw_pc_asort_fields as $field => $order ){
		
			switch( strtolower( gettype( $item_1 ) ) ){
				
				case 'object':
						if( isset( $item_1->$field ) && isset( $item_2->$field ) ){
							
							$s_result = strnatcmp( $item_1->$field, $item_2->$field );
							
							if( $s_result > 0 ){
								return ( $order == "ASC" ) ? 1 : -1;
							}elseif( $s_result < 0 ){
								return ( $order == "ASC" ) ? -1 : 1;
							}
							
						}elseif( isset( $item_1->$field ) && !isset( $item_2->$field ) ){
							
							return ( $order == "ASC" ) ? 1 : -1;
							
						}elseif( !isset( $item_1->$field ) && isset( $item_2->$field ) ){
							
							return ( $order == "ASC" ) ? -1 : 1;
							
						}
					break;
			}
		}
		return 0;
	}
}
if (!function_exists( "otw_overlay_item_attributes" )){
	function otw_overlay_item_attributes( $tag, $item_type, $item_id, $overlay_data, $item_data ){
		
		$attributes = '';
		
		switch( $tag ){
			case 'p':
					$attributes_array = array();
					if( otw_post('otw_action',false) ){
						
						if( otw_post( array( 'otw_sbi_'.$item_type, $item_id ), false ) || otw_post( array( 'otw_sbi_'.$item_type, 'all' ), false ) ){
							$attributes_array['class'][] = 'sitem_selected';
						}else{
							$attributes_array['class'][] = 'sitem_notselected';
						}
					}else{
						if( isset( $overlay_data['validfor'][ $item_type ]['all'] ) ){
							$attributes_array['class'][] = 'sitem_selected';
						}elseif( isset( $overlay_data['validfor'][ $item_type ][ $item_id ] ) ){
							$attributes_array['class'][] = 'sitem_selected';
						}else{
							$attributes_array['class'][] = 'sitem_notselected';
						}
					}
					if( isset( $attributes_array['class'] ) ){
						$attributes .= ' class="'.implode( ' ', $attributes_array['class'] ).'"';
					}
				break;
			case 'c':
					if( otw_post('otw_action',false) ){
						if( otw_post( array( 'otw_sbi_'.$item_type, $item_id ), false ) || otw_post( array( 'otw_sbi_'.$item_type, 'all' ), false ) ){
							$attributes .= ' checked="checked"';
						}
					}else{
						if( isset( $overlay_data['validfor'][ $item_type ]['all'] ) ){
							$attributes .= ' checked="checked"';
						}elseif( isset( $overlay_data['validfor'][ $item_type ][ $item_id ] ) ){
							$attributes .= ' checked="checked"';
						}
					}
				break;
			case 'ap':
					if( otw_post('otw_action',false) ){
						if( otw_post( array( 'otw_sbi_'.$item_type, $item_id ), false ) ){
							$attributes .= ' class="all sitem_selected"';
						}else{
							$attributes .= ' class="all sitem_notselected"';
						}
					}else{
						if( isset( $overlay_data['validfor'][ $item_type ][ $item_id ] ) ){
							$attributes .= ' class="all sitem_selected"';
						}else{
							$attributes .= ' class="all sitem_notselected"';
						}
					}
				break;
			case 'ac':
					if( otw_post('otw_action',false) ){
						if( otw_post( array( 'otw_sbi_'.$item_type, $item_id ), false ) ){
							$attributes .= ' checked="checked"';
						}
					}else{
						if( isset( $overlay_data['validfor'][ $item_type ][ $item_id ] ) ){
							$attributes .= ' checked="checked"';
						}
					}
				break;
			case 'l':
					if( isset( $item_data->_sub_level ) && $item_data->_sub_level ){
						$attributes .= ' style="margin-left: '.( $item_data->_sub_level * 20 ).'px"';
					}
				break;
		}
		echo $attributes;
	}
}

/** get the attribute of wp item
  *  @param string
  *  @param stdClass
  *  @return string
  */
if( !function_exists( 'otw_pc_wp_item_attribute' ) ){
	function otw_pc_wp_item_attribute( $item_type, $attribute, $object ){
		
		switch( $attribute ){
			
			case 'ID':
					switch( $item_type ){
						case 'postsincategory':
								return $object->cat_ID;
							break;
						case 'category':
								return $object->cat_ID;
							break;
						case 'postsintag':
								return $object->term_id;
							break;
						case 'posttag':
								return $object->term_id;
							break;
						case 'pagetemplate':
								return $object->script;
							break;
						case 'customposttype':
								return $object->name;
							break;
						case 'author_archive':
								return $object->ID;
							break;
						default:
								if( preg_match( "/^ctx_(.*)$/", $item_type, $matches ) ){
									return $object->term_id;
								}elseif( preg_match( "/^(.*)_in_ctx_(.*)$/", $item_type, $matches ) ){
									return $object->term_id;
								}
								return $object->ID;
							break;
					}
				break;
			case 'TITLE':
					switch( $item_type ){
						case 'page':
						case 'post':
								return $object->post_title;
							break;
						case 'author_archive':
								return $object->display_name;
							break;
						case 'customposttype':
								return $object->label;
							break;
						default:
								if( preg_match( "/^cpt_(.*)$/", $item_type, $matches ) ){
									return $object->post_title;
								}
								return $object->name;
							break;
					}
				break;
		}
	}
}

/**
 * Check if external plugin is installed
 *
 * @param string - plugin name
 * @return boolean
 */
if( !function_exists( 'otw_pc_installed_plugin' ) ){
	function otw_pc_installed_plugin( $plugin_name ){
		
		$installed = false;
		switch( $plugin_name ){
			case 'bbpress':
					if(function_exists( 'bbp_get_db_version_raw') && bbp_get_db_version_raw() ){
						$installed = true;
					}
				break;
			case 'wpml':
					if( function_exists( 'icl_get_languages' ) ){
						$installed = true;
					}
				break;
			case 'buddypress':
					if( class_exists( 'BuddyPress' ) ){
						
						global $bp;
						
						if( strtolower( get_class( $bp ) ) == 'buddypress' )
						{
							$installed = true;
						}
					}
				break;
		}
		
		return $installed;
	}
}

if (!function_exists( "otw_pc_post_by_title" )){
	function otw_pc_post_by_title( $query ){
		
		global $string_filter, $id_list_filter;
		
		$query .= " AND post_title LIKE '%".$string_filter."%'";
		return $query;
	}
}

if( !function_exists( 'otw_pc_admin_settings' ) ){
	function otw_pc_admin_settings(){
		
		$otw_admin_settings = get_option( 'otw_admin_settings' );
		
		if( !is_array( $otw_admin_settings ) ){
			$otw_admin_settings = array();
		}
		
		if( otw_post( 'type', '' ) ){
		
			switch( otw_post( 'type', '' ) ){
				
				case 'page':
						if( otw_post( 'page', false ) ){
						
							switch( otw_post( 'page', '' ) ){
							
								case 'otw-pc-manage':
										if( otw_post( 'setting', false ) && strlen( trim( otw_post( 'setting', '' ) ) ) && otw_post( 'value', false ) && strlen( trim( otw_post( 'value', '' ) ) ) ){
											
											if( !isset( $otw_admin_settings['page'] ) ){
												$otw_admin_settings['page'] = array();
											}
											
											if( !isset( $otw_admin_settings['page'][ otw_post( 'page', '' ) ] ) ){
												$otw_admin_settings['page'][ otw_post( 'page', '' ) ] = array();
											}
											$otw_admin_settings['page'][ otw_post( 'page', '' ) ][ otw_post( 'setting', '' ) ] = otw_post( 'value', '' );
											
											update_option( 'otw_admin_settings', $otw_admin_settings );
										}
									break;
							}
						
						}
					break;
			}
		}
		die;
	}
}

/**
 * Edit imported shortcodes page
 */
if (!function_exists('otw_pc_import_shortcodes_manage') ){
	
	function otw_pc_import_shortcodes_manage(){
		require_once( 'otw_pc_import_shortcodes_manage.php' );
	}
}

/**
 * Delete imported shortcodes page
 */
if (!function_exists('otw_pc_import_shortcodes_delete')){
	function otw_pc_import_shortcodes_delete(){
		require_once( 'otw_pc_import_shortcodes_delete.php' );
	}
}

/**
 * Imported shortcodes page
 */
if (!function_exists('otw_pc_import_shortcodes')) {
	function otw_pc_import_shortcodes() {
		require_once( 'otw_pc_import_shortcodes.php' );
	}
}

/**
 * Edit Imported shortcodes fields page
 */
if (!function_exists('otw_pc_import_shortcodes_fields')) {

    function otw_pc_import_shortcodes_fields() {
        require_once( 'otw_pc_import_shortcodes_fields.php' );
    }

}

/**
 * Delete Custm shortcodes page
 */
if (!function_exists('otw_pc_import_shortcodes_fields_delete')) {

    function otw_pc_import_shortcodes_fields_delete() {
        require_once( 'otw_pc_import_shortcodes_fields_delete.php' );
    }

}

/**
 * Imported shortcodes page
 */
if (!function_exists('otw_pc_import_shortcodes_fields_manage')) {

    function otw_pc_import_shortcodes_fields_manage() {
        require_once( 'otw_pc_import_shortcodes_fields_manage.php' );
    }

}

/**
 * Imported shortcodes field options
 */
if (!function_exists('otw_pc_import_shortcodes_fields_options')) {

    function otw_pc_import_shortcodes_fields_options() {
        require_once( 'otw_pc_import_shortcodes_fields_options.php' );
    }

}

/**
 * Add more items based on installed plugins etc.
 */
if (!function_exists('otw_pc_add_items')) {
	function otw_pc_add_items(){
		
		global $wp_pc_int_items;
		
		//wpml
		$active_plugins = get_option( 'active_plugins' );
		
		if( otw_installed_plugin( 'wpml' ) ){
			$wp_pc_int_items['wpmllanguages'] = array();
			$wp_pc_int_items['wpmllanguages'][0] = array();
			$wp_pc_int_items['wpmllanguages'][1] = esc_html__( 'WPML plugin language', 'otw_pc' );
			$wp_pc_int_items['wpmllanguages'][2] = esc_html__( 'All WPML plugin languages', 'otw_pc' );
		}
	}
}
/**
 * Keep the admin menu open
 */
if (!function_exists('otw_open_pc_menu')) {

    function otw_open_pc_menu($params) {

        global $menu;

        foreach ($menu as $key => $item) {
            if ($item[2] == 'otw-pc') {
                $menu[$key][4] = $menu[$key][4] . ' wp-has-submenu wp-has-current-submenu wp-menu-open menu-top otw-menu-open';
            }
        }
    }

}

if( !function_exists( 'otw_pc_factory_message' ) ){
	
	function otw_pc_factory_message( $params ){
		
		global $otw_pc_plugin_id;
		
		if( isset( $params['plugin'] ) && $otw_pc_plugin_id == $params['plugin'] ){
			
			//filter out some messages if need it
		}
		if( isset( $params['message'] ) )
		{
			return $params['message'];
		}
		return $params;
	}
}