<?php
global $_wp_column_headers;

$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );

if( !is_array( $otw_pc_import_shortcodes ) ){
	$otw_pc_import_shortcodes = array();
}

$_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] = array(
	'name' => esc_html__( 'Shortcode Label', 'otw_pc' ),
	'key' => esc_html__( 'Shortcode Name', 'otw_pc' )
);

$message = '';
$massages = array();
$messages[1] = esc_html__( 'Imported shortcode saved', 'otw_pc' );
$messages[2] = esc_html__( 'Imported shortcode deleted', 'otw_pc' );

if( otw_get('message',false) && isset( $messages[ otw_get('message','') ] ) ){
	$message .= $messages[ otw_get('message','') ];
}
?>
<?php if ( $message ) : ?>
<div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php endif ?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php esc_html_e('Imported Shortcodes', 'otw_pc') ?>
		<a class="button add-new-h2" href="admin.php?page=otw-pc-import-shortcodes-manage"><?php esc_html_e('Import shortcode', 'otw_pc') ?></a>
	</h2>
	
	<form class="search-form form-wrap" action="" method="get">
		<?php include_once( 'otw_pc_help.php' );?>
	</form>
	<div class="updated">
		<p><?php echo otw_esc_text( esc_html__( 'Import shortcodes from other plugins and your theme so you can use them in the Popping Content plugin interfaces.<br />For example you have a [mygallery] shortcode that generates a gallery and you want to use that gallery in a custom page layout created with the Popping Content plugin.<br />Import that shortcode so you can have it in the interface along with the other OTW shortcodes.', 'otw_pc' ), 'cont' );?></p>
	</div>
	<br class="clear" />
	<?php if( is_array( $otw_pc_import_shortcodes ) && count( $otw_pc_import_shortcodes ) ){?>
		<table class="widefat fixed" cellspacing="0">
			<thead>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $key => $name ){?>
						<th><?php echo esc_html( $name )?></th>
					<?php }?>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $key => $name ){?>
						<th><?php echo esc_html( $name )?></th>
					<?php }?>
				</tr>
			</tfoot>
			<tbody>
			<?php foreach( $otw_pc_import_shortcodes as $import_shortcode_key => $import_shortcode_item ){?>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $column_name => $column_title ){
						
						$edit_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-manage&amp;action=edit&amp;import_shortcode='.urlencode( $import_shortcode_key ) );
						$delete_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-delete&amp;import_shortcode='.urlencode( $import_shortcode_key ) );
						$fields_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields&amp;import_shortcode='.urlencode( $import_shortcode_key ) );
						
						switch($column_name) {
						
							case 'name':
								
									echo '<td><strong><a href="'.esc_attr( $edit_link ).'" title="'.esc_attr(sprintf(__('Edit &#8220;%s&#8221;', 'otw_pc'), $import_shortcode_key)).'">'.$import_shortcode_item['title'].'</a></strong><br />';
									
									echo '<div class="row-actions">';
									echo '<a href="'.esc_attr( $edit_link ).'">' . esc_html__('Edit', 'otw_pc') . '</a>';
									echo ' | <a href="'.esc_attr( $fields_link ).'">' . esc_html__('Fields', 'otw_pc'). '</a>';
									echo ' | <a href="'.esc_attr( $delete_link ).'">' . esc_html__('Delete', 'otw_pc'). '</a>';
									
									echo '</div>';
									
									echo '</td>';
								break;
							case 'key':
								
									echo '<td>'.$import_shortcode_key.'</td>';
								break;
						}
					?>
					
					<?php }?>
				</tr>
			<?php }?>
			</tbody>
		</table>
		
	<?php }else{ ?>
		<p><?php esc_html_e('No imported shortcodes found.', 'otw_pc' )?></p>
	<?php } ?>
</div>