<?php
global $validate_messages;

$page_title = esc_html__( 'Delete Imported Shortcode', 'otw_pc' );

$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );

if( !is_array( $otw_pc_import_shortcodes ) ){
	$otw_pc_import_shortcodes = array();
}

$otw_import_shortcode_values = array();
$otw_import_shortcode_values['name'] = '';
$otw_import_shortcode_values['key'] = '';

$requested_shortcode = '';
if( otw_get('import_shortcode',false) && array_key_exists( urldecode( otw_get('import_shortcode','') ), $otw_pc_import_shortcodes ) ){
	$requested_shortcode = urldecode( otw_get('import_shortcode','') );
	$otw_import_shortcode_values['key'] = urldecode( otw_get('import_shortcode','') );
	$otw_import_shortcode_values['name'] =  $otw_pc_import_shortcodes[ urldecode( otw_get('import_shortcode','') ) ]['title'];
}
else
{
	wp_die( esc_html__( 'Invalid shortcode', 'otw_pc' ) );
}
?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php echo $page_title; ?>
		<a class="button add-new-h2" href="<?php echo admin_url( 'admin.php?page=otw-pc-import-shortcodes' )?>" ><?php esc_html_e('Back To Available Imported Shortcodes', 'otw_pc')?></a>
	</h2>
	<?php if( isset( $validate_messages ) && count( $validate_messages ) ){?>
		<div id="message" class="error">
			<?php foreach( $validate_messages as $v_message ){
				echo '<p>'.$v_message.'</p>';
			}?>
		</div>
	<?php }?>
	<div class="form-wrap" id="poststuff">
		<?php include_once( 'otw_pc_help.php' );?>
		
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="delete_otw_pc_import_shortcode" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-import-shortcode-delete'); ?>
			<div id="post-body">
				<div id="post-body-content">
					<div class="form-field form-required">
						<input type="hidden" name="otw_import_shortcode_key" value="<?php echo esc_attr( $otw_import_shortcode_values['key'] )?>" />
						<p><?php esc_html_e( 'Please confirm to delete the the imported shortcode  \''.$otw_import_shortcode_values['name'].'\'.', 'otw_pc' );?></p>
					</div>
					<p class="submit">
						<input type="submit" value="<?php esc_html_e( 'Yes, delete it!', 'otw_pc') ?>" name="submit" class="button"/>
					</p>
				</div>
			</div>
		</form>
	</div>
</div>
