<?php
global $_wp_column_headers, $otw_pc_import_shortcode_field_types;

$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );
$otw_pc_import_shortcode_key = '';
$otw_pc_import_shortcode = false;

if( otw_get('import_shortcode',false) ){
	$otw_pc_import_shortcode_key = urldecode( otw_get('import_shortcode','') );
}

if( !is_array( $otw_pc_import_shortcodes ) ){
	$otw_pc_import_shortcodes = array();
}

if( isset( $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ] ) ){
	$otw_pc_import_shortcode = $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ];
}else{
	wp_die( esc_html__( 'Invalid imported shortcode', 'otw_pc' ) );
}

$_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] = array(
	'name' => esc_html__( 'Field Name', 'otw_pc' ),
	'type' => esc_html__( 'Field Type', 'otw_pc' ),
	'description' => esc_html__( 'Field Description', 'otw_pc' ),
	'default_value' => esc_html__( 'Default Value', 'otw_pc' )
);

$message = '';
$massages = array();
$messages[1] = esc_html__( 'Imported shortcode field saved', 'otw_pc' );
$messages[2] = esc_html__( 'Imported shortcode field deleted', 'otw_pc' );

if( otw_get('message',false) && isset( $messages[ otw_get('message','') ] ) ){
	$message .= $messages[ otw_get('message','') ];
}
?>
<?php if ( $message ) : ?>
<div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php endif ?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php esc_html_e('Imported Shortcodes Fields', 'otw_pc') ?>
		<a class="button add-new-h2" href="admin.php?page=otw-pc-import-shortcodes"><?php esc_html_e('Back To Shortcodes', 'otw_pc') ?></a>
		<a class="button add-new-h2" href="admin.php?page=otw-pc-import-shortcodes-fields-manage&import_shortcode=<?php echo urlencode( $otw_pc_import_shortcode_key) ?>""><?php esc_html_e('Add Shortcode Field', 'otw_pc') ?></a>
	</h2>
	<h3>
		<?php esc_html_e( 'Imported Shortcode:', 'otw_pc' )?> <?php echo $otw_pc_import_shortcode['title'];?>
	</h3>
	<form class="search-form form-wrap" action="" method="get">
		<?php include_once( 'otw_pc_help.php' );?>
	</form>
	
	<br class="clear" />
	<?php if( is_array( $otw_pc_import_shortcode['params'] ) && count( $otw_pc_import_shortcode['params'] ) ){?>
		<table class="widefat fixed" cellspacing="0">
			<thead>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $key => $name ){?>
						<th><?php echo esc_html( $name )?></th>
					<?php }?>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $key => $name ){?>
						<th><?php echo esc_html( $name )?></th>
					<?php }?>
				</tr>
			</tfoot>
			<tbody>
			<?php foreach( $otw_pc_import_shortcode['params'] as $import_shortcode_field_key => $import_shortcode_field_item ){?>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $column_name => $column_title ){
						
						$edit_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields-manage&amp;action=edit&amp;import_shortcode='.urlencode( $otw_pc_import_shortcode_key ).'&amp;import_shortcode_field='.urlencode( $import_shortcode_field_key ) );
						$delete_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields-delete&amp;import_shortcode='.urlencode( $otw_pc_import_shortcode_key ).'&amp;import_shortcode_field='.urlencode( $import_shortcode_field_key ) );
						$options_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields-options&amp;import_shortcode='.urlencode( $otw_pc_import_shortcode_key ).'&amp;import_shortcode_field='.urlencode( $import_shortcode_field_key ) );
						
						switch($column_name) {
						
							case 'name':
								
									echo '<td><strong><a href="'.esc_attr( $edit_link ).'" title="'.esc_attr(sprintf(__('Edit &#8220;%s&#8221;', 'otw_pc'), $otw_pc_import_shortcode_key)).'">'.$import_shortcode_field_item['name'].'</a></strong><br />';
									
									echo '<div class="row-actions">';
									echo '<a href="'.esc_attr( $edit_link ).'">' . esc_html__('Edit', 'otw_pc') . '</a>';
									echo ' | <a href="'.esc_attr( $delete_link ).'">' . esc_html__('Delete', 'otw_pc'). '</a>';
									
									echo '</div>';
									
									echo '</td>';
								break;
							case 'key':
									echo '<td>'.$import_shortcode_field_key.'</td>';
								break;
							case 'type':
									echo '<td>';
									
									if( isset( $otw_pc_import_shortcode_field_types[ $import_shortcode_field_item['type'] ] ) ){
										echo $otw_pc_import_shortcode_field_types[ $import_shortcode_field_item['type'] ];
										
										if( $import_shortcode_field_item['type'] == 'select' ){
											echo '<div>';
												echo '<a href="'.esc_attr( $options_link ).'">' . esc_html__('Options', 'otw_pc') . '</a>';
											echo '</div>';
										}
									}
									
									echo '</td>';
								break;
							case 'description':
									echo '<td>'.$import_shortcode_field_item['description'].'</td>';
								break;
							case 'default_value':
									echo '<td>'.$import_shortcode_field_item['default_value'].'</td>';
								break;
						}
					?>
					
					<?php }?>
				</tr>
			<?php }?>
			</tbody>
		</table>
		
	<?php }else{ ?>
		<p><?php esc_html_e('No custom fields for this shortcode found.', 'otw_pc' )?></p>
	<?php } ?>
</div>