<?php
global $validate_messages, $otw_pc_import_shortcode_field_types;

$page_title = esc_html__( 'Add Imported Shortcode Field', 'otw_pc' );

$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );

$otw_pc_import_shortcode_key = '';
$otw_pc_import_shortcode = false;

if( otw_get('import_shortcode',false) ){
	$otw_pc_import_shortcode_key = urldecode( otw_get('import_shortcode','') );
}


if( !is_array( $otw_pc_import_shortcodes ) ){
	$otw_pc_import_shortcodes = array();
}

if( isset( $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ] ) ){
	$otw_pc_import_shortcode = $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ];
}else{
	wp_die( esc_html__( 'Invalid imported shortcode', 'otw_pc' ) );
}


$otw_import_shortcode_field_values = array();
$otw_import_shortcode_field_values['key'] = '';
$otw_import_shortcode_field_values['name'] = '';
$otw_import_shortcode_field_values['description'] = '';
$otw_import_shortcode_field_values['type'] = '';
$otw_import_shortcode_field_values['default_value'] = '';
$otw_import_shortcode_field_values['options'] = '';

$requested_shortcode_field = '';
if( otw_get( 'import_shortcode_field', false ) && array_key_exists( urldecode( otw_get( 'import_shortcode_field', '' ) ), $otw_pc_import_shortcode['params'] ) ){
	$requested_shortcode_field = urldecode( otw_get( 'import_shortcode_field', '' ) );
	
	$otw_import_shortcode_field_values['key'] = $requested_shortcode_field;
	$otw_import_shortcode_field_values['name'] = $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['name'];
	$otw_import_shortcode_field_values['description'] = $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['description'];
	$otw_import_shortcode_field_values['type'] = $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['type'];
	$otw_import_shortcode_field_values['default_value'] = $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['default_value'];
	$page_title = esc_html__( 'Edit imported shortcode field', 'otw_pc' );
}

if( otw_post( 'otw_import_shortcode_field_key', false ) ){
	$otw_import_shortcode_field_values['key'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_key', '' ) );
}
if( otw_post( 'otw_import_shortcode_field_name', false ) ){
	$otw_import_shortcode_field_values['name'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_name', '' ) );
}
if( otw_post( 'otw_import_shortcode_field_description', false ) ){
	$otw_import_shortcode_field_values['description'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_description', '' ) );
}
if( otw_post( 'otw_import_shortcode_field_type', false ) ){
	$otw_import_shortcode_field_values['type'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_type', '' ) );
}
if( otw_post( 'otw_import_shortcode_field_default_value', false ) ){
	$otw_import_shortcode_field_values['default_value'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_default_value', '' ) );
}
?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php echo $page_title; ?>
		<a class="button add-new-h2" href="<?php echo admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields&import_shortcode='.$otw_pc_import_shortcode_key )?>" ><?php esc_html_e('Back To Available Imported Shortcodes Fields', 'otw_pc')?></a>
		<a class="button add-new-h2" href="admin.php?page=otw-pc-import-shortcodes"><?php esc_html_e('Back To Shortcodes', 'otw_pc') ?></a>
	</h2>
	<h3>
		<?php esc_html_e( 'Imported Shortcode:', 'otw_pc' )?> <?php echo $otw_pc_import_shortcode['title'];?>
	</h3>
	<?php if( isset( $validate_messages ) && count( $validate_messages ) ){?>
		<div id="message" class="error">
			<?php foreach( $validate_messages as $v_message ){
				echo '<p>'.$v_message.'</p>';
			}?>
		</div>
	<?php }?>
	<div class="form-wrap" id="poststuff">
		<?php include_once( 'otw_pc_help.php' );?>
		
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="manage_otw_pc_import_shortcode_field" />
			<input type="hidden" name="otw_import_shortcode_field_edit" value="<?php echo esc_attr( $requested_shortcode_field )?>" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-import-shortcodes-fields-manage'); ?>
			<div id="post-body">
				<div id="post-body-content">
					<div class="form-field form-required">
						<label for="otw_import_shortcode_field_key"><?php esc_html_e( 'Field key', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_field_key" value="<?php echo esc_attr( $otw_import_shortcode_field_values['key'] )?>" tabindex="1" style="width: 460px;" size="100" name="otw_import_shortcode_field_key"/>
						<p><?php esc_html_e( 'Add the field key. This will be used for parameter of the shortcode', 'otw_pc' );?></p>
					</div>
					<div class="form-field form-required">
						<label for="otw_import_shortcode_field_name"><?php esc_html_e( 'Field name', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_field_name" value="<?php echo esc_attr( $otw_import_shortcode_field_values['name'] )?>" tabindex="2" style="width: 460px;" size="100" name="otw_import_shortcode_field_name"/>
						<p><?php esc_html_e( 'Add the name of your field. This name displayed in the interface.', 'otw_pc' );?></p>
					</div>
					<div class="form-field form-required">
						<label for="otw_import_shortcode_field_description"><?php esc_html_e( 'Field description', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_field_description" value="<?php echo esc_attr( $otw_import_shortcode_field_values['description'] )?>" tabindex="3" style="width: 560px;" size="100" name="otw_import_shortcode_field_description"/>
						<p><?php esc_html_e( 'Add the description of your field. This name displayed in the interface.', 'otw_pc' );?></p>
					</div>
					<div class="form-field form-required">
						<label for="otw_import_shortcode_field_type"><?php esc_html_e( 'Field type', 'otw_pc' );?></label>
						<select type="text" id="otw_import_shortcode_field_type" tabindex="4" name="otw_import_shortcode_field_type">
							<?php foreach( $otw_pc_import_shortcode_field_types as $field_type => $field_name ){?>
								<option value="<?php echo esc_attr( $field_type )?>"<?php echo ( $otw_import_shortcode_field_values['type'] == $field_type )?' selected="selected"':'' ?>><?php echo esc_html( $field_name )?></option>
							<?php }?>
						</select>
						<p><?php esc_html_e( 'Field type.', 'otw_pc' );?></p>
					</div>
					<div class="form-field form-required">
						<label for="otw_import_shortcode_field_default_value"><?php esc_html_e( 'Field default value', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_field_default_value" value="<?php echo esc_attr( $otw_import_shortcode_field_values['default_value'] )?>" tabindex="5" style="width: 160px;" size="100" name="otw_import_shortcode_field_default_value"/>
						<p><?php esc_html_e( 'Add the description of your field. This name displayed in the interface.', 'otw_pc' );?></p>
					</div>
					<p class="submit">
						<input type="submit" value="<?php esc_html_e( 'Save', 'otw_pc') ?>" name="submit" tabindex="6" class="button"/>
					</p>
				</div>
			</div>
		</form>
	</div>
</div>
