<?php
global $validate_messages, $otw_pc_import_shortcode_field_types, $_wp_column_headers;

$_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] = array(
	'name' => esc_html__( 'Option Name', 'otw_pc' ),
	'key' => esc_html__( 'Option Value', 'otw_pc' )
);

$page_title = esc_html__( 'Imported Shortcode Field Options', 'otw_pc' );

$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );

$otw_pc_import_shortcode_key = '';
$otw_pc_import_shortcode = false;

if( otw_get('import_shortcode',false) ){
	$otw_pc_import_shortcode_key = urldecode( otw_get('import_shortcode','') );
}

if( !is_array( $otw_pc_import_shortcodes ) ){
	$otw_pc_import_shortcodes = array();
}

if( isset( $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ] ) ){
	$otw_pc_import_shortcode = $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ];
}else{
	wp_die( esc_html__( 'Invalid imported shortcode', 'otw_pc' ) );
}

$requested_shortcode_field = '';
if( otw_get( 'import_shortcode_field', false ) && array_key_exists( urldecode( otw_get( 'import_shortcode_field', '' ) ), $otw_pc_import_shortcode['params'] ) ){
	$requested_shortcode_field = urldecode( otw_get( 'import_shortcode_field', '' ) );
}

if( !$requested_shortcode_field ){
	wp_die( esc_html__( 'Invalid imported shortcode field', 'otw_pc' ) );
}

$otw_import_shortcode_field_option_values = array();
$otw_import_shortcode_field_option_values['key'] = '';
$otw_import_shortcode_field_option_values['name'] = '';

$requested_shortcode_field_option = '';
if( otw_get( 'import_shortcode_field_option', false ) && array_key_exists( urldecode( otw_get( 'import_shortcode_field_option', '' ) ), $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'] ) ){
	
	$requested_shortcode_field_option = urldecode( otw_get( 'import_shortcode_field_option', '' ) );
	
	if( otw_get('action',false) && ( otw_get('action','') == 'delete' ) ){
		
		unset( $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'][ $requested_shortcode_field_option ] );
		unset( $otw_pc_import_shortcodes[ $otw_pc_import_shortcode_key ]['params'][ $requested_shortcode_field ]['options'][ $requested_shortcode_field_option ] );
		$requested_shortcode_field_option = '';
		update_option( 'otw_import_shortcodes', $otw_pc_import_shortcodes );
		otw_sget('message', 2);
	}else{
		$otw_import_shortcode_field_option_values['key'] = $requested_shortcode_field_option;
		$otw_import_shortcode_field_option_values['name'] = $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'][ $requested_shortcode_field_option ];
		$page_title = esc_html__( 'Edit imported shortcode field option', 'otw_pc' );
	}
}

if( otw_post( 'otw_import_shortcode_field_option_key', false ) ){
	$otw_import_shortcode_field_option_values['key'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_option_key', '' ) );
}
if( otw_post( 'otw_import_shortcode_field_option_name', false ) ){
	$otw_import_shortcode_field_option_values['name'] = otw_stripslashes( otw_post( 'otw_import_shortcode_field_option_name', '' ) );
}
$message = '';
$massages = array();
$messages[1] = esc_html__( 'Option saved', 'otw_pc' );
$messages[2] = esc_html__( 'Option deleted', 'otw_pc' );

if( otw_get('message',false) && isset( $messages[ otw_get('message','') ] ) ){
	$message .= $messages[ otw_get('message','') ];
}
?>
<?php if ( $message ) : ?>
<div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php endif ?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php echo $page_title; ?>
		<a class="button add-new-h2" href="<?php echo admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields&import_shortcode='.$otw_pc_import_shortcode_key )?>" ><?php esc_html_e('Back To Available Imported Shortcodes Fields', 'otw_pc')?></a>
		<a class="button add-new-h2" href="admin.php?page=otw-pc-import-shortcodes"><?php esc_html_e('Back To Shortcodes', 'otw_pc') ?></a>
	</h2>
	<h3>
		<?php esc_html_e( 'Imported Shortcode:', 'otw_pc' )?> <?php echo $otw_pc_import_shortcode['title'];?>
	</h3>
	<?php if( isset( $validate_messages ) && count( $validate_messages ) ){?>
		<div id="message" class="error">
			<?php foreach( $validate_messages as $v_message ){
				echo '<p>'.$v_message.'</p>';
			}?>
		</div>
	<?php }?>
	<div id="poststuff">
		<?php include_once( 'otw_pc_help.php' );?>
		
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="manage_otw_pc_import_shortcode_field_option" />
			<input type="hidden" name="otw_import_shortcode_field_option_edit" value="<?php echo esc_attr( $requested_shortcode_field_option )?>" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-import-shortcodes-fields-manage'); ?>
			<div id="post-body">
				<div id="post-body-content">
					<fieldset>
						<label for="otw_import_shortcode_field_option_key"><?php esc_html_e( 'Option value', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_field_option_key" value="<?php echo esc_attr( $otw_import_shortcode_field_option_values['key'] )?>" tabindex="1" style="width: 140px;" size="100" name="otw_import_shortcode_field_option_key"/>
						<label for="otw_import_shortcode_field_option_name"><?php esc_html_e( 'Option name', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_field_option_name" value="<?php echo esc_attr( $otw_import_shortcode_field_option_values['name'] )?>" tabindex="2" style="width: 140px;" size="100" name="otw_import_shortcode_field_option_name"/>
						
						<input type="submit" value="<?php ( $requested_shortcode_field_option )?_e( 'Update option', 'otw_pc'):_e( 'Add Option', 'otw_pc') ?>" name="submit" tabindex="3" class="button"/>
					</fieldset>
				</div>
			</div>
		</form>
		
		<br class="clear" />
		<br class="clear" />
		<?php if( isset( $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'] ) && is_array( $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'] ) && count( $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'] ) ){?>
			<table class="widefat fixed" cellspacing="0">
				<thead>
					<tr>
						<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $key => $name ){?>
							<th><?php echo esc_html( $name )?></th>
						<?php }?>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $key => $name ){?>
							<th><?php echo esc_html( $name )?></th>
						<?php }?>
					</tr>
				</tfoot>
				<tbody>
				<?php foreach( $otw_pc_import_shortcode['params'][ $requested_shortcode_field ]['options'] as $option_key => $option_value ){?>
					<tr>
						<?php foreach( $_wp_column_headers['toplevel_page_otw-pc-import-shortcodes'] as $column_name => $column_title ){
							
							$edit_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields-options&amp;action=edit&amp;import_shortcode='.urlencode( $otw_pc_import_shortcode_key ).'&amp;import_shortcode_field='.urlencode( $requested_shortcode_field ).'&amp;import_shortcode_field_option='.urlencode( $option_key ) );
							$delete_link = admin_url( 'admin.php?page=otw-pc-import-shortcodes-fields-options&amp;action=delete&amp;import_shortcode='.urlencode( $otw_pc_import_shortcode_key ).'&amp;import_shortcode_field='.urlencode( $requested_shortcode_field ).'&amp;import_shortcode_field_option='.urlencode( $option_key ) );
							
							switch($column_name) {
							
								case 'name':
									
										echo '<td><strong><a href="'.esc_attr( $edit_link ).'" title="'.esc_attr(sprintf(__('Edit &#8220;%s&#8221;', 'otw_pc'), $option_value)).'">'.$option_value.'</a></strong><br />';
										
										echo '<div class="row-actions">';
										echo '<a href="'.esc_attr( $edit_link ).'">' . esc_html__('Edit', 'otw_pc') . '</a>';
										echo ' | <a href="'.esc_attr( $delete_link ).'">' . esc_html__('Delete', 'otw_pc'). '</a>';
										
										echo '</div>';
										
										echo '</td>';
									break;
								case 'key':
										echo '<td>'.$option_key.'</td>';
									break;
							}
						?>
						
						<?php }?>
					</tr>
				<?php }?>
				</tbody>
			</table>
			
		<?php }else{ ?>
			<p><?php esc_html_e('No custom fields for this shortcode found.', 'otw_pc' )?></p>
		<?php } ?>

	</div>
	
</div>
