<?php
global $validate_messages, $otw_pc_import_shortcode_field_types;

$page_title = esc_html__( 'Import Shortcode', 'otw_pc' );

$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );

if( !is_array( $otw_pc_import_shortcodes ) ){
	$otw_pc_import_shortcodes = array();
}

$otw_import_shortcode_values = array();
$otw_import_shortcode_values['name'] = '';
$otw_import_shortcode_values['key'] = '';
$otw_import_shortcode_values['content'] = '';

$requested_shortcode = '';
if( otw_get('import_shortcode',false) && array_key_exists( urldecode( otw_get('import_shortcode','') ), $otw_pc_import_shortcodes ) ){
	$requested_shortcode = urldecode( otw_get('import_shortcode','') );
	$otw_import_shortcode_values['key'] = urldecode( otw_get('import_shortcode','') );
	$otw_import_shortcode_values['name'] =  $otw_pc_import_shortcodes[ urldecode( otw_get('import_shortcode','') ) ]['title'];
	$otw_import_shortcode_values['content'] =  $otw_pc_import_shortcodes[ urldecode( otw_get('import_shortcode','') ) ]['content'];
	$page_title = esc_html__( 'Edit imported shortcode', 'otw_pc' );
}

if( otw_post( 'otw_import_shortcode_title', false ) ){
	$otw_import_shortcode_values['name'] = otw_stripslashes( otw_post( 'otw_import_shortcode_title', '' ) );
}
if( otw_post( 'otw_import_shortcode_key', false ) ){
	$otw_import_shortcode_values['key'] = otw_stripslashes( otw_post( 'otw_import_shortcode_key', '' ) );
}
if( otw_post( 'otw_import_shortcode_content', false ) ){
	$otw_import_shortcode_values['content'] = otw_stripslashes( otw_post( 'otw_import_shortcode_content', '' ) );
}
?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php echo $page_title; ?>
		<a class="button add-new-h2" href="<?php echo admin_url( 'admin.php?page=otw-pc-import-shortcodes' )?>" ><?php esc_html_e('Back to available imported shortcodes', 'otw_pc')?></a>
	</h2>
	<?php if( isset( $validate_messages ) && count( $validate_messages ) ){?>
		<div id="message" class="error">
			<?php foreach( $validate_messages as $v_message ){
				echo '<p>'.$v_message.'</p>';
			}?>
		</div>
	<?php }?>
	<div class="form-wrap" id="poststuff">
		<?php include_once( 'otw_pc_help.php' );?>
		<div class="updated">
			<p><?php echo otw_esc_text( esc_html__( 'Import shortcodes from other plugins and your theme so you can use them in the Popping Content plugin interfaces.<br />For example you have a [mygallery] shortcode that generates a gallery and you want to use that gallery in a custom page layout created with the Popping Content plugin.<br />Import that shortcode so you can have it in the interface along with the other OTW shortcodes.', 'otw_pc' ), 'cont' );?></p>
		</div>
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="manage_otw_pc_import_shortcode" />
			<input type="hidden" name="otw_import_shortcode_edit" value="<?php echo esc_attr( $requested_shortcode )?>" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-import-shortcodes-manage'); ?>
			<div id="post-body">
				<div id="post-body-content">
					<div class="form-field form-required">
						<label for="otw_import_shortcode_title"><?php esc_html_e( 'Shortcode label', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_title" value="<?php echo esc_attr( $otw_import_shortcode_values['name'] )?>" tabindex="1" style="width: 460px;" size="100" name="otw_import_shortcode_title"/>
						<p><?php esc_html_e( 'The label is how you are going to see your shortcode in the OTW interface.', 'otw_pc' );?></p>
					</div>
					<div class="form-field form-required">
						<label for="otw_import_shortcode_key"><?php esc_html_e( 'Shortcode name/key', 'otw_pc' );?></label>
						<input type="text" id="otw_import_shortcode_key" value="<?php echo esc_attr( $otw_import_shortcode_values['key'] )?>" tabindex="2" style="width: 460px;" size="100" name="otw_import_shortcode_key"/>
						<p><?php esc_html_e( 'The name/key of the shortcode. For example mygallery if you call the shortcode by [mygallery] or [mygallery]content[/mygallery].', 'otw_pc' );?></p>
					</div>
					<div class="form-field form-required">
						<label for="otw_import_shortcode_content"><?php esc_html_e( 'Shortcode content', 'otw_pc' );?></label>
						<select id="otw_import_shortcode_content" tabindex="3"  name="otw_import_shortcode_content">
							<option value="no"<?php echo ( $otw_import_shortcode_values['content'] == 'no' )?' selected="selected"':'' ?>><?php esc_html_e('--No content--','otw_pc')?></option>
							<?php foreach( $otw_pc_import_shortcode_field_types as $field_type => $field_name ){?>
								<?php if( !in_array( $field_type, array( 'uploader', 'checkbox', 'select' ) ) ){?>
									<option value="<?php echo esc_attr( $field_type )?>"<?php echo ( $otw_import_shortcode_values['content'] == $field_type )?' selected="selected"':'' ?>><?php echo esc_html( $field_name )?></option>
								<?php }?>
							<?php }?>
							
						</select>
						<p><?php esc_html_e( 'Example [mygallery]content[/mygallery]. This field will help you easily place your content once you select this shortcode in the OTW interface.', 'otw_pc' );?></p>
					</div>
					<p class="submit">
						<input type="submit" value="<?php esc_html_e( 'Save', 'otw_pc') ?>" name="submit" class="button" tabindex="4"/>
					</p>
				</div>
			</div>
		</form>
	</div>
</div>
