<?php
	global $validate_messages, $otw_pc_grid_manager_object, $wp_pc_int_items, $otw_pc_overlay_object;
	
	$page_title = esc_html__( 'Create New overlay', 'otw_pc' );
	
	$with_exclude_items = array( 'postsincategory', 'postsintag', 'post_in_ctx' );
	
	$otw_overlay_id = 0;
	
	$page_settings = array();
	
	
	$otw_overlay_values = array();
	$otw_overlay_values['loaded'] = false;
	$otw_overlay_values['title'] = '';
	$otw_overlay_values['status'] = 'active';
	$otw_overlay_values['type'] = 'full_bar';
	$otw_overlay_values['grid_content'] = '';
	$otw_overlay_values['validfor'] = array();
	$otw_overlay_values['exclude_posts_for'] = array();
	$otw_overlay_values['options'] = array();
	
	$otw_admin_settings = get_option( 'otw_admin_settings' );
	
	//init default values of the elements
	foreach( $otw_pc_overlay_object->overlay_types as $overlay_type => $overlay_type_data ){
		
		foreach( $overlay_type_data['options'] as $option_type => $type_options ){
			
			$page_settings['metabox_'.$option_type ] = 'open';
			
			if( is_array( $otw_admin_settings ) && isset( $otw_admin_settings['page'] ) && isset( $otw_admin_settings['page']['otw-pc-manage'] ) && isset( $otw_admin_settings['page']['otw-pc-manage']['metabox_'.$option_type] ) ){
				
				if( in_array( $otw_admin_settings['page']['otw-pc-manage']['metabox_'.$option_type], array( 'open', 'closed' ) ) ){
					$page_settings['metabox_'.$option_type ] = $otw_admin_settings['page']['otw-pc-manage']['metabox_'.$option_type];
				}
			}
			
			foreach( $type_options['items'] as $option_name => $option_item ){
				
				switch(  $option_item['type'] ){
				
					case 'checkboxes':
							foreach( $option_item['default'] as $def_key => $def_value ){
								$otw_overlay_values['options'][ $overlay_type.'_'.$def_key ] = $def_value;
							}
						break;
					default:
							$otw_overlay_values['options'][ $overlay_type.'_'.$option_name ] = $option_item['default'];
							
							if( isset( $option_item['subfields'] ) && count( $option_item['subfields'] ) ){
								
								foreach( $option_item['subfields'] as $subfield => $subfield_data ){
								
									$otw_overlay_values['options'][ $overlay_type.'_'.$option_name.'_'.$subfield ] = $subfield_data['default'];
								}
							}
						break;
				}
			}
		}
	}
	
	$valid_for_values = array();
	
	if( otw_get('overlay',false) ){
		
		$otw_overlay_id = otw_get( 'overlay', '' );
		$otw_overlays = otw_get_overlays();
		
		if( is_array( $otw_overlays ) && isset( $otw_overlays[ $otw_overlay_id ] ) ){
			
			foreach( $otw_overlays[ $otw_overlay_id ] as $o_key => $o_data ){
				if( $o_key == 'options' ){
					foreach( $o_data as $option_name => $option_value ){
						$otw_overlay_values['options'][ $option_name ] = $option_value;
					}
				}else{
					$otw_overlay_values[ $o_key ] = $o_data;
				}
			}
			$otw_overlay_values['loaded'] = true;
			$otw_overlay_values['title'] = $otw_overlays[ $otw_overlay_id ]['title'];
			$otw_overlay_values['type'] = $otw_overlays[ $otw_overlay_id ]['type'];
			$otw_overlay_values['status'] = $otw_overlays[ $otw_overlay_id ]['status'];
			$otw_overlay_values['grid_content'] = otw_stripslashes( $otw_overlays[ $otw_overlay_id ]['grid_content'] );
			
			if( isset( $otw_overlays[ $otw_overlay_id ]['validfor'] ) ){
				$otw_overlay_values['validfor'] = $otw_overlays[ $otw_overlay_id ]['validfor'];
			}
			if( isset( $otw_overlays[ $otw_overlay_id ]['exclude_posts_for'] ) ){
				$otw_overlay_values['exclude_posts_for'] = $otw_overlays[ $otw_overlay_id ]['exclude_posts_for'];
			}
			$page_title = esc_html__( 'Edit overlay', 'otw_pc' );
		}
	}
	
	
	if( otw_post('otw_action',false) ){
		
		foreach( $otw_overlay_values as $otw_field_key => $otw_field_default_value ){
			
			if( $otw_field_key == 'options' ){
				
				foreach( $otw_field_default_value as $d_key => $d_value ){
				
					if( otw_post( $d_key, false ) ){
						$otw_overlay_values['options'][ $d_key ] = otw_post( $d_key, '' );
					}
				}
			
			}elseif( otw_post( $otw_field_key, false ) ){
				$otw_overlay_values[ $otw_field_key ] = otw_post( $otw_field_key, '' );
			}
		}
		if( otw_post( '_otw_grid_manager_content', false ) && otw_post( array( '_otw_grid_manager_content', 'code' ), false ) ){
			$otw_overlay_values['grid_content'] = otw_stripslashes( otw_post( array( '_otw_grid_manager_content', 'code' ), '' ) );
		}
	}
	
	foreach( $wp_pc_int_items as $wp_item_type => $wp_item_data ){
	
		if( isset( $otw_overlay_values['validfor'][ $wp_item_type ] ) ){
			$valid_for_values[ $wp_item_type ] = implode(',', array_keys( $otw_overlay_values['validfor'][ $wp_item_type ] ) );
		}elseif( !$otw_overlay_values['loaded'] && in_array( $wp_item_type, array( 'wpmllanguages', 'userroles' ) ) ){
			$db_full_items = otw_pc_get_filtered_items( $wp_item_type, '', 0, 0 );
			$keys = array( 'all' );
			if( isset( $db_full_items[1] ) && is_array( $db_full_items[1] ) ){
				foreach( $db_full_items[1] as $db_full_wpItem ){
					$key = otw_pc_wp_item_attribute( $wp_item_type, 'ID', $db_full_wpItem );
					$keys[ $key ] = $key;
				}
			}
			$valid_for_values[ $wp_item_type ] = implode( ",", $keys );
		}else{
			$valid_for_values[ $wp_item_type ] = '';
		}
		
		if( otw_post( 'otw_'.$wp_item_type.'_validfor', false ) ){
			$valid_for_values[ $wp_item_type ] = otw_post( 'otw_'.$wp_item_type.'_validfor', '' );
		}
	}

/** set class name of each item block
  *  @param array
  *  @return void
  */
function otw_pc_overlay_block_class( $item_type, $overlay_data, $validfor_data ){
	
	if( strlen( trim( $validfor_data ) ) ){
		return;
	}
	
	if( otw_post('otw_action',false) ){
		if( ( !otw_post( 'otw_sbi_'.$item_type, false ) || !count( otw_post( 'otw_sbi_'.$item_type, '' ) ) ) && !otw_post( 'otw_all_selection_'.$item_type, false ) ){
			echo ' otw_closed';
		}
	}else{
		if( !$overlay_data['loaded'] ){
		
			switch( $item_type ){
				case 'wpmllanguages':
				case 'userroles':
					break;
				default:
						if( !isset( $overlay_data['validfor'][ $item_type ] ) || !count( $overlay_data['validfor'][ $item_type ] ) ){
							echo ' otw_closed';
						}
					break;
			}
		}else{
			if( !isset( $overlay_data['validfor'][ $item_type ] ) || !count( $overlay_data['validfor'][ $item_type ] ) ){
				echo ' otw_closed';
			}
		}
	}
}


/** set class name of each item parent block
  *  @param array
  *  @return void
  */
function otw_pc_parent_overlay_block_class( $item_type, $overlay_data, $validfor_data ){
	
	if( strlen( trim( $validfor_data ) ) ){
		return;
	}
	if( otw_post('otw_action',false) ){
		if( ( !otw_post( 'otw_sbi_'.$item_type, false ) || !count( otw_post( 'otw_sbi_'.$item_type, '' ) ) ) && !otw_post( 'otw_all_selection_'.$item_type, false ) ){
			echo ' closed';
		}
	}else{
		if( !$overlay_data['loaded'] ){
		
			switch( $item_type ){
				case 'wpmllanguages':
				case 'userroles':
					break;
				default:
						if( !isset( $overlay_data['validfor'][ $item_type ] ) || !count( $overlay_data['validfor'][ $item_type ] ) ){
							echo ' closed';
						}
					break;
			}
		}else{
			if( !isset( $overlay_data['validfor'][ $item_type ] ) || !count( $overlay_data['validfor'][ $item_type ] ) ){
				echo ' closed';
			}
		}
	}
}

$info_box_class = 'otw_info_box';

if( isset( $otw_admin_settings['page'] ) && isset( $otw_admin_settings['page']['otw-pc-manage'] ) && isset( $otw_admin_settings['page']['otw-pc-manage']['infobox'] ) && in_array( $otw_admin_settings['page']['otw-pc-manage']['infobox'], array( 'open', 'closed') ) ){
	$info_box_class .= ' otw_ib_'.$otw_admin_settings['page']['otw-pc-manage']['infobox'];
}else{
	$info_box_class .= ' otw_ib_open';
}

$message = '';
$massages = array();
$messages[1] = esc_html__( 'overlay saved.', 'otw_pc' );
$messages[2] = esc_html__( 'overlay deleted.', 'otw_pc' );
$messages[3] = esc_html__( 'overlay activated.', 'otw_pc' );
$messages[4] = esc_html__( 'overlay deactivated.', 'otw_pc' );

if( otw_get('message',false) && isset( $messages[ otw_get('message','') ] ) ){
	$message .= $messages[ otw_get('message','') ];
}
?>
<?php if ( $message ){ ?>
<div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php } ?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php echo esc_html( $page_title ); ?>
		<a class="preview button" href="admin.php?page=otw-pc"><?php esc_html_e('Back To Available overlays', 'otw_pc')?></a>
	</h2>
	<?php if( isset( $validate_messages ) && count( $validate_messages ) ){?>
		<div id="message" class="error">
			<?php foreach( $validate_messages as $v_message ){
				echo '<p>'.$v_message.'</p>';
			}?>
		</div>
	<?php }?>
	<div class="updated <?= $info_box_class?>">
		<div class="otw_info_box_controls">
			<a href="javascript:;" class="otw_open_info_box"><?php esc_html_e( 'info', 'otw_pc' )?></a>
			<a href="javascript:;" class="otw_close_info_box"><?php esc_html_e( 'x', 'otw_pc' )?></a>
		</div>
		<div class="otw_info_box_content">
			<p><?php esc_html_e( 'Wondering how this works?', 'otw_pc' );?></p>
			<ul>
				<li><?php echo otw_esc_text(__( '1. Choose the Overlay Type', 'otw_pc' ), 'cont' );?></li>
				<li><?php echo otw_esc_text(__( '2. Set it up in <a href="javascript:;" class="otw_scrollto" rel="otw_options_main">Overlay Options</a> bellow', 'otw_pc' ), 'cont' );?></li>
				<li><?php echo otw_esc_text(__( '3. Choose pages/posts/etc. where the overlay will be visible in <a href="javascript:;" class="otw_scrollto" rel="otw-visbitily-header"> Visibility Options</a> on the right side of the screen', 'otw_pc' ), 'cont' );?></li>
				<li><?php echo otw_esc_text(__( '4. Style it however you need in <a href="javascript:;" class="otw_scrollto" rel="otw_options_styling">Styling Options</a> and <a href="javascript:;" class="otw_scrollto" rel="otw_options_custom">Custom Styling Options</a> bellow', 'otw_pc' ), 'cont' );?></li>
				<li><?php echo otw_esc_text(__( '5. Go down to the <a href="javascript:;" rel="otw_grid_manager_content" class="otw_scrollto">OTW Grid Manager</a> to create a layout and insert shortcodes in your overlay. The layout is the skeleton that holds the shortcodes and makes sure everything is well arranged.', 'otw_pc' ), 'cont' );?></li>
			</ul>
		</div>
	</div>
	<div class="form-wrap" id="poststuff">
		<script type="text/javascript">
			var otw_pc_labels = { 'now': '<?php esc_html_e( 'Now', 'otw_pc' )?>','never': '<?php esc_html_e( 'Never', 'otw_pc' )?>','every_day': '<?php esc_html_e( 'Every Day', 'otw_pc' )?>','dname1': '<?php esc_html_e( 'Mon', 'otw_pc' )?>','dname2': '<?php esc_html_e( 'Thu', 'otw_pc' )?>','dname3': '<?php esc_html_e( 'Wed', 'otw_pc' )?>','dname4': '<?php esc_html_e( 'Thu', 'otw_pc' )?>','dname5': '<?php esc_html_e( 'Fri', 'otw_pc' )?>','dname6': '<?php esc_html_e( 'Sat', 'otw_pc' )?>','dname0': '<?php esc_html_e( 'Sun', 'otw_pc' )?>','all_time': '<?php esc_html_e( 'All day long', 'otw_pc' )?>', 'confirm_delete_period': '<?php esc_html_e( 'Please confirm to delete the period', 'otw_pc' )?>', 'period_dialog_title': '<?php esc_html_e( 'Add/Edit Active Period', 'otw_pc' )?>'};
		</script>
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="manage_otw_pc_overlay" />
			<input type="hidden" id="otw_overlay_id" value="<?php echo esc_attr( $otw_overlay_id )?>" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-manage'); ?>
			<div id="post-body">
				<div id="post-body-content">
					<div id="otw-col-left">
						<div class="form-field form-required">
							<label for="title"><?php esc_html_e( 'Overlay Title', 'otw_pc' );?></label>
							<input type="text" id="title" value="<?php echo esc_attr( $otw_overlay_values['title'] )?>" tabindex="1" size="30" name="title"/>
							<p><?php esc_html_e( 'The name is how it appears on your admin panel.', 'otw_pc' );?></p>
						</div>
						<div class="form-field">
							<label for="status"><?php esc_html_e( 'Status', 'otw_pc' );?></label>
							<select id="status" tabindex="2" style="width: 170px;" name="status">
								<option value="active"<?php if( $otw_overlay_values['status'] == 'active' ){ echo ' selected="selected" ';}?>><?php esc_html_e( 'Active', 'otw_pc' )?></option>
								<option value="inactive"<?php if( $otw_overlay_values['status'] == 'inactive' ){ echo ' selected="selected" ';}?>><?php esc_html_e( 'Inactive', 'otw_pc' )?></option>
							</select>
						</div>
						<div class="form-field form-required">
							<label for="type"><?php esc_html_e( 'Overlay Type', 'otw_pc' );?></label>
							<select id="type" tabindex="3" name="type">
								<?php foreach( $otw_pc_overlay_object->overlay_types as $overlay_type => $overlay_data ){?>
									<option value="<?php echo esc_attr( $overlay_type ) ?>" <?php echo ( $otw_overlay_values['type'] == $overlay_type )?' selected="selected"':''?> ><?php echo esc_html( $overlay_data['label'] )?></option>
								<?php }?>
							</select>
							<p><?php esc_html_e( 'Choose the type of your overlay.', 'otw_pc' );?></p>
						</div>
						<?php foreach( $otw_pc_overlay_object->overlay_types as $overlay_type => $overlay_data ){?>
							
							<div class="otw_overlay_options" id="otw_overlay_options_<?php echo esc_attr( $overlay_type )?>">
							
								<?php if( isset( $overlay_data['options'] ) && count( $overlay_data['options'] ) ){?>
									
									<?php foreach( $overlay_data['options'] as $option_name => $option_data ){?>
										<div class="meta-box-sortables otw_options_<?= $option_name?>" >
											<div data-type="<?= $option_name?>" class="postbox<?php echo ( $page_settings['metabox_'.$option_name ] == 'closed'  )?' closed':''?>">
												<div title="<?php esc_html_e('Click to toggle', 'otw_pc')?>" class="handlediv sitem_toggle otw-sitem-toggle"><br /></div>
												<h3 class="hndle sitem_header"><span><?php echo esc_html( $option_data['label'] )?></span></h3>
												<div class="inside <?php echo ( $page_settings['metabox_'.$option_name ] == 'closed' )?' otw_closed':''?>">
													<?php foreach( $option_data['items'] as $element_name => $element_data ){?>
														
														<?php switch( $element_data['type'] ) {
															
															case 'active_period':
																	echo OTW_Form::datetimepicker( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'id_from' => $overlay_type.'_'.$element_name.'_from', 'name_from' => $overlay_type.'_'.$element_name.'_from', 'id_to' => $overlay_type.'_'.$element_name.'_to', 'name_to' => $overlay_type.'_'.$element_name.'_to', 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'description' => $element_data['description'], 'format' => 'from_to', 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ] ) );
																break;
															case 'input_text': 
																	echo OTW_Form::text_input( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'description' => $element_data['description'], 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ] ) );
																break;
															case 'content_width':
															case 'min_content_width':
															case 'max_content_width':?>
																	<div class="otw-form-control otw-smallform-control">
																		<?php echo OTW_Form::text_input( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'description' => '', 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ], 'format' => 'no_form_control' ) );?>
																		<?php echo OTW_Form::select( array( 'id' => $overlay_type.'_'.$element_name.'_unit', 'name' => $overlay_type.'_'.$element_name.'_unit', 'label' => '', 'parse' => $otw_overlay_values['options'], 'options' => $element_data['subfields']['unit']['options'], 'description' => '', 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name.'_unit' ], 'format' => 'no_form_control' )  );?>
																		<?php if( !empty( $element_data['description'] ) ){?>
																			<span class="otw-form-hint"><?php echo esc_html( $element_data['description'] ) ?>
																		<?php }?>
																	</div>
																	<?php
																break;

															case 'select':
																	echo OTW_Form::select( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'options' => $element_data['options'], 'description' => $element_data['description'], 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ] )  );
																break;
															case 'color_picker':
																	echo OTW_Form::color_picker( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'description' => $element_data['description'], 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ] )  );
																break;
															case 'uploader':
																	echo OTW_Form::uploader( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'description' => $element_data['description'], 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ] )  );
																break;
															case 'select_subfields':
																	echo OTW_Form::select_subfields( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'options' => $element_data['options'], 'description' => $element_data['description'], 'value_from' => $otw_overlay_values['options'], 'subfields' => $element_data['subfields'] ) );
																break;
															case 'checkboxes':?>
																	<div class="otw-form-control">
																		<label for=""><?php echo esc_html( $element_data['label'] ) ?></label>
																		
																		<?php
																			foreach( $element_data['options'] as $e_option_key => $e_option ){
																				$e_params = array();
																				$e_params['id'] = $overlay_type.'_'.$e_option_key;
																				$e_params['name'] = $overlay_type.'_'.$e_option_key;
																				$e_params['label'] = $e_option;
																				$e_params['format'] = 'otw-form-control-checkbox-group';
																				$e_params['value'] = 'yes';
																				
																				$e_params['checked'] = false;
																				
																				if( isset( $otw_overlay_values['options'][ $overlay_type.'_'.$e_option_key ] ) ){
																					
																					if( $otw_overlay_values['options'][ $overlay_type.'_'.$e_option_key ] == 'yes' ){
																						$e_params['checked'] = true;
																					}
																				}
																				
																				echo OTW_Form::checkbox( $e_params );
																			}
																		?>
																		<span class="otw-form-hint"><?php echo esc_html( $element_data['description'] ) ?></span>
																	</div>
																<?php break;
															case 'height_from': ?>
																	<div class="otw-form-control otw-smallform-control">
																		<?php echo OTW_Form::text_input( array( 'id' => $overlay_type.'_'.$element_name, 'name' => $overlay_type.'_'.$element_name, 'label' => $element_data['label'], 'parse' => $otw_overlay_values['options'], 'description' => '', 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ], 'format' => 'no_form_control' ) );?>
																		<?php echo OTW_Form::select( array( 'id' => $overlay_type.'_'.$element_name.'_unit', 'name' => $overlay_type.'_'.$element_name.'_unit', 'label' => '', 'parse' => $otw_overlay_values['options'], 'options' => $element_data['subfields']['unit']['options'], 'description' => '', 'value' => $otw_overlay_values['options'][ $overlay_type.'_'.$element_name.'_unit' ], 'format' => 'no_form_control' )  );?>
																		<?php if( !empty( $element_data['description'] ) ){?>
																			<span class="otw-form-hint"><?php echo esc_html( $element_data['description'] ) ?></span>
																		<?php }?>
																	</div>
																<?php break;
															case 'active_periods': ?>
																	<div class="otw-form-control">
																		<label for=""><?php echo esc_html( $element_data['label'] ) ?></label>
																		<input type="button" value="<?php esc_html_e( 'Add Period', 'otw_pc' )?>" class="button add_active_periods" id="add_ap_<?php echo esc_attr( $overlay_type.'_'.$element_name )?>"/>
																		<span class="otw-form-hint"><?php echo esc_html( $element_data['description'] )?></span>
																		<input type="hidden" name="<?php echo esc_attr( $overlay_type.'_'.$element_name )?>" value="<?php echo otw_stripslashes( otw_htmlentities( $otw_overlay_values['options'][ $overlay_type.'_'.$element_name ] ) ) ?>" class="otw_active_periods_value" id="<?php echo esc_attr( $overlay_type.'_'.$element_name )?>" />
																		
																		<div id="<?php echo esc_attr( $overlay_type.'_'.$element_name )?>_table">
																			<table width="100%" class="otw_active_periods_table">
																				<thead>
																					<tr>
																						<th><?php esc_html_e( 'Starts', 'otw_pc' )?></th>
																						<th><?php esc_html_e( 'Ends', 'otw_pc' )?></th>
																						<th><?php esc_html_e( 'Days', 'otw_pc' )?></th>
																						<th><?php esc_html_e( 'Time', 'otw_pc' )?></th>
																						<th>&nbsp;</th>
																						<th>&nbsp;</th>
																					</tr>
																				</thead>
																				<tbody>
																				</tbody>
																			</table>
																		</div>
																	</div>
																<?php break;
															
														}?>
													<?php }?>
												</div>
											</div>
										</div>
									<?php }?>
								<?php }?>
							</div>
						<?php }?>
						<div>
							<p class="submit">
								<input type="submit" value="<?php esc_html_e( 'Save Overlay', 'otw_pc') ?>" name="submit" class="button button-primary button-large"/>
							</p>
						</div>
					</div>
					<div id="otw-col-right" class="otw_pc_<?php echo esc_attr( $otw_overlay_id )?>">
						<h3 class="otw-visbitily-header"><span><?php esc_html_e('Visibility options', 'otw_pc')?></span></h3>
						<div class="otw_updated">
							<p><?php esc_html_e( 'A selected page template includes all pages using that template.', 'otw_pc' )?><br />
							<?php esc_html_e( 'Template hierarchy Page includes all pages.', 'otw_pc' )?></p>
						</div>
						<div class="otw_pc_global_manage_settings">
							<a href="javascript:;" class="otw_all_global_manage_vis"><?php esc_html_e( 'Visible everywhere', 'otw_pc' )?></a>
							|
							<a href="javascript:;" class="otw_all_global_manage_invis"><?php esc_html_e( 'Invisible everywhere', 'otw_pc' )?></a>
							<br /><i><?php esc_html_e( 'This will not affect the "User roles/Logged in as" tab settings.', 'otw_pc' ) ?></i>
						</div>
						<?php if( is_array( $wp_pc_int_items ) && count( $wp_pc_int_items ) ){?>
						
							<?php foreach( $wp_pc_int_items as $wp_item_type => $wp_item_data ){?>
							
								<div class="meta-box-sortables">
									<div class="postbox<?php otw_pc_parent_overlay_block_class( $wp_item_type, $otw_overlay_values, $valid_for_values[ $wp_item_type ] )?>">
										<div title="<?php esc_html_e('Click to toggle', 'otw_pc')?>" class="handlediv sitem_toggle otw-sitem-toggle"><br /></div>
										<h3 class="hndle sitem_header"><span><?php echo esc_html( $wp_item_data[1] )?></span></h3>
										
										<div class="inside sitems<?php otw_pc_overlay_block_class( $wp_item_type, $otw_overlay_values, $valid_for_values[ $wp_item_type ] )?>" id="otw_pc_type_<?php echo esc_attr( $wp_item_type )?>">
											
											<div class="otw_overlay_item_filter" id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_filter" >
												<div id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_search" class="otw_overlay_filter_search">
													<label for="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_search_field"><?php esc_html_e( 'Search', 'otw_pc' )?></label>
													<input type="text" id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_search_field" class="otw_pc_q_filter" value=""/>
												</div>
												<div id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_clear" class="otw_overlay_filter_clear">
													<a href="javascript:;" id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_clear"><?php esc_html_e( 'reset', 'otw_pc' )?></a>
												</div>
												<div id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_order" class="otw_overlay_filter_order">
													<label for="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_order_field"><?php esc_html_e( 'Order', 'otw_pc' )?></label>
													<select id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_order_field">
														<?php $sort_options = otw_pc_get_item_sort_options( $wp_item_type);?>
														<?php if( count( $sort_options ) ){?>
															<?php foreach( $sort_options as $s_key => $s_value ){ ?>
																<option value="<?php echo esc_attr( $s_key )?>"><?php echo esc_html( $s_value )?></option>
															<?php }?>
														<?php }?>
													</select>
												</div>
												<div id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_show" class="otw_overlay_filter_show">
													<label for="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_show_field"><?php esc_html_e( 'Show', 'otw_pc' )?></label>
													<select id="otw_type_<?php echo esc_attr( $wp_item_type ) ?>_show_field">
														<option value="all"><?php esc_html_e( 'All', 'otw_pc' )?></option>
														<option value="all_selected"><?php esc_html_e( 'All Selected', 'otw_pc' )?></option>
														<option value="all_unselected"><?php esc_html_e( 'All Unselected', 'otw_pc' )?></option>
													</select>
												</div>
											</div>
											<div class="otw_pc_all_actions">
												<div class="otw_pc_all_links">
													<a href="javascript:;" class="otw_pc_select_all_items" rel="<?php echo esc_attr( $wp_item_type )?>"><?php esc_html_e( 'Select All', 'otw_pc' )?></a>
													|
													<a href="javascript:;" class="otw_pc_unselect_all_items" rel="<?php echo esc_attr( $wp_item_type )?>"><?php esc_html_e( 'Unselect All', 'otw_pc' )?></a>
												</div>
												<div class="otw_pc_selected_items">
													<span class="otw_selected_items_number"></span>&nbsp;<span class="otw_seleted_items_plural"><?php esc_html_e( 'items are', 'otw_pc' );?></span><span class="otw_selected_items_singular"><?php esc_html_e('item is', 'otw_pc' )?></span>&nbsp;<?php esc_html_e( 'selected', 'otw_pc' )?>
												</div>
											</div>
											<div class="a_item">
												<?php if( is_array( $wp_item_data[0] ) && count( $wp_item_data[0] ) ){?>
													<?php foreach( $wp_item_data[0] as $wpItem ){?>
														<p<?php otw_overlay_item_attributes( 'p', $wp_item_type, otw_pc_wp_item_attribute( $wp_item_type, 'ID', $wpItem ), $otw_overlay_values, $wpItem )?>>
															<input type="checkbox" id="otw_sbi_<?php echo esc_attr( $wp_item_type )?>_sbi_<?php echo otw_pc_wp_item_attribute( $wp_item_type, 'ID', $wpItem ) ?>"<?php otw_overlay_item_attributes( 'c', $wp_item_type, otw_wp_item_attribute( $wp_item_type, 'ID', $wpItem ), $otw_overlay_values, array() )?> value="<?php echo otw_wp_item_attribute( $wp_item_type, 'ID', $wpItem ) ?>" name="otw_sbi_<?php echo esc_attr( $wp_item_type )?>[<?php echo otw_wp_item_attribute( $wp_item_type, 'ID', $wpItem ) ?>]" /><label for="otw_sbi_<?php echo esc_attr( $wp_item_type )?>_sbi_<?php echo otw_wp_item_attribute( $wp_item_type, 'ID', $wpItem ) ?>"<?php otw_overlay_item_attributes( 'l', $wp_item_type, otw_wp_item_attribute( $wp_item_type, 'ID', $wpItem ), $otw_overlay_values, $wpItem )?> ><a href="javascript:;"><?php echo otw_wp_item_attribute( $wp_item_type, 'TITLE', $wpItem ) ?></a></label>
														</p>
													<?php }?>
												<?php }else{ echo '&nbsp;'; }?>
												</div>
												<?php
													$exclude_type = $wp_item_type;
													
													if( preg_match( "/^post_in_ctx_(.*)$/", $exclude_type ) ){
														$exclude_type = 'post_in_ctx';
													}
													
													if( in_array( $exclude_type, $with_exclude_items ) ){?>
														<div class="otw_exclude_items">
															<span><?php esc_html_e( 'Exclude posts from the above result-set by given id or slug. Separate with commas.', 'otw_pc' ); ?></span><br />
															<input type="text" name="otw_exclude_posts_<?php echo esc_attr( $wp_item_type ) ?>" value="<?php echo otw_pc_wp_item_exclude( 'post', $wp_item_type, $otw_overlay_values ) ?>" />
														</div>
												<?php }?>
											<input type="hidden" id="otw_pc_type_<?php echo esc_attr( $wp_item_type )?>_validfor" class="otw_pc_validfor" value="<?php echo esc_html( $valid_for_values[ $wp_item_type ] )?>" name="otw_<?php echo esc_attr( $wp_item_type )?>_validfor" />
										</div>
									</div>
								</div>
							<?php }?>
						<?php }?>
					</div>
					<div id="<?php echo esc_attr( $otw_pc_grid_manager_object->meta_name );?>">
						<div class="meta-box-sortables">
							<div class="postbox">
								<h3 class="hndle sitem_header"><span><?php esc_html_e( 'OTW Grid Manager', 'otw_pc' )?></span></h3>
								<div class="inside">
									<?php echo $otw_pc_grid_manager_object->build_custom_box( $otw_overlay_values['grid_content'] );?>
								</div>
							</div>
						</div>
					</div>
					<div id="otw_periods_dialog_wrapper">
					<div id="otw_periods_dialog">
						<div class="otw_periopds_content">
							<div class="otw_period_row">
								<label for="" class="main"><?php esc_html_e( 'Starts', 'otw_pc' )?></label>
								<div class="otw_period_values">
									<p><input type="checkbox" name="period_from_now" value="1" id="period_from_now"/><label for="period_from_now"><?php esc_html_e( 'Now(default)', 'otw_pc' )?></label></p>
									<p><?php esc_html_e( '-OR-', 'otw_pc' )?></p>
									<p><input type="text" id="period_from_date" name="period_from_date" class="otw-datetimepicker" /></p>
								</div>
								<span><?php esc_html_e( 'Starts: This is the start of the activation period.', 'otw_pc' )?></span>
							</div>
							<div class="otw_period_row">
								<label for="" class="main"><?php esc_html_e( 'Ends', 'otw_pc' )?></label>
								<div class="otw_period_values">
									<p><input type="checkbox" id="period_to_never" name="period_to_never" value="1" /><label for="period_to_never"><?php esc_html_e( 'Never ends(default)', 'otw_pc' )?></label></p>
									<p><?php esc_html_e( '-OR-', 'otw_pc' )?></p>
									<p><input type="text"  class="otw-datetimepicker" id="period_to_date" name="period_to_date" /></p>
								</div>
								<span><?php esc_html_e( 'Ends: This is the end of the activation period.', 'otw_pc' )?></span>
							</div>
							<div class="otw_period_row">
								<label for="" class="main"><?php esc_html_e( 'Days', 'otw_pc' )?></label>
								<div class="otw_period_values otw_period_day_values">
									<p>
										<input type="checkbox" name="period_day_mon" id="period_day_mon" class="period_day"  value="1" /><label for="period_day_mon"><?php esc_html_e( 'Mon', 'otw_pc' )?></label>
										<input type="checkbox" name="period_day_tue" id="period_day_tue" class="period_day"  value="2" /><label for="period_day_tue"><?php esc_html_e( 'Tue', 'otw_pc' )?></label>
										<input type="checkbox" name="period_day_wed" id="period_day_wed" class="period_day"  value="3" /><label for="period_day_wed"><?php esc_html_e( 'Wed', 'otw_pc' )?></label>
										<input type="checkbox" name="period_day_thu" id="period_day_thu" class="period_day"  value="4" /><label for="period_day_thu"><?php esc_html_e( 'Thu', 'otw_pc' )?></label>
										<input type="checkbox" name="period_day_fri" id="period_day_fri" class="period_day"  value="5" /><label for="period_day_fri"><?php esc_html_e( 'Fri', 'otw_pc' )?></label>
										<input type="checkbox" name="period_day_sat" id="period_day_sat" class="period_day"  value="6" /><label for="period_day_sat"><?php esc_html_e( 'Sat', 'otw_pc' )?></label>
										<input type="checkbox" name="period_day_sun" id="period_day_sun" class="period_day"  value="0" /><label for="period_day_sun"><?php esc_html_e( 'Sun', 'otw_pc' )?></label>
									</p>
								</div>
								<span><?php esc_html_e( 'Days: Select the days for the above period.', 'otw_pc' )?></span>
							</div>
							<div class="otw_period_row">
								<label for="" class="main"><?php esc_html_e( 'Time', 'otw_pc' )?></label>
								<div class="otw_period_values">
									<p><input type="checkbox" id="period_time_all" name="period_time_all" value="1"/><label for="period_time_all"><?php esc_html_e( 'All day long(default)', 'otw_pc' )?></label></p>
									<p><?php esc_html_e( '-OR-', 'otw_pc' )?></p>
									<p>
										<label for="period_from_hour"><?php esc_html_e( 'From', 'otw_pc' )?></label>
										<select id="period_from_hour" name="period_from_hour">
											<?php
												for( $cH = 0; $cH < 12; $cH++ ){
													$value = $cH;
													
													if( $cH < 10 ){
														$value = '0'.$cH;
													}
													echo '<option value="'.esc_attr( $value ).'">'.$value.'</option>';
												}
											?>
										</select>
										<label for="period_from_min" class="short">:</label>
										<select id="period_from_min" name="period_from_min">
											<?php
												for( $cM = 0; $cM < 60; $cM++ ){
													$value = $cM;
													
													if( $cM < 10 ){
														$value = '0'.$cM;
													}
													echo '<option value="'.esc_attr( $value ).'">'.$value.'</option>';
												}
											?>
										</select>
										<select id="period_from_mer" name="period_from_mer">
											<option value="am"><?php esc_html_e( 'AM', 'otw_pc' )?></option>
											<option value="pm"><?php esc_html_e( 'PM', 'otw_pc' )?></option>
										</select>
										<label for="period_to_hour"><?php esc_html_e( 'To', 'otw_pc' )?></label>
										<select id="period_to_hour" name="period_to_hour">
											<?php
												for( $cH = 0; $cH < 12; $cH++ ){
													$value = $cH;
													
													if( $cH < 10 ){
														$value = '0'.$cH;
													}
													echo '<option value="'.esc_attr( $value ).'">'.$value.'</option>';
												}
											?>
										</select>
										<label for="period_to_min" class="short">:</label>
										<select id="period_to_min" name="period_to_min">
											<?php
												for( $cM = 0; $cM < 60; $cM++ ){
													$value = $cM;
													
													if( $cM < 10 ){
														$value = '0'.$cM;
													}
													echo '<option value="'.esc_attr( $value ).'">'.$value.'</option>';
												}
											?>
										</select>
										<select id="period_to_mer" name="period_to_mer">
											<option value="am"><?php esc_html_e( 'AM', 'otw_pc' )?></option>
											<option value="pm"><?php esc_html_e( 'PM', 'otw_pc' )?></option>
										</select>
									</p>
								</div>
								<span><?php esc_html_e( 'Time: Select the time in the selected days.', 'otw_pc' )?></span>
							</div>
							<div class="otw_period_buttons">
								<input type="button" value="<?php esc_html_e( 'Save', 'otw_pc' )?>" id="otw_save_periods" class="button button-primary"/>
								<input type="button" value="<?php esc_html_e( 'Close', 'otw_pc' )?>" id="otw_close_periods" class="button" />
							</div>
						</div>
					</div>
					</div>
					<div>
						<p class="submit">
							<input type="submit" value="<?php esc_html_e( 'Save Overlay', 'otw_pc') ?>" name="submit" class="button button-primary button-large"/>
						</p>
					</div>
				</div>
			</div>
		</form>
	</div>
</div>
