<?php
/** Manage plugin options
  *
  */

global $otw_pc_custom_css_path, $otw_pc_plugin_id;;

$db_values = array();
$db_values['otw_pc_custom_css'] = '';

global $wp_filesystem;

if( !otw_init_filesystem() ){
	$error = new WP_Error( 'invalid_write_perms', esc_html__( 'No write perimtions to save settings.', 'otw_pc' ) );
	$error_string = $error->get_error_message();
}

if( $wp_filesystem->exists( $otw_pc_custom_css_path ) ){
	$db_values['otw_pc_custom_css'] = $wp_filesystem->get_contents( $otw_pc_custom_css_path );
}

$db_values['otw_pc_promotions'] = get_option( $otw_pc_plugin_id.'_dnms' );

if( empty( $db_values['otw_pc_promotions'] ) ){
	$db_values['otw_pc_promotions'] = 'on';
}


$upload_dir = wp_upload_dir();

$message = '';
$massages = array();
$messages[1] = esc_html__( 'Options saved', 'otw_pc' );

if( otw_get('message',false) && isset( $messages[ otw_get('message','') ] ) ){
	$message .= $messages[ otw_get('message','') ];
}
?>
<?php if ( $message ) : ?>
<div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php endif; ?>
<?php if( !isset( $upload_dir['basedir'] ) || !$wp_filesystem->is_writable( $upload_dir['basedir'] ) ){?>
<div class="error"><?php esc_html_e('The file \''.$otw_pc_custom_css_path.'\' is not writable. Please make sure you add read/write permissions to this file.', 'otw_pc');?></div>
<?php }?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php esc_html_e('Plugin Options', 'otw_pc') ?>
	</h2>
	<div class="form-wrap otw-options" id="poststuff">
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="manage_otw_pc_options" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-options'); ?>

			<div id="post-body">
				<div id="post-body-content">
					<div class="form-field">
						<label for="otw_pc_promotions"><?php esc_html_e('Show OTW Promotion Messages in my WordPress admin', 'otw_pc'); ?></label>
						<select id="otw_pc_promotions" name="otw_pc_promotions">
							<option value="on" <?php echo ( isset( $db_values['otw_pc_promotions'] ) && ( $db_values['otw_pc_promotions'] == 'on' ) )? 'selected="selected"':''?>>on(default)</option>
							<option value="off"<?php echo ( isset( $db_values['otw_pc_promotions'] ) && ( $db_values['otw_pc_promotions'] == 'off' ) )? 'selected="selected"':''?>>off</option>
						</select>
					</div>
					<div class="form-field">
						<label><?php esc_html_e('Custom CSS', 'otw_pc');?></label>
						<p><?php esc_html_e( 'Adjust your own CSS. Please use with caution.', 'otw_pc') ?></p>
						<textarea name="otw_pc_custom_css" cols="100" rows="35"><?php echo esc_textarea( $db_values['otw_pc_custom_css'] );?></textarea>
					</div>
					<p class="submit">
						<input type="submit" value="<?php esc_html_e( 'Save Options', 'otw_pc') ?>" name="submit" class="button"/>
					</p>
				</div>
			</div>
		</form>
	</div>
</div>
