<?php
/** Overlay actions
  *  - delete overlay
  *  - activate
  *  - deactivate
  */
	global $validate_messages;
	
	$otw_overlay_values = array(
		'title'       =>  '',
		'status'      =>  'inactive'
	);
	
	$otw_overlay_id = '';
	$otw_action = '';
	
	if( otw_get('action',false) ){
		
		switch( otw_get('action','') ){
			
			case 'delete':
					$otw_action = 'otw_pc_overlay_delete';
					$page_title = esc_html__( 'Delete Overlay', 'otw_pc' );
					$confirm_text = esc_html__( 'Please confirm to delete the overlay', 'otw_pc' );
				break;
			case 'activate':
					$otw_action = 'otw_pc_overlay_activate';
					$page_title = esc_html__( 'Activate Overlay', 'otw_pc' );
					$confirm_text = esc_html__( 'Please confirm to activate the overlay', 'otw_pc' );
				break;
			case 'deactivate':
					$otw_action = 'otw_pc_overlay_deactivate';
					$page_title = esc_html__( 'Deactivate Overlay', 'otw_pc' );
					$confirm_text = esc_html__( 'Please confirm to deactivate the overlay', 'otw_pc' );
				break;
			case 'copy':
					$otw_action = 'otw_pc_overlay_copy';
					$page_title = esc_html__( 'Duplicate Overlay', 'otw_pc' );
					$confirm_text = esc_html__( 'Please confirm to duplicate the overlay', 'otw_pc' );
				break;
		}
	}
	if( !$otw_action ){
		wp_die( esc_html__( 'Invalid overlay action', 'otw_pc' ) );
	}
	if( otw_get('overlay',false) ){
		
		$otw_overlay_id = otw_get( 'overlay', '' );
		$otw_overlays = otw_get_overlays();
		
		if( is_array( $otw_overlays ) && isset( $otw_overlays[ $otw_overlay_id ] ) ){
			
			$otw_overlay_values['title'] = $otw_overlays[ $otw_overlay_id ]['title'];
			$otw_overlay_values['status'] = $otw_overlays[ $otw_overlay_id ]['status'];
			$otw_overlay_values['validfor'] = $otw_overlays[ $otw_overlay_id ]['validfor'];
			
			if( otw_post( 'title', false ) ){
				$otw_overlay_values['title'] = otw_post( 'title', '' );
			}
		}
	}
	if( !$otw_overlay_id ){
		wp_die( esc_html__( 'Invalid overlay', 'otw_pc' ) );
	}
	
?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php echo esc_html( $page_title ); ?>
		<a class="preview button" href="admin.php?page=otw-pc"><?php esc_html_e( 'Back To List Of overlays', 'otw_pc' );?></a>
	</h2>
	<div id="ajax-response"></div>
	<?php if( isset( $validate_messages ) && count( $validate_messages ) ){?>
		<div id="message" class="error">
			<?php foreach( $validate_messages as $v_message ){
				echo '<p>'.$v_message.'</p>';
			}?>
		</div>
	<?php }?>
	<div class="form-wrap" id="poststuff">
		<form method="post" action="" class="validate">
			<input type="hidden" name="otw_action" value="<?php echo esc_attr( $otw_action )?>" />
			<?php wp_original_referer_field(true, 'previous'); wp_nonce_field('otw-pc-overlays-action'); ?>

			<div id="post-body">
				<div id="post-body-content">
					<div id="col-right">
						<div class="form-field form-required">
							<?php switch( $otw_action ){
								case 'otw_pc_overlay_copy':?>
										<label for="title"><?php esc_html_e( 'Overlay Title', 'otw_pc' );?></label>
										<input type="text" id="title" value="<?php echo esc_attr( $otw_overlay_values['title'] )?>" tabindex="1" size="30" name="title"/>
										<p><?php esc_html_e( 'The name is how it appears on your admin panel.', 'otw_pc' );?></p>
									<?php break;
								default: ?>
										<strong><?php echo esc_html( $otw_overlay_values['title'] )?></strong>
									<?php break;
							}?>
						</div>
						<div class="form-field">
							<?php esc_html_e( 'Status', 'otw_pc' );?>:
							<strong><?php esc_html_e( ucfirst( $otw_overlay_values['status']  ), 'otw_pc' )?></strong>
						</div>
					</div>
					<div id="col-left">
						<p>
							<?php echo $confirm_text;?>
						</p>
						<p class="submit">
							<input type="submit" class="button button-primary button-large" value="<?php esc_html_e( 'Confirm', 'otw_pc') ?>" name="submit" />
							<input type="submit" value="<?php esc_html_e( 'Cancel', 'otw_pc' ) ?>" name="cancel" class="button"/>
						</p>
					</div>
				</div>
			</div>
		</form>
	</div>
</div>