<?php
/**
 * Process otw actions
 *
 */

if( otw_post('otw_action',false) ){

	switch( otw_post('otw_action','') ){
		
		case 'otw_pc_overlay_copy':
				if( otw_post( 'cancel', false ) ){
					wp_redirect( 'admin.php?page=otw-pc' );
				}else{
					global $validate_messages;
					
					$valid_page = true;
					$validate_messages = array();
					
					$otw_overlays = otw_get_overlays();
					
					if( otw_get('overlay',false) && isset( $otw_overlays[ otw_get('overlay','') ] ) ){
						$otw_overlay_id = otw_get( 'overlay', '' );
						
						if( !otw_post( 'title', false ) || !strlen( trim( otw_post( 'title', '' ) ) ) ){
							$valid_page = false;
							$validate_messages[] = esc_html__( 'Please type valid overlay title', 'otw_pc' );
						}
						
						if( $valid_page )
						{
							$overlay = $otw_overlays[ $otw_overlay_id ];
							$new_otw_overlay_id = 'otw-overlay-'.( otw_get_next_overlay_id() );
							$overlay['id'] = $new_otw_overlay_id;
							$overlay['title'] = otw_post( 'title', '' );
							$otw_overlays[ $new_otw_overlay_id ] = $overlay;
							
							otw_save_overlays( $otw_overlays );
							
							wp_redirect( 'admin.php?page=otw-pc&message=5' );
						}
					}else{
						wp_die( esc_html__( 'Invalid overlay', 'otw_pc' ) );
					}
				}
			break;
		case 'otw_pc_overlay_deactivate':
				if( otw_post( 'cancel', false ) ){
					wp_redirect( 'admin.php?page=otw-pc' );
				}else{
					$otw_overlays = otw_get_overlays();
					
					if( otw_get('overlay',false) && isset( $otw_overlays[ otw_get('overlay','') ] ) ){
						$otw_overlay_id = otw_get( 'overlay', '' );
						
						$otw_overlays[ $otw_overlay_id ]['status'] = 'inactive';
						
						otw_save_overlays( $otw_overlays );
						
						wp_redirect( 'admin.php?page=otw-pc&message=4' );
					}else{
						wp_die( esc_html__( 'Invalid overlay', 'otw_pc' ) );
					}
				}
			break;
		case 'otw_pc_overlay_activate':
				if( otw_post( 'cancel', false ) ){
					wp_redirect( 'admin.php?page=otw-pc' );
				}else{
					$otw_overlays = otw_get_overlays();
					
					if( otw_get('overlay',false) && isset( $otw_overlays[ otw_get('overlay','') ] ) ){
						$otw_overlay_id = otw_get( 'overlay', '' );
						
						$otw_overlays[ $otw_overlay_id ]['status'] = 'active';
						
						otw_save_overlays( $otw_overlays );
						
						wp_redirect( 'admin.php?page=otw-pc&message=4' );
					}else{
						wp_die( esc_html__( 'Invalid overlay', 'otw_pc' ) );
					}
				}
			break;
		case 'otw_pc_overlay_delete':
				if( otw_post( 'cancel', false ) ){
					wp_redirect( 'admin.php?page=otw-pc' );
				}else{
					
					$otw_overlays = otw_get_overlays();
					
					if( otw_get('overlay',false) && isset( $otw_overlays[ otw_get('overlay','') ] ) ){
						$otw_overlay_id = otw_get( 'overlay', '' );
						
						$new_overlays = array();
						
						//remove the overlay from otw_overlays
						foreach( $otw_overlays as $overlay_key => $overlay ){
						
							if( $overlay_key != $otw_overlay_id ){
							
								$new_overlays[ $overlay_key ] = $overlay;
							}
						}
						otw_save_overlays( $new_overlays );
						
						wp_redirect( admin_url( 'admin.php?page=otw-pc&message=2' ) );
					}else{
						wp_die( esc_html__( 'Invalid overlay', 'otw_pc' ) );
					}
				}
			break;
		case 'manage_otw_pc_overlay':
				
				global $validate_messages, $wpdb, $otw_pc_overlay_object;
				
				$validate_messages = array();
				
				$valid_page = true;
				if( !otw_post( 'title', false ) || !strlen( trim( otw_post( 'title', '' ) ) ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Please type valid overlay title', 'otw_pc' );
				}
				if( !otw_post( 'status', false ) || !strlen( trim( otw_post( 'status', '' ) ) ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Please select status', 'otw_pc' );
				}
				if( !otw_post( 'type', false ) || !strlen( trim( otw_post( 'type', '' ) ) ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Please select overlay type', 'otw_pc' );
				}
				if( $valid_page ){
					$otw_overlays = otw_get_overlays();
					
					if( otw_get('overlay',false) && isset( $otw_overlays[ otw_get('overlay','') ] ) ){
						$otw_overlay_id = otw_get( 'overlay', '' );
						$overlay = $otw_overlays[ otw_get('overlay','') ];
					}else{
						$overlay = array();
						$otw_overlay_id = false;
					}
					
					$overlay['title'] = (string) otw_post( 'title', '' );
					$overlay['type'] = (string) otw_post( 'type', '' );
					$overlay['status'] = (string) otw_post( 'status', '' );
					$overlay['grid_content'] = otw_post( array( '_otw_grid_manager_content', 'code' ), '' );
					$overlay['options'] = array();
					
					//save options
					foreach( $otw_pc_overlay_object->overlay_types as $overlay_type => $overlay_type_data ){
						
						foreach( $overlay_type_data['options'] as $type_options ){
							
							foreach( $type_options['items'] as $option_name => $option_item ){
								
								switch( $option_item['type'] ){
									case 'checkboxes':
											foreach( $option_item['options'] as $sub_option_key => $sub_option_name ){
											
												if( otw_post( $overlay_type.'_'.$sub_option_key, false ) ){
													$overlay['options'][ $overlay_type.'_'.$sub_option_key ] = otw_post( $overlay_type.'_'.$sub_option_key, '' );
												}else{
													$overlay['options'][ $overlay_type.'_'.$sub_option_key ] = 'no';
												}
											}
										break;
									default:
											if( otw_post( $overlay_type.'_'.$option_name, false ) ){
												
												$overlay['options'][ $overlay_type.'_'.$option_name ] = otw_post( $overlay_type.'_'.$option_name, '' );
												
											}elseif( isset( $overlay['options'][ $overlay_type.'_'.$option_name ] ) ){
												
												unset( $overlay['options'][ $overlay_type.'_'.$option_name ] );
											}
											
											if( isset( $option_item['subfields'] ) && is_array( $option_item['subfields'] ) && count( $option_item['subfields'] ) ){
											
												foreach( $option_item['subfields'] as $subfield => $subfield_data ){
												
													if( otw_post( $overlay_type.'_'.$option_name.'_'.$subfield, false ) ){
														
														$overlay['options'][ $overlay_type.'_'.$option_name.'_'.$subfield ] = otw_post( $overlay_type.'_'.$option_name.'_'.$subfield, '' );
														
													}elseif( isset( $overlay['options'][ $overlay_type.'_'.$option_name.'_'.$subfield  ] ) ){
														
														unset( $overlay['options'][ $overlay_type.'_'.$option_name.'_'.$subfield  ] );
													}
												}
											
											}
										break;
								}
							}
						}
					}
					
					$otw_sbi_items = array_keys( $wp_pc_int_items );
					
					foreach( $otw_sbi_items as $otw_sbi_item ){
						
						if( otw_post( 'otw_'.$otw_sbi_item.'_validfor', false ) && strlen( trim( otw_post( 'otw_'.$otw_sbi_item.'_validfor', '' ) ) ) ){
							
							$overlay['validfor'][ $otw_sbi_item ] = array();
							
							$posted_items = explode( ',', otw_post( 'otw_'.$otw_sbi_item.'_validfor', '' ) );
							
							foreach( $posted_items as $item_id ){
								$overlay['validfor'][ $otw_sbi_item ][ $item_id ] = array();
								$overlay['validfor'][ $otw_sbi_item ][ $item_id ]['id'] = $item_id;
								
								if( otw_post( 'otw_exclude_sub_object_'.$otw_sbi_item.'_'.$item_id, false ) && strlen( trim( otw_post( 'otw_exclude_sub_object_'.$otw_sbi_item.'_'.$item_id, '' ) ) ) ){
									$overlay['validfor'][ $otw_sbi_item ][ $item_id ]['exclude_post'] = otw_post( 'otw_exclude_sub_object_'.$otw_sbi_item.'_'.$item_id, '' );
								}
							}
							
						}else{
							$overlay['validfor'][ $otw_sbi_item ] = array();
						}
						
						//global selection
						if( otw_post( 'otw_all_selection_'.$otw_sbi_item, false ) && ( otw_post( 'otw_all_selection_'.$otw_sbi_item, '' ) == 1 ) ){
							
							if( !isset( $overlay['validfor'] ) ){
								$overlay['validfor'] = array();
							}
							if( !isset( $overlay['validfor'][ $otw_sbi_item ] ) ){
								$overlay['validfor'][ $otw_sbi_item ] = array();
							}
							
							$overlay['validfor'][ $otw_sbi_item ]['all'] = array();
							$overlay['validfor'][ $otw_sbi_item ]['all']['id'] = 'all';
							$overlay['validfor'][ $otw_sbi_item ]['all']['type'] = 'global';
							$overlay['validfor'][ $otw_sbi_item ]['all']['exclude'] = '';
						}
						//save excluded posts for some types
						if( otw_post( 'otw_exclude_posts_'.$otw_sbi_item, false ) && strlen( otw_post( 'otw_exclude_posts_'.$otw_sbi_item, '' ) ) ){
							if( !isset( $overlay['exclude_posts_for'] ) ){
								$overlay['exclude_posts_for'] = array();
							}
							$overlay['exclude_posts_for'][ $otw_sbi_item ] = otw_post( 'otw_exclude_posts_'.$otw_sbi_item, '' );
						}elseif( isset( $overlay['exclude_posts_for'] ) && isset( $overlay['exclude_posts_for'][ $otw_sbi_item ] ) ){
							unset( $overlay['exclude_posts_for'][ $otw_sbi_item ] );
						}
					}
					
					if( $otw_overlay_id === false ){
						
						$otw_overlay_id = 'otw-overlay-'.( otw_get_next_overlay_id() );
						$overlay['id'] = $otw_overlay_id;
					}
					
					$otw_overlays[ $otw_overlay_id ] = $overlay;
					
					if( !otw_save_overlays( $otw_overlays ) && $wpdb->last_error ){
						
						$valid_page = false;
						$validate_messages[] = esc_html__( 'DB Error: ', 'otw_pc' ).$wpdb->last_error.'. Tring to save '.strlen( maybe_serialize( $otw_overlays ) ).' bytes.';
					}else{
						wp_redirect( 'admin.php?page=otw-pc-manage&action=edit&overlay='.$otw_overlay_id.'&message=1' );
					}
				}
			break;
		case 'manage_otw_pc_import_shortcode_field_option':
				global $validate_messages;
				
				$validate_messages = array();
				
				$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );
				
				if( !is_array( $otw_pc_import_shortcodes ) ){
					$otw_pc_import_shortcodes = array();
				}
				
				$otw_import_shortcode_key = '';
				
				if( otw_get('import_shortcode',false) && strlen( trim( otw_get( 'import_shortcode', '' ) ) ) ){
					$otw_import_shortcode_key = otw_get( 'import_shortcode', '' );
				}
				
				$otw_import_shortcode_field_key = '';
				
				if( otw_get( 'import_shortcode_field', false ) && strlen( trim( otw_get( 'import_shortcode_field', '' ) ) ) ){
					$otw_import_shortcode_field_key = otw_get( 'import_shortcode_field', '' );
				}
				
				$valid_page = true;
				
				if( !isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ] ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Invalid imported shortcode', 'otw_pc' );
				}elseif( !isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $otw_import_shortcode_field_key ] ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Invalid imported shortcode field', 'otw_pc' );
				}
				
				if( $valid_page ){
					if( !otw_post( 'otw_import_shortcode_field_option_key', false ) || !strlen( trim( otw_post( 'otw_import_shortcode_field_option_key', '' ) ) ) ){
						$valid_page = false;
						$validate_messages[] = esc_html__( 'Please type valid option value', 'otw_pc' );
					}
					if( !otw_post( 'otw_import_shortcode_field_option_name', false ) || !strlen( trim( otw_post( 'otw_import_shortcode_field_option_name', '' ) ) ) ){
						$valid_page = false;
						$validate_messages[] = esc_html__( 'Please type valid option name', 'otw_pc' );
					}
				}
				
				if( $valid_page ){
				
					$option_edit_key = '';
					if( otw_post( 'otw_import_shortcode_field_option_edit', false ) ){
						$option_edit_key = otw_post( 'otw_import_shortcode_field_option_edit', '' );
					}
					
					if( !isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $otw_import_shortcode_field_key ]['options'] ) ){
						$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $otw_import_shortcode_field_key ]['options'] = array();
					}
					
					if( $option_edit_key && ( $option_edit_key != otw_post( 'otw_import_shortcode_field_option_key', '' ) ) && isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $otw_import_shortcode_field_key ]['options'][ $option_edit_key ] ) ){
						unset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $otw_import_shortcode_field_key ]['options'][ $option_edit_key ] );
					}
					
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $otw_import_shortcode_field_key ]['options'][ otw_post( 'otw_import_shortcode_field_option_key', '' ) ] = otw_post( 'otw_import_shortcode_field_option_name', '' );
					
					update_option( 'otw_import_shortcodes', $otw_pc_import_shortcodes );
					
					wp_redirect( 'admin.php?page=otw-pc-import-shortcodes-fields-options&import_shortcode='.urlencode( $otw_import_shortcode_key ).'&import_shortcode_field='.urlencode( $otw_import_shortcode_field_key ).'&message=1' );
				}
			break;
		case 'delete_otw_pc_import_shortcode_field':
				
				$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );
				
				if( !is_array( $otw_pc_import_shortcodes ) ){
					$otw_pc_import_shortcodes = array();
				}
				
				$otw_import_shortcode_key = '';
				
				if( otw_get('import_shortcode',false) && strlen( trim( otw_get( 'import_shortcode', '' ) ) ) ){
					$otw_import_shortcode_key = otw_get( 'import_shortcode', '' );
				}
				
				if( isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ] ) ){
					
					if( otw_post( 'otw_import_shortcode_field_key', false ) && isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ otw_post( 'otw_import_shortcode_field_key', '' ) ] ) ){
					
						unset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ otw_post( 'otw_import_shortcode_field_key', '' ) ] );
						
						update_option( 'otw_import_shortcodes', $otw_pc_import_shortcodes );
					}
				}
				wp_redirect( 'admin.php?page=otw-pc-import-shortcodes-fields&import_shortcode='.urlencode( $otw_import_shortcode_key ).'&message=1' );
				
			break;
		case 'manage_otw_pc_import_shortcode_field':
				global $validate_messages;
				
				$validate_messages = array();
				
				$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );
				
				if( !is_array( $otw_pc_import_shortcodes ) ){
					$otw_pc_import_shortcodes = array();
				}
				
				$otw_import_shortcode_key = '';
				
				if( otw_get('import_shortcode',false) && strlen( trim( otw_get( 'import_shortcode', '' ) ) ) ){
					$otw_import_shortcode_key = otw_get( 'import_shortcode', '' );
				}
				
				$valid_page = true;
				
				if( !isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ] ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Invalid imported shortcode', 'otw_pc' );
				}
				if( $valid_page ){
					if( !otw_post( 'otw_import_shortcode_field_name', false ) || !strlen( trim( otw_post( 'otw_import_shortcode_field_name', '' ) ) ) ){
						$valid_page = false;
						$validate_messages[] = esc_html__( 'Please type valid field name', 'otw_pc' );
					}
					if( !otw_post( 'otw_import_shortcode_field_key', false ) || !strlen( trim( otw_post( 'otw_import_shortcode_field_key', '' ) ) ) ){
						$valid_page = false;
						$validate_messages[] = esc_html__( 'Please type valid field key', 'otw_pc' );
					}elseif( otw_post( 'otw_import_shortcode_field_key', false ) && !preg_match( "/^([0-9a-zA-Z\-\_]+)$/", otw_post( 'otw_import_shortcode_field_key', '' ) ) ){
						$valid_page = false;
						$validate_messages[] = esc_html__( 'Please type valid field key', 'otw_pc' );
					}
				}
				
				if( $valid_page ){
				
					$field_edit_key = '';
					if( otw_post( 'otw_import_shortcode_field_edit', false ) ){
						$field_edit_key = otw_post( 'otw_import_shortcode_field_edit', '' );
					}
					
					$field_key = otw_post( 'otw_import_shortcode_field_key', '' );
					if( !isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'] ) ){
						$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'] = array();
					}
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_key ] = array();
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_key ]['key'] = otw_post( 'otw_import_shortcode_field_key', '' );
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_key ]['name'] = otw_post( 'otw_import_shortcode_field_name', '' );
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_key ]['description'] = otw_post( 'otw_import_shortcode_field_description', '' );
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_key ]['type'] = otw_post( 'otw_import_shortcode_field_type', '' );
					$otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_key ]['default_value'] = otw_post( 'otw_import_shortcode_field_default_value', '' );
					
					if( $field_edit_key && ( $field_edit_key != $field_key ) && isset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_edit_key ] ) ){
						unset( $otw_pc_import_shortcodes[ $otw_import_shortcode_key ]['params'][ $field_edit_key ] );
					}
					
					update_option( 'otw_import_shortcodes', $otw_pc_import_shortcodes );
					
					wp_redirect( 'admin.php?page=otw-pc-import-shortcodes-fields&import_shortcode='.urlencode( $otw_import_shortcode_key ).'&message=1' );
				}
			break;
		case 'delete_otw_pc_import_shortcode':
				
				$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );
				
				if( !is_array( $otw_pc_import_shortcodes ) ){
					$otw_pc_import_shortcodes = array();
				}
				
				if( $otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ] ){
					unset( $otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ] );
				}
				
				update_option( 'otw_import_shortcodes', $otw_pc_import_shortcodes );
				
				wp_redirect( 'admin.php?page=otw-pc-import-shortcodes&message=1' );
			break;
		case 'manage_otw_pc_import_shortcode':
				global $validate_messages;
				
				$validate_messages = array();
				
				$otw_pc_import_shortcodes = get_option( 'otw_import_shortcodes' );
				
				if( !is_array( $otw_pc_import_shortcodes ) ){
					$otw_pc_import_shortcodes = array();
				}
				
				$valid_page = true;
				
				if( !otw_post( 'otw_import_shortcode_title', false ) || !strlen( trim( otw_post( 'otw_import_shortcode_title', '' ) ) ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Please type valid shortcode name', 'otw_pc' );
				}
				if( !otw_post( 'otw_import_shortcode_key', false ) || !strlen( trim( otw_post( 'otw_import_shortcode_key', '' ) ) ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Please type valid shortcode key', 'otw_pc' );
				}elseif( otw_post( 'otw_import_shortcode_key', false ) && !preg_match( "/^([0-9a-zA-Z\-\_]+)$/", otw_post( 'otw_import_shortcode_key', '' ) ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'Please type valid shortcode key', 'otw_pc' );
				}elseif( otw_post( 'otw_import_shortcode_edit', false ) && !otw_post( 'otw_import_shortcode_edit', '' ) && array_key_exists( otw_post( 'otw_import_shortcode_key', '' ), $otw_pc_import_shortcodes ) ){
					$valid_page = false;
					$validate_messages[] = esc_html__( 'This shortcode already exists', 'otw_pc' );
				}
				
				if( $valid_page ){
					
					$tmp_shortcodes = $otw_pc_import_shortcodes;
					
					$otw_pc_import_shortcodes = array();
					
					$is_new = true;
					
					foreach( $tmp_shortcodes as $cs_key => $cs_data ){
						
						if( otw_post( 'otw_import_shortcode_edit', false ) && otw_post( 'otw_import_shortcode_edit', '' ) && ( otw_post( 'otw_import_shortcode_edit', '' ) == $cs_key ) ){
							$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ] = $cs_data;
							$is_new = false;
						}else{
							$otw_pc_import_shortcodes[ $cs_key ] = $cs_data;
						}
					}
					
					if( $is_new ){
						$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ] = array();
						$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ]['title'] = otw_post( 'otw_import_shortcode_title', '' );
						$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ]['content'] = otw_post( 'otw_import_shortcode_content', '' );
						$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ]['params'] = array();
					}else{
						$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ]['content'] = otw_post( 'otw_import_shortcode_content', '' );
						$otw_pc_import_shortcodes[ otw_post( 'otw_import_shortcode_key', '' ) ]['title'] = otw_post( 'otw_import_shortcode_title', '' );
					}
					update_option( 'otw_import_shortcodes', $otw_pc_import_shortcodes );
					
					wp_redirect( 'admin.php?page=otw-pc-import-shortcodes&message=1' );
				}
			break;
		case 'manage_otw_pc_options':
				
				$upload_dir = wp_upload_dir();
				
				global $wp_filesystem;
				
				if( otw_init_filesystem() ){
					
					if( isset( $upload_dir['basedir'] ) && $wp_filesystem->is_writable( $upload_dir['basedir'] ) ){
						
						global $otw_pc_custom_css_path;
						
						if( otw_post( 'otw_pc_custom_css', false ) && strlen( trim( otw_post( 'otw_pc_custom_css', '' ) ) ) ){
						
							if( isset( $upload_dir['basedir'] ) && $wp_filesystem->is_writable( $upload_dir['basedir'] ) ){
								
								if( !$wp_filesystem->is_dir( $upload_dir['basedir'].'/otwpc' ) ){
									$wp_filesystem->mkdir( $upload_dir['basedir'].'/otwpc' );
								}
							}
							
							if( $wp_filesystem->is_dir( $upload_dir['basedir'].'/otwpc' ) && $wp_filesystem->is_writable( $upload_dir['basedir'].'/otwpc' ) ){
							
								$wp_filesystem->put_contents( $otw_pc_custom_css_path, otw_stripslashes( otw_post( 'otw_pc_custom_css', '' ) ) );
							}
						}elseif( $wp_filesystem->exists( $otw_pc_custom_css_path ) ){
							$wp_filesystem->delete( $otw_pc_custom_css_path );
						}
					}
				}
				
				if( otw_post( 'otw_pc_promotions', false ) && !empty( otw_post( 'otw_pc_promotions', '' ) ) ){
					
					global $otw_pc_factory_object, $otw_pc_plugin_id;
					
					update_option( $otw_pc_plugin_id.'_dnms', otw_post( 'otw_pc_promotions', '' ) );
					
					if( is_object( $otw_pc_factory_object ) ){
						$otw_pc_factory_object->retrive_plungins_data( true );
					}
				}
				
				wp_redirect( admin_url( 'admin.php?page=otw-pc-options&message=1' ) );
			break;


	}
}
