'use strict';

var otw_pc_items = {};
var otw_pc_periods_dialog = false;

jQuery(document).ready(function() {
	init_manage_page();
});
function init_manage_page(){
	
	var s_labels = jQuery( '.otw_overlay_item_filter label' ).on( 'click',   function( event ){
		event.preventDefault();
		otw_select_sitem( this );
	} );
	
	jQuery( '#type' ).on( 'change',  function(){
		
		var overlay_options = jQuery( 'div.otw_overlay_options' );
		
		overlay_options.removeClass( 'otw_overlay_openened' );
		
		if( this.value ){
			jQuery( '#otw_overlay_options_' + this.value ).addClass( 'otw_overlay_openened' );
		};
	} );
	
	jQuery( '#otw_overlay_options_' + jQuery( '#type' ).val() ).addClass( 'otw_overlay_openened' );
	
	jQuery( '#full_bar_position, #side_box_position' ).on( 'change',  function(){
		
		set_default_content_width( jQuery( this ) );
	} );
	set_default_content_width( jQuery( '#full_bar_position' ) );
	set_default_content_width( jQuery( '#side_box_position' ) );
	
	jQuery( '#side_box_position' ).on( 'change',  function(){
		
		set_height_from_top_and_bottom();
	} );
	
	set_height_from_top_and_bottom();
	
	jQuery( '.otw_pc_global_manage_settings a' ).on( 'click',  function(){
		
		var action = '';
		
		switch( jQuery( this ).attr( 'class' ) ){
		
			case 'otw_all_global_manage_vis':
					action = 'all';
				break;
			case 'otw_all_global_manage_invis':
					action = 'none';
				break;
		}
		
		jQuery( '.sitems' ).each( function(){
		
			var box = jQuery( this );
			
			var b_matches = false;
			
			var item_type = '';
			if( b_matches = box.attr( 'id' ).match( /^otw_pc_type_(.*)$/ ) ){
			
				item_type = b_matches[1];
			}
			
			if( item_type != 'userroles' ){
			
				switch( action ){
				
					case 'all':
							box.removeClass( 'otw_closed' );
							box.parents( 'div.postbox' ).removeClass( 'closed' );
							
							box.find( 'a.otw_pc_select_all_items' ).click();
						break;
					case 'none':
							box.find( 'a.otw_pc_unselect_all_items' ).click();
						break;
				}
			}
		} );
		
	} );
	
	jQuery( '.sitems .otw_pc_validfor' ).each( function(){
		
		var valid_handler = jQuery( this );
		var matches = false;
		
		if( matches = valid_handler.attr( 'id' ).match( /^otw_pc_type_(.*)_validfor$/ ) )
		{
			var values = valid_handler.val().split( ',' );
			
			if( values.length )
			{
				otw_pc_items[ matches[1] ] = {};
				for( var cV = 0; cV < values.length; cV++ )
				{
					if( values[ cV ].length )
					{
						otw_pc_items[ matches[1] ][ values[ cV ] ] = true;
					};
				};
				otw_display_selected_items( matches[1] );
			};
		};
	} );
	
	jQuery('#otw-col-right').find('.sitem_toggle, .sitem_header').on( 'click', function() {
		jQuery(this).parent().find( '.inside').toggleClass('otw_closed');
		jQuery(this).parent().toggleClass('closed');
	});
	
	jQuery( '.otw_info_box .otw_info_box_controls a' ).on( 'click',  function(){
	
		var matches = false;
		
		var link = jQuery( this );
		
		var info_box = link.parent().parent();
		
		if( matches = link.attr( 'class' ).match( /otw_(open|close)_info_box/ ) ){
			var post_params = {};
			post_params.type = 'page';
			post_params.page = 'otw-pc-manage';
			post_params.setting = 'infobox';
			
			switch( matches[1] ){
			
				case 'open':
						info_box.removeClass( 'otw_ib_closed' ).addClass( 'otw_ib_open' );
						post_params.value = 'open';
					break;
				default:
						info_box.removeClass( 'otw_ib_open' ).addClass( 'otw_ib_closed' );
						post_params.value = 'closed';
					break;
			}
			
			var req_url = 'admin-ajax.php?action=otw_pc_admin_settings';
			
			var settings = {
				url: req_url,
				type: 'post',
				data: post_params
			};
			jQuery.ajax( settings );
		}
	} )
	
	jQuery( '.otw_info_box .otw_info_box_content a.otw_scrollto' ).on( 'click',  function(){
	
		var link = jQuery( this );
		
		if( link.attr( 'rel' ).match( /^otw_options_(.*)$/ ) ){
			
			jQuery( '.otw_overlay_openened .' + link.attr( 'rel' ) ).each( function(){
			
				var node = jQuery( this );
				
				if( node.css( 'display' ) == 'block' ){
					
					jQuery('html, body').animate({
						scrollTop: ( node.offset().top - 30 )
					}, 1000 );
				}
			
			});
		}else if( link.attr( 'rel' ) == 'otw-visbitily-header' ){
		
			jQuery( '.otw-visbitily-header' ).each( function(){
			
				var node = jQuery( this );
				
				if( node.css( 'display' ) == 'block' ){
					
					jQuery('html, body').animate({
						scrollTop: ( node.offset().top - 30 )
					}, 1000 );
				}
			
			});
		}else if( link.attr( 'rel' ) == 'otw_grid_manager_content' ){
		
			jQuery( '#otw_grid_manager_content' ).each( function(){
			
				var node = jQuery( this );
				
				jQuery('html, body').animate({
					scrollTop: ( node.offset().top - 30 )
				}, 1000 );
			
			});
		}
	});
	
	jQuery('#otw-col-left').find('.sitem_toggle, .sitem_header').on( 'click', function() {
	
		
		if( jQuery(this).parent().attr( 'data-type' ) ){
			
			var post_params = {};
			post_params.type = 'page';
			post_params.page = 'otw-pc-manage';
			post_params.setting = 'metabox_' + jQuery(this).parent().attr( 'data-type' )
			if( jQuery(this).parent().find( '.inside').hasClass( 'otw_closed' ) ){
				post_params.value = 'open';
			}else{
				post_params.value = 'closed';
			}
			var req_url = 'admin-ajax.php?action=otw_pc_admin_settings';
			
			var settings = {
				url: req_url,
				type: 'post',
				data: post_params
			};
			jQuery.ajax( settings );
		}
		jQuery(this).parent().find( '.inside').toggleClass('otw_closed');
		jQuery(this).parent().toggleClass('closed');
	});
	
	
	jQuery('input.otw_pc_q_filter').focus( function(){
		this.value='';
	});
	jQuery('input.otw_pc_q_filter').keyup( function( event ){
		var search_box = jQuery( this );
		try{
			clearTimeout( window.otw_q_filter_timeout );
		}catch(e){}
		
		if (event.which == 13) {
			event.stopPropagation();
			event.preventDefault();
		}
		window.otw_q_filter_timeout = setTimeout( function(){otw_pc_man_filter_wp_items( search_box )}, 300 );
	});
	jQuery('input.otw_pc_q_filter').keydown( function( event ){
		
		var search_box = jQuery( this );
		try{
			clearTimeout( window.otw_q_filter_timeout );
		}catch(e){}
		if (event.which == 13) {
			event.stopPropagation();
			event.preventDefault();
		}
		window.otw_q_filter_timeout = setTimeout( function(){otw_pc_man_filter_wp_items( search_box )}, 300 );
		
	});
	jQuery('div.otw_overlay_filter_order select').on( 'change',  function( event ){
		
		otw_pc_man_filter_wp_items( jQuery( this ) );
	});
	jQuery('div.otw_overlay_filter_show select').on( 'change',  function( event ){
		
		otw_pc_man_filter_wp_items( jQuery( this ) );
	});
	jQuery('div.otw_overlay_filter_clear a').on( 'click',  function( event ){
		
		var a_matches = false;
		if( a_matches = this.id.match( /^otw_type_(.*)_clear$/ ) )
		{
			jQuery( '#otw_type_' + a_matches[1] + '_search_field' ).val( '' );
			jQuery( '#otw_type_' + a_matches[1] + '_show_field' ).val( 'all' );
			jQuery( '#otw_type_' + a_matches[1] + '_order_field' ).val( 'a_z' );
			jQuery( '#otw_type_' + a_matches[1] + '_page_field' ).val( '0' );
			
			jQuery( '#otw_type_' + a_matches[1] + '_per_page_field' ).attr( 'id', 'otw_type_' + a_matches[1] + '_per_page_field_old' );
			
			otw_pc_man_filter_wp_items( jQuery( this ) );
		};
	});
	jQuery( 'a.otw_pc_select_all_items' ).on( 'click',  function(){
		
		var link = jQuery( this );
		var item_type = link.attr( 'rel' );
		
		if( item_type ){
		
			jQuery( '#otw_pc_type_' + item_type +' .f_items p' ).addClass( 'sitem_loading' );
			
			var req_url = 'admin-ajax.php?action=otw_pc_items_by_type';
			
			var post_params = { string_filter: '', type: item_type, format: 'ids' };
			
			var settings = {
				url: req_url,
				type: 'post',
				data: post_params,
				success:function( data ){
					
					otw_pc_items[ item_type ][ 'all' ] = true;
					
					var t_data = data.trim().split( ',' );
					
					for( var tCD = 0; tCD < t_data.length; tCD++ ){
						if( t_data[ tCD ].length )
						{
							otw_pc_items[ item_type ][ t_data[ tCD ] ] = true;
						};
					};
					
					jQuery( '#otw_pc_type_' + item_type +' .f_items p' ).removeClass( 'sitem_loading' );
					
					otw_display_selected_items( item_type, true );
				}
			};
			jQuery.ajax( settings );
		};
	});
	jQuery( 'a.otw_pc_unselect_all_items' ).on( 'click',  function(){
		
		var link = jQuery( this );
		var item_type = link.attr( 'rel' );
		
		if( item_type ){
			
			otw_pc_items[ item_type ][ 'all' ] = false;
			otw_display_selected_items( item_type, true );
		};
	});
	
	otw_pc_init_periods_tables();
	
	otw_pc_init_periods_dialog();
	
	otw_pc_init_items();
};

function otw_pc_init_periods_tables(){
	
	var values = jQuery( '.otw_active_periods_value' );
	
	for( var cV = 0; cV < values.length; cV++ ){
	
		otw_pc_build_active_period_table( values[ cV ].id );
	}
}

function otw_pc_build_active_period_table( type ){

	var container = jQuery( '#' + type + '_table tbody' );
	
	container.html( '...' );
	
	var value = jQuery( '#' + type ).val();
	
	var table_html = '<tr><td colspan="6">No active periods defined</td></tr>';
	
	if( value.length ){
	
		var object = jQuery.parseJSON( value );
		
		table_html = '';
		
		for( var cO = 0; cO < object.length; cO++){
		
			table_html = table_html + '<tr>';
			
			table_html = table_html + '<td>';
			
			if( object[cO].period_from_now == '1' ){
				table_html = table_html + otw_pc_labels['now'];
			}else{
				table_html = table_html + object[cO].period_from_date;
			}
			
			table_html = table_html + '</td>';
			
			table_html = table_html + '<td>';
			
			if( object[cO].period_to_never == '1' ){
				table_html = table_html + otw_pc_labels['never'];
			}else{
				table_html = table_html + object[cO].period_to_date;
			}
			
			table_html = table_html + '</td>';
			
			table_html = table_html + '<td>';
			
			if( object[cO].days.length == 0 ){
				table_html = table_html + otw_pc_labels['every_day'];
			}else{
				for( var cD = 0; cD < object[cO].days.length; cD++ ){
					table_html = table_html + otw_pc_labels[ 'dname' + object[cO].days[cD] ];
					
					if( ( cD + 1 ) < object[cO].days.length ){
						table_html = table_html + ', ';
					}
				}
			}
			
			table_html = table_html + '</td>';
			
			table_html = table_html + '<td>';
			
			if( object[cO].period_time_all == '1' ){
				table_html = table_html + otw_pc_labels['all_time'];
			}else{
				table_html = table_html + object[cO].period_from_hour + ':' + object[cO].period_from_min + object[cO].period_from_mer + ' - ';
				table_html = table_html + object[cO].period_to_hour + ':' + object[cO].period_to_min + object[0].period_to_mer;
			}
			
			table_html = table_html + '</td>';
			
			table_html = table_html + '<td>';
			table_html = table_html + '<a class="otw-period-control-edit" href="javascript:;" onClick="return otw_edit_active_period( this, \'' + type + '\', ' + cO + ');"></a>';
			table_html = table_html + '</td>';
			
			table_html = table_html + '<td>';
			table_html = table_html + '<a class="otw-period-control-delete" href="javascript:;" onClick="return otw_delete_active_period( \'' + type + '\',' + cO + ');"></a>';
			table_html = table_html + '</td>';
			
			table_html = table_html + '</tr>';
		}
		
	}
	
	container.html( table_html );
}

function otw_pc_init_periods_dialog(){

	otw_pc_periods_dialog = jQuery( '#otw_periods_dialog' );
	
	jQuery( '#otw_close_periods' ).on( 'click',  function(){
		tb_remove();
	});
	
	jQuery( '#otw_save_periods' ).on( 'click',  function(){
		
		var period_data = {};
		
		if( jQuery( '#period_from_now' )[0].checked ){
			period_data.period_from_now = 1;
		}else{
			period_data.period_from_now = 0;
		}
		period_data.period_from_date = jQuery( '#period_from_date' ).val();
		
		if( jQuery( '#period_to_never' )[0].checked ){
			period_data.period_to_never = 1;
		}else{
			period_data.period_to_never = 0;
		}
		period_data.period_to_date = jQuery( '#period_to_date' ).val();
		
		var period_days = jQuery( 'input.period_day' );
		
		period_data.days = new Array();
		
		for( var cP = 0; cP < period_days.length; cP++ ){
		
			if( period_days[ cP ].checked ){
				
				period_data.days[ period_data.days.length ] = period_days[ cP ].value;
			}
		}
		
		if( jQuery( '#period_time_all' )[0].checked ){
			period_data.period_time_all = 1;
		}else{
			period_data.period_time_all = 0;
		}
		
		period_data.period_from_hour = jQuery( '#period_from_hour' ).val();
		period_data.period_from_min  = jQuery( '#period_from_min' ).val();
		period_data.period_from_mer  = jQuery( '#period_from_mer' ).val();
		
		period_data.period_to_hour = jQuery( '#period_to_hour' ).val();
		period_data.period_to_min  = jQuery( '#period_to_min' ).val();
		period_data.period_to_mer  = jQuery( '#period_to_mer' ).val();
		
		otw_pc_periods_dialog.periods[ otw_pc_periods_dialog.period_id ] = period_data;
		
		jQuery( '#' + otw_pc_periods_dialog.type + '_active_periods'  ).val( JSON.stringify( otw_pc_periods_dialog.periods ) )
		
		tb_remove();
		
		otw_pc_build_active_period_table( otw_pc_periods_dialog.type + '_active_periods' );
	});
	
	jQuery( '.otw-datetimepicker' ).datetimepicker( {format: 'd.m.Y H:i' } );
	
	jQuery( '.add_active_periods').on( 'click',  function(){
		
		var matches = false;
		
		if( matches = this.id.match( /^add_ap_(.*)_active_periods$/ ) ){
			
			var position = jQuery( this ).position();
			
			otw_pc_periods_dialog.type = matches[1];
			
			if( jQuery( '#' + otw_pc_periods_dialog.type + '_active_periods'  ).val() ){
				otw_pc_periods_dialog.periods = jQuery.parseJSON( jQuery( '#' + otw_pc_periods_dialog.type + '_active_periods'  ).val() );
			}else{
				otw_pc_periods_dialog.periods = new Array();
			}
			otw_pc_periods_dialog.period_id = otw_pc_periods_dialog.periods.length;
			
			otw_pc_periods_dialog.find( '#period_from_now' )[0].checked = true;
			otw_pc_periods_dialog.find( '#period_from_date' ).val( '' );
			
			otw_pc_periods_dialog.find( '#period_to_never' )[0].checked = true;
			
			otw_pc_periods_dialog.find( '#period_to_date' ).val( '' );
			
			otw_pc_periods_dialog.find( '.period_day' )[0].checked = false;
			
			otw_pc_periods_dialog.find( '#period_time_all' )[0].checked = true;
			
			otw_pc_periods_dialog.find( '#period_from_hour' ).val( '00' );
			otw_pc_periods_dialog.find( '#period_from_min' ).val( '00' );
			otw_pc_periods_dialog.find( '#period_from_mer' ).val( 'am' );
			
			otw_pc_periods_dialog.find( '#period_to_hour' ).val( '00' );
			otw_pc_periods_dialog.find( '#period_to_min' ).val( '00' );
			otw_pc_periods_dialog.find( '#period_to_mer' ).val( 'am' );
			
			otw_open_periods_dialog();
		}
	} );
}

function otw_open_periods_dialog(){
	
	tb_position = function(){
	
		var isIE6 = typeof document.body.style.maxHeight === "undefined";
		var b=jQuery(window).height();
		jQuery("#TB_window").css({marginLeft: '-' + parseInt((TB_WIDTH / 2),10) + 'px', width: TB_WIDTH + 'px'});
		jQuery("#TB_window").css( 'top', ( b / 2 ) - (  TB_HEIGHT / 2 ) );
	}
	
	jQuery( window ).resize( function(){
		tb_position();
	} );
	
	var f=jQuery(window).width();
	var b=jQuery(window).height();
	f=850<f?850:f;
	f-=80;
	b=760<b?760:b;
	b-=110; 
	
	tb_show( otw_pc_labels['period_dialog_title'], "#TB_inline?width=" + f + "height=" + b + "&inlineId=otw_periods_dialog_wrapper"  );
}

function otw_delete_active_period( type, pid ){
	
	if( confirm( otw_pc_labels['confirm_delete_period'] ) ){
		var matches = false;
		
		if( matches = type.match( /^(.*)_active_periods$/ ) ){
			
			if( jQuery( '#' + type  ).val() ){
				var periods = jQuery.parseJSON( jQuery( '#' + type ).val() );
				
				var new_periods = new Array();
				
				for( var cP = 0; cP < periods.length; cP++ ){
				
					if( cP != pid ){
						new_periods[ new_periods.length ] = periods[cP];
					}
				}
				
				jQuery( '#' + type ).val( JSON.stringify( new_periods ) );
			}
			otw_pc_build_active_period_table( type );
		}
	}
}
function otw_edit_active_period( link, type, pid ){
	
	var matches = false;
	
	if( matches = type.match( /^(.*)_active_periods$/ ) ){
		
		var position = jQuery( link ).parent().position();
		
		otw_pc_periods_dialog.type = matches[1];
		
		if( jQuery( '#' + otw_pc_periods_dialog.type + '_active_periods'  ).val() ){
			otw_pc_periods_dialog.periods = jQuery.parseJSON( jQuery( '#' + otw_pc_periods_dialog.type + '_active_periods'  ).val() );
		}else{
			otw_pc_periods_dialog.periods = new Array();
		}
		
		otw_pc_periods_dialog.period_id = pid;
		
		if( otw_pc_periods_dialog.periods[ pid ].period_from_now == '1' ){
			otw_pc_periods_dialog.find( '#period_from_now' )[0].checked = true;
		}else{
			otw_pc_periods_dialog.find( '#period_from_now' )[0].checked = false;
		}
		
		otw_pc_periods_dialog.find( '#period_from_date' ).val( otw_pc_periods_dialog.periods[ pid ].period_from_date );
		
		if( otw_pc_periods_dialog.periods[ pid ].period_to_never == '1' ){
			otw_pc_periods_dialog.find( '#period_to_never' )[0].checked = true;
		}else{
			otw_pc_periods_dialog.find( '#period_to_never' )[0].checked = false;
		}
		
		otw_pc_periods_dialog.find( '#period_to_date' ).val( otw_pc_periods_dialog.periods[ pid ].period_to_date );
		
		otw_pc_periods_dialog.find( '.period_day' )[0].checked = false;
		
		for( var cD = 0; cD < otw_pc_periods_dialog.periods[ pid ].days.length; cD++ ){
			switch( otw_pc_periods_dialog.periods[ pid ].days[cD] ){
			
				case '1':
						otw_pc_periods_dialog.find( '#period_day_mon' )[0].checked = true;
					break;
				case '2':
						otw_pc_periods_dialog.find( '#period_day_tue' )[0].checked = true;
					break;
				case '3':
						otw_pc_periods_dialog.find( '#period_day_wed' )[0].checked = true;
					break;
				case '4':
						otw_pc_periods_dialog.find( '#period_day_thu' )[0].checked = true;
					break;
				case '5':
						otw_pc_periods_dialog.find( '#period_day_fri' )[0].checked = true;
					break;
				case '6':
						otw_pc_periods_dialog.find( '#period_day_sat' )[0].checked = true;
					break;
				case '0':
						otw_pc_periods_dialog.find( '#period_day_sun' )[0].checked = true;
					break;
			}
			
		}
		
		if( otw_pc_periods_dialog.periods[ pid ].period_time_all == '1' ){
			otw_pc_periods_dialog.find( '#period_time_all' )[0].checked = true;
		}else{
			otw_pc_periods_dialog.find( '#period_time_all' )[0].checked = false;
		}
		
		otw_pc_periods_dialog.find( '#period_from_hour' ).val( otw_pc_periods_dialog.periods[ pid ].period_from_hour );
		otw_pc_periods_dialog.find( '#period_from_min' ).val( otw_pc_periods_dialog.periods[ pid ].period_from_min );
		otw_pc_periods_dialog.find( '#period_from_mer' ).val( otw_pc_periods_dialog.periods[ pid ].period_from_mer );
		
		otw_pc_periods_dialog.find( '#period_to_hour' ).val( otw_pc_periods_dialog.periods[ pid ].period_to_hour );
		otw_pc_periods_dialog.find( '#period_to_min' ).val( otw_pc_periods_dialog.periods[ pid ].period_to_min );
		otw_pc_periods_dialog.find( '#period_to_mer' ).val( otw_pc_periods_dialog.periods[ pid ].period_to_mer );
		
		otw_open_periods_dialog();
	}
}

function set_height_from_top_and_bottom(){

	var position = jQuery( '#side_box_position' ).val();
	
	switch( position ){
	
		case 'otw-right-sticky':
		case 'otw-left-sticky':
				jQuery( '#side_box_height_from_top' ).parent().show();
				jQuery( '#side_box_height_from_bottom' ).parent().show();
			break;
		default:
				jQuery( '#side_box_height_from_top' ).parent().hide();
				jQuery( '#side_box_height_from_bottom' ).parent().hide();
			break;
	}
}
function set_default_content_width( position_node ){
	
	var ov_id = jQuery( '#otw_overlay_id' ).val();
	
	if( ov_id == '0' ){
		
		var type = '';
		
		var matches = false;
		
		if( matches = position_node.attr( 'name' ).match( /^(.*)_position$/ ) ){
			type = matches[1];
		}
		
		if( type ){
			
			var default_val = '';
			switch( position_node.val() ){
			
				case 'otw-top-sticky':
				case 'otw-bottom-sticky':
						
						switch( type ){
						
							case 'full_bar':
							case 'side_box':
									default_val = 600;
								break;
						}
						
					break;
				case 'otw-left-sticky':
				case 'otw-right-sticky':
						
						switch( type ){
						
							case 'full_bar':
							case 'side_box':
									default_val = 400;
								break;
						}
						
					break;
			}
			if( jQuery( '#' + type + '_content_width' ).size() ){
				jQuery( '#' + type + '_content_width' ).val( default_val );
			};
		};
	};
	
}
function otw_pc_man_filter_wp_items( search_box ){

	var bar = search_box.parents( '.sitems' );
	
	var matches = false;
	
	if( matches = bar.attr( 'id' ).match( /^otw_pc_type_(.*)$/ ) ){
		otw_pc_load_items( matches[1] , bar );
	};
};
function otw_pc_init_items(){

	var bars = jQuery( '#otw-col-right' ).find( 'div.sitems' );
	
	if( bars.size() ){
		for( var cB = 0; cB < bars.size(); cB++ ){
			
			var matches = false;
			
			if( matches = jQuery( bars[cB] ).attr( 'id' ).match( /^otw_pc_type_(.*)$/ ) ){
				otw_pc_load_items( matches[1] , bars[cB] );
			};
		};
	};
};
function otw_pc_load_items( item_type, item_node ){

	var post_params = { string_filter: '', type: item_type, show: 'all', order: 'a_z', page: 0 };
	
	var overlay_id = jQuery( '#otw-col-right' ).attr( 'class' );
	
	var matches = false;
	if( matches = overlay_id.match( /^otw_pc_([a-z0-9\-]+)$/ ) )
	{
		post_params['overlay'] = matches[1];
	}
	post_params.string_filter = jQuery( '#otw_type_' + item_type + '_search_field' ).val();
	post_params.show = jQuery( '#otw_type_' + item_type + '_show_field' ).val();
	post_params.order = jQuery( '#otw_type_' + item_type + '_order_field' ).val();
	post_params.page = jQuery( '#otw_type_' + item_type + '_page_field' ).val();
	
	if( jQuery( '#otw_type_' + item_type + '_per_page_field' ).size() ){
		post_params.per_page = jQuery( '#otw_type_' + item_type + '_per_page_field' ).val();
	}
	
	jQuery( '#otw_type_' + item_type + '_filter' ).addClass( 'sitem_loading' );
	
	var req_url = 'admin-ajax.php?action=otw_pc_items_by_type';
	
	var settings = {
		url: req_url,
		type: 'post',
		data: post_params,
		success:function( data ){
			
			var t_data = data.trim();
			jQuery( item_node ).find( 'div.a_item' ).html( t_data );
			jQuery( item_node ).find( 'div.a_item label' ).on( 'click',   function( event ){
				event.preventDefault();
				otw_select_sitem( this );
			} );
			otw_init_item_pager( item_type );
			otw_display_selected_items( item_type );
			jQuery( '#otw_type_' + item_type + '_filter' ).removeClass( 'sitem_loading' );
		}
	};
	
	jQuery.ajax( settings );
};
function otw_init_item_pager( item_type ){
	jQuery('#otw_type_' + item_type + '_per_page_field').on( 'change',  function( event ){
		otw_pc_load_items( item_type , jQuery( '#otw_pc_type_' + item_type ) );
	});
	jQuery('#otw_pc_type_' + item_type + ' .otw_overlay_pager_links a ').on( 'click',  function(){
		
		if( jQuery( this ).attr( 'rel' ).match( /^\d+$/ ) ){
			jQuery( '#otw_type_' + item_type + '_page_field' ).val( jQuery( this ).attr( 'rel' ) );
			otw_pc_load_items( item_type , jQuery( '#otw_pc_type_' + item_type ) );
		};
		
	} );
}
function otw_select_sitem( param, force, force_value ){

	var label = jQuery( param );
	var block = label.parent();
	var input = block.find( 'input' );
	
	var matches = false;
	
	if( matches = input.attr( 'id' ).match( /^otw_sbi_(.*)_sbi_([a-z0-9\.\-\_]+)$/ ) ){
		
		if( otw_pc_items[ matches[1] ][ matches[2] ] != undefined && otw_pc_items[ matches[1] ][ matches[2] ] ){
			otw_pc_items[ matches[1] ][ matches[2] ] = false;
		}else{
			otw_pc_items[ matches[1] ][ matches[2] ] = true;
		};
		
		if( matches[2] == 'all' ){
			if( otw_pc_items[ matches[1] ][ matches[2] ] )
			{
				jQuery( jQuery( '#otw_pc_type_' + matches[1] ).find( 'p' )[0] ).addClass( 'sitem_loading' );
				
				var req_url = 'admin-ajax.php?action=otw_pc_items_by_type';
				
				var post_params = { string_filter: '', type: matches[1], format: 'ids' };
				
				var settings = {
					url: req_url,
					type: 'post',
					data: post_params,
					success:function( data ){
					
						var t_data = data.trim().split( ',' );
						
						for( var tCD = 0; tCD < t_data.length; tCD++ ){
							if( t_data[ tCD ].length )
							{
								otw_pc_items[ matches[1] ][ t_data[ tCD ] ] = true;
							};
						};
						
						jQuery( '#otw_pc_type_' + matches[1] ).find( 'p.all' ).removeClass( 'sitem_loading' );
						
						otw_display_selected_items( matches[1], true );
					}
				};
				jQuery.ajax( settings );
			}else{
				otw_display_selected_items( matches[1], true );
			}
			
		}else{
			otw_pc_items[ matches[1] ][ 'all' ] = false;
			otw_display_selected_items( matches[1], false );
		};
	};
};
function otw_display_selected_items( type, apply_to_all ){
	
	if( ( type != undefined ) && ( otw_pc_items[type] != undefined ) && ( otw_pc_items[ type ]['all'] != undefined ) &&  otw_pc_items[ type ]['all'] ){
		apply_to_all = true;
	};
	
	//check if all is selected
	if( apply_to_all ){
		var apply_class = 'sitem_notselected';
		var remove_class = 'sitem_selected';
		
		if( otw_pc_items[ type ]['all'] ){
			apply_class = 'sitem_selected';
			remove_class = 'sitem_notselected';
		}else{
			otw_pc_items[ type ] = {};
		}
		jQuery( '#otw_pc_type_' + type ).find( 'p.all' ).removeClass( remove_class );
		jQuery( '#otw_pc_type_' + type ).find( 'p.all' ).addClass( apply_class );
		
		jQuery( '#otw_pc_type_' + type ).find( 'div.f_items input[type=checkbox]' ).each( function(){
			jQuery( this ).parent().attr( 'class', apply_class );
		});
	}
	else
	{
		jQuery( '#otw_pc_type_' + type ).find( 'p.all' ).removeClass( 'sitem_selected' );
		jQuery( '#otw_pc_type_' + type ).find( 'p.all' ).addClass( 'sitem_notselected' );
		
		jQuery( '#otw_pc_type_' + type ).find( 'div.f_items input[type=checkbox]' ).each( function(){
			
			if( otw_pc_items[type][this.value ] ){
				jQuery( this ).parent().attr( 'class', 'sitem_selected' );
			}else{
				jQuery( this ).parent().attr( 'class', 'sitem_notselected' );
			}
		});
	}
	var joined_values = '';
	var total_values  = 0;
	
	for( var item_key in otw_pc_items[type] ){
		
		if( item_key && otw_pc_items[type][ item_key ] ){
			if( item_key != 'all' ){
				total_values++;
			}
			joined_values = joined_values + item_key + ',';
		}
	};
	
	if( joined_values.length ){
		joined_values = joined_values.substring( 0, joined_values.length - 1 );
		jQuery( '#otw_pc_type_' + type + '_validfor' ).val(joined_values );
	}else{
		jQuery( '#otw_pc_type_' + type + '_validfor' ).val( '' );
	}
	jQuery( '#otw_pc_type_' + type ).find( 'div.otw_pc_selected_items span.otw_selected_items_number' ).html( total_values );
	if( total_values == 1 ){
		jQuery( '#otw_pc_type_' + type ).find( 'div.otw_pc_selected_items span.otw_seleted_items_plural' ).hide();
		jQuery( '#otw_pc_type_' + type ).find( 'div.otw_pc_selected_items span.otw_selected_items_singular' ).show();
	}else{
		jQuery( '#otw_pc_type_' + type ).find( 'div.otw_pc_selected_items span.otw_seleted_items_plural' ).show();
		jQuery( '#otw_pc_type_' + type ).find( 'div.otw_pc_selected_items span.otw_selected_items_singular' ).hide();
	}
	jQuery( '#otw_pc_type_' + type ).find( 'div.otw_pc_selected_items').show();
};

function select_sitem( param, force, force_value ){
	
	var label = jQuery( param );
	var block = label.parent();
	var input = block.find( 'input' );
	
	if( force ){
		if( force_value ){
			input[0].checked = true;
			block.removeClass( 'sitem_notselected' );
			block.addClass( 'sitem_selected' );
		}else{
			input[0].checked = false;
			block.removeClass( 'sitem_selected' );
			block.addClass( 'sitem_notselected' );
		}
	}else{
		if( !input[0].checked ){
			input[0].checked = true;
			block.removeClass( 'sitem_notselected' );
			block.addClass( 'sitem_selected' );
		}else{
			input[0].checked = false;
			block.removeClass( 'sitem_selected' );
			block.addClass( 'sitem_notselected' );
		}
		
		
		if( input.attr( 'id' ).match( /^otw_sbi_(.*)_sbi_all$/ ) ){
			input.parent().parent().find( 'label' ).each( function(){
				if( !jQuery( this ).attr( 'for' ).match( /^otw_sbi_(.*)_sbi_all$/ ) ){
					select_sitem( this, true, input[0].checked );
				}
			} );
		}else{
			input.parent().parent().find( 'label' ).each( function(){
				if( jQuery( this ).attr( 'for' ).match( /^otw_sbi_(.*)_sbi_all$/ ) ){
					select_sitem( this, true, false );
					return;
				}
			} );
		}
	}
}