<?php
class OTW_Overlay extends OTW_Component{

	/**
	 * The option name
	 */
	public $option_name = 'otw_overlays';
	
	/**
	 * Default views for the main overlay types
	 */
	public $views = array(
		'full_bar'     => 'views/full_bar',
		'side_box'     => 'views/side_box',
		'lightbox'     => 'views/lightbox',
		'full_bar_man' => 'views/full_bar_man'
	);
	
	public $overlay_types = array(
	
	);
	
	public $create_nav_menu = false;
	
	public $overlays = false;
	
	/**
	 * instance of grid component object
	 */
	public $grid_manager_component_object = false;
	
	/**
	 * settings
	 */
	public $settings = array();
	
	public function init(){
		
		$this->apply_settings();
		
		$this->init_types();
		
		
		if( !is_admin() ){
			
			add_action( 'wp_footer', array( $this, 'display_overlays' ) );
			
			if( method_exists( $this, 'add_lib' ) ){
				$this->add_lib( 'css', 'otw-shortcode-general_foundicons', $this->component_url.'css/general_foundicons.css', 'front', 50, array() );
				$this->add_lib( 'css', 'otw-shortcode-social_foundicons', $this->component_url.'css/social_foundicons.css', 'front', 50, array() );
				
				$this->add_lib( 'css', 'otw-popups', $this->component_url.'css/otw-popups.css', 'front', 50, array() );
				$this->add_lib( 'css', 'otw-mfp', $this->component_url.'css/otw-mfp.css', 'front', 50, array() );
				$this->add_lib( 'css', 'otw-overlay', $this->component_url.'css/otw-overlay.css', 'front', 50, array() );
			}else{
				wp_enqueue_style( 'otw-shortcode-general_foundicons', $this->component_url.'css/general_foundicons.css', array(), $this->css_version );
				wp_enqueue_style( 'otw-shortcode-social_foundicons', $this->component_url.'css/social_foundicons.css', array(), $this->css_version );
				
				wp_enqueue_style( 'otw-popups', $this->component_url.'css/otw-popups.css', array( ), $this->css_version );
				wp_enqueue_style( 'otw-mfp', $this->component_url.'css/otw-mfp.css', array( ), $this->css_version );
				wp_enqueue_style( 'otw-overlay', $this->component_url.'css/otw-overlay.css', array( ), $this->css_version );
			}
			
			if( method_exists( $this, 'add_lib' ) ){
				$this->add_lib( 'js', 'otw-mpf-code', $this->component_url.'js/mfp-core-inline-0.9.9.js', 'front', 100, array( 'jquery' ) );
				$this->add_lib( 'js', 'otw-sticky', $this->component_url.'js/otw-sticky.js', 'front', 100, array( 'jquery' ) );
				$this->add_lib( 'js', 'otw-overlay', $this->component_url.'js/otw-overlay.js', 'front', 100, array( 'jquery' ) );
			}else{
				wp_enqueue_script('otw-mpf-code', $this->component_url.'js/mfp-core-inline-0.9.9.js' , array( 'jquery' ), $this->js_version );
				wp_enqueue_script('otw-sticky', $this->component_url.'js/otw-sticky.js' , array( 'jquery' ), $this->js_version );
				wp_enqueue_script('otw-overlay', $this->component_url.'js/otw-overlay.js' , array( 'jquery' ), $this->js_version );
			}
			
			if( $this->create_nav_menu ){
				add_filter( 'nav_menu_link_attributes', array( $this, 'add_nav_menu_shortcodes' ) );
			}
			
			$this->process_tracking();
		}else{
			if( method_exists( $this, 'add_lib' ) ){
				$this->add_lib( 'js', 'otw-overlay-admin', $this->component_url.'js/otw-overlay-admin.js' , 'admin', 100,  array( 'jquery' ) );
			}else{
				wp_enqueue_script('otw-overlay-admin', $this->component_url.'js/otw-overlay-admin.js' , array( 'jquery' ), $this->js_version );
			}
		}
		
		
		
		add_shortcode( 'otw_ovl', array( $this, 'shortcode_overlay_link' ) );
		add_shortcode( 'otw_ovl_btn', array( $this, 'shortcode_overlay_button' ) );
	}
	
	
	
	/**
	 * apply settings
	 */
	public function apply_settings(){
	
		$this->settings = array(
			'icon_types' => array(
			
				''                      => $this->get_label( 'none (Default)' ),
				'general foundicon-settings'      => $this->get_label( 'Settings' ),
				'general foundicon-heart'         => $this->get_label( 'Heart' ),
				'general foundicon-star'          => $this->get_label( 'Star' ),
				'general foundicon-plus'          => $this->get_label( 'Plus' ),
				'general foundicon-minus'         => $this->get_label( 'Minus' ),
				'general foundicon-checkmark'     => $this->get_label( 'Checkmark' ),
				'general foundicon-remove'        => $this->get_label( 'Remove' ),
				'general foundicon-mail'          => $this->get_label( 'Mail' ),
				'general foundicon-calendar'      => $this->get_label( 'Calendar' ),
				'general foundicon-page'          => $this->get_label( 'Page' ),
				'general foundicon-tools'         => $this->get_label( 'Tools' ),
				'general foundicon-globe'         => $this->get_label( 'Globe' ),
				'general foundicon-cloud'         => $this->get_label( 'Cloud' ),
				'general foundicon-error'         => $this->get_label( 'Error' ),
				'general foundicon-right-arrow'   => $this->get_label( 'Right arrow' ),
				'general foundicon-left-arrow'    => $this->get_label( 'Left arrow' ),
				'general foundicon-up-arrow'      => $this->get_label( 'Up arrow' ),
				'general foundicon-down-arrow'    => $this->get_label( 'Down arrow' ),
				'general foundicon-trash'         => $this->get_label( 'Trash' ),
				'general foundicon-add-doc'       => $this->get_label( 'Add Doc' ),
				'general foundicon-edit'          => $this->get_label( 'Edit' ),
				'general foundicon-lock'          => $this->get_label( 'Lock' ),
				'general foundicon-unlock'        => $this->get_label( 'Unlock' ),
				'general foundicon-refresh'       => $this->get_label( 'Refresh' ),
				'general foundicon-paper-clip'    => $this->get_label( 'Paper clip' ),
				'general foundicon-video'         => $this->get_label( 'Video' ),
				'general foundicon-photo'         => $this->get_label( 'Photo' ),
				'general foundicon-graph'         => $this->get_label( 'Graph' ),
				'general foundicon-idea'          => $this->get_label( 'Idea' ),
				'general foundicon-mic'           => $this->get_label( 'Mic' ),
				'general foundicon-cart'          => $this->get_label( 'Cart' ),
				'general foundicon-address-book'  => $this->get_label( 'Address book' ),
				'general foundicon-compass'       => $this->get_label( 'Compass' ),
				'general foundicon-flag'          => $this->get_label( 'Flag' ),
				'general foundicon-location'      => $this->get_label( 'Location' ),
				'general foundicon-clock'         => $this->get_label( 'Clock' ),
				'general foundicon-folder'        => $this->get_label( 'Folder' ),
				'general foundicon-inbox'         => $this->get_label( 'Inbox' ),
				'general foundicon-website'       => $this->get_label( 'Website' ),
				'general foundicon-smiley'        => $this->get_label( 'Smiley' ),
				'general foundicon-search'        => $this->get_label( 'Search' ),
				'general foundicon-phone'         => $this->get_label( 'Phone' ),
				
				'social foundicon-thumb-up'       => $this->get_label( 'Thumb up' ),
				'social foundicon-thumb-down'     => $this->get_label( 'Thumb down' ),
				'social foundicon-rss'            => $this->get_label( 'Rss' ),
				'social foundicon-facebook'       => $this->get_label( 'Facebook' ),
				'social foundicon-twitter'        => $this->get_label( 'Twitter' ),
				'social foundicon-pinterest'      => $this->get_label( 'Pinterest' ),
				'social foundicon-github'         => $this->get_label( 'Github' ),
				'social foundicon-path'           => $this->get_label( 'Path' ),
				'social foundicon-linkedin'       => $this->get_label( 'LinkedIn' ),
				'social foundicon-dribbble'       => $this->get_label( 'Dribbble' ),
				'social foundicon-stumble-upon'   => $this->get_label( 'Stumble upon' ),
				'social foundicon-behance'        => $this->get_label( 'Behance' ),
				'social foundicon-reddit'         => $this->get_label( 'Reddit' ),
				'social foundicon-google-plus'    => $this->get_label( 'Google plus' ),
				'social foundicon-youtube'        => $this->get_label( 'Youtube' ),
				'social foundicon-vimeo'          => $this->get_label( 'Vimeo' ),
				'social foundicon-clickr'         => $this->get_label( 'Clickr' ),
				'social foundicon-slideshare'     => $this->get_label( 'Slideshare' ),
				'social foundicon-picassa'        => $this->get_label( 'Picassa' ),
				'social foundicon-skype'          => $this->get_label( 'Skype' ),
				'social foundicon-instagram'      => $this->get_label( 'instagram' ),
				'social foundicon-foursquare'     => $this->get_label( 'Foursquare' ),
				'social foundicon-delicious'      => $this->get_label( 'Delicious' ),
				'social foundicon-chat'           => $this->get_label( 'Chat' ),
				'social foundicon-torso'          => $this->get_label( 'Torso' ),
				'social foundicon-tumblr'         => $this->get_label( 'Tumblr' ),
				'social foundicon-video-chat'     => $this->get_label( 'Video chat' ),
				'social foundicon-digg'           => $this->get_label( 'Digg' ),
				'social foundicon-wordpress'      => $this->get_label( 'Wordpress' )
			),
			'default_icon_type' => ''
		);
		
	}

	
	/**
	 * process tracking
	 */
	public function process_tracking(){
	
		if( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && otw_post( 'otw_overlay_action', '' ) == 'otw-overlay-validate' ){
			
			$overlays = get_option( $this->option_name );
			
			$response = array();
			$response['active'] = true;
			$response['id'] = otw_post( 'overlay_id', '' );
			
			if( is_array( $overlays ) && array_key_exists( otw_post( 'overlay_id', '' ), $overlays ) ){
				
				if( $overlays[ otw_post( 'overlay_id', '' ) ]['status'] == 'active' ){
					
					//find the open method
					$overlay_data = $overlays[ otw_post( 'overlay_id', '' ) ];
					
					$type = $overlay_data['type'];
					
					if( isset( $overlay_data['options'] ) && isset( $overlay_data['options'][ $type.'_open_type' ] ) ){
						
						$close_type = $overlay_data['options'][ $type.'_close_type' ];
						
						switch( $close_type ){
						
							case 'otw-close-days':
									if( isset( $_COOKIE ) && isset( $_COOKIE['otw_ovcd_'.md5( $overlay_data['id'] ) ] ) && intval( $_COOKIE['otw_ovcd_'.md5( $overlay_data['id'] ) ] ) ){
										
										$response['active'] = false;
									}
								break;
							case 'otw-close-forever':
									if( isset( $_COOKIE ) && isset( $_COOKIE['otw_ovcf_'.md5( $overlay_data['id'] ) ] ) && intval( $_COOKIE['otw_ovcf_'.md5( $overlay_data['id'] ) ] ) ){
										$response['active'] = false;
									}
								break;
							case 'otw-close-loads':
									
									$cookie_name = 'otw_ovcl_'.md5( $overlay_data['id'] );
									if( isset( $_COOKIE ) && isset( $_COOKIE[ $cookie_name ] ) && intval( $_COOKIE[ $cookie_name ] ) ){
									
										if( intval( $_COOKIE[ $cookie_name ] ) > 0 )
										{
											$response['active'] = false;
											$response['left'] = $_COOKIE[ $cookie_name ];
										}
										setcookie( $cookie_name, intval( $_COOKIE[ $cookie_name ] ) - 1, strtotime( 'now +5 years' ) );
										
									}
								break;
						}
					}
				}
				else
				{
					$response['active'] = false;
				}
			}
			else
			{
				$response['active'] = false;
			}
			
			echo json_encode( $response );
			die;
			
		}elseif( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && otw_post( 'otwcalloverlay', false ) ){
			
			$overlays = get_option( $this->option_name );
			
			if( is_array( $overlays ) && array_key_exists( otw_post( 'otwcalloverlay', '' ), $overlays ) ){
				$this->_display_overlay( $overlays[ otw_post( 'otwcalloverlay', '' ) ], true );
				die;
			}
		
		}elseif( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && otw_post( 'otw_overlay_action', false ) && ( otw_post( 'otw_overlay_action', '' ) == 'otw-overlay-tracking' ) ){
		
			$overlays = get_option( $this->option_name );
			
			if( is_array( $overlays ) && array_key_exists( otw_post( 'overlay_id', '' ), $overlays ) ){
			
				$type = '';
				
				if( isset( $overlays[ otw_post( 'overlay_id', '' ) ]['type'] ) ){
				
					$type = $overlays[ otw_post( 'overlay_id', '' ) ]['type'];
				}
				
				switch( otw_post( 'method', '' ) ){
				
					case 'open_mouse':
						
							$cookie_name = 'otw_ovom_'.md5( otw_post( 'overlay_id', '' ) );
							
							setcookie( $cookie_name, true, strtotime( 'now +30 days' ) );
							echo 'true';
							die;
						break;
					case 'open_wooab':
							global $woocommerce;
							
							if( ( strtolower( gettype( $woocommerce ) ) == 'object' ) && isset( $woocommerce->cart ) ){
								
								$card = $woocommerce->cart->get_cart();
								
								if( is_array( $card ) && count( $card ) ){
									echo 'open';
								}
							}
							die;
						break;
					case 'close_forever':
							
							$cookie_name = 'otw_ovcf_'.md5( otw_post( 'overlay_id', '' ) );
							
							setcookie( $cookie_name, true, strtotime( 'now +5 years' ) );
							echo 'true';
							die;
						break;
					case 'close_loads':
							if( isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'] ) && isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_loads'] ) && intval( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_loads'] ) ){
								
								$cookie_name = 'otw_ovcl_'.md5( otw_post( 'overlay_id', '' ) );
								
								setcookie( $cookie_name, $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_loads'], strtotime( 'now +5 years' ) );
								echo 'true';
								die;
							}
						break;
					case 'close_days':
							if( isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'] ) && isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_days'] ) && intval( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_days'] ) ){
								
								$cookie_name = 'otw_ovcd_'.md5( otw_post( 'overlay_id', '' ) );
								
								setcookie( $cookie_name, $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_days'], strtotime( 'now +'.intval( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_days']  ).' days' ) );
								echo 'true';
								die;
							}
						break;
					case 'close_loaded':
							if( isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'] ) && isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_loads'] ) && intval( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_close_type_loads'] ) ){
								
								$cookie_name = 'otw_ovcl_'.md5( otw_post( 'overlay_id', '' ) );
								
								if( isset( $_COOKIE[ $cookie_name ] ) && intval( $_COOKIE[ $cookie_name ] ) ){
									
									setcookie( $cookie_name, intval( $_COOKIE[ $cookie_name ] ) - 1, strtotime( 'now +5 years' ) );
									echo 'true';
									die;
								}
							}
						break;
					case 'open_loads':
							if( isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'] ) && isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_loads'] ) && intval( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_loads'] ) ){
							
								$cookie_name = 'otw_ovol_'.md5( otw_post( 'overlay_id', '' ) );
								
								$current_loads = 0;
								
								if( isset( $_COOKIE[ $cookie_name ] ) && intval( $_COOKIE[ $cookie_name ] ) ){
									$current_loads = intval( $_COOKIE[ $cookie_name ] );
								}
								
								if( $current_loads == $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_loads'] ){
									echo 'open';
								}else{
									setcookie( $cookie_name, $current_loads + 1, strtotime( 'now +5 years' ) );
								}
							}
							die;
						break;
					case 'open_seconds':
							if( isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'] ) && isset( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'] ) && intval( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'] ) ){
								
								$cookie_name = 'otw_ovos_'.md5( otw_post( 'overlay_id', '' ) );
								
								$start_time = 0;
								
								$left_seconds = $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'];
								
								if( isset( $_COOKIE[ $cookie_name ] ) && intval( $_COOKIE[ $cookie_name ] ) ){
									$start_time = intval( $_COOKIE[ $cookie_name ] );
								}
								
								if( $start_time > 0 ){
									
									$left_time = ( time() - $start_time );
									
									if( $left_time > $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'] ){
										
										setcookie( $cookie_name, time(), strtotime( 'now +'.( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'] * 2 ).' seconds' ) );
										
									}else{
										$left_seconds = $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'] - $left_time;
									}
								}
								else{
									
									setcookie( $cookie_name, time(), strtotime( 'now +'.( $overlays[ otw_post( 'overlay_id', '' ) ]['options'][ $type.'_open_type_seconds'] * 2 ).' seconds' ) );
									
								}
								echo $left_seconds;
							}
							die;
						break;
				}
			}
		}
	}
	
	/**
	 * Init overlay types
	 */
	private function init_types(){
		
		//full bar
		$this->init_full_bar_types();
		
		//site box
		$this->init_side_box_types();
		
		//lightbox
		$this->init_lightbox_types();
	}
	
	/**
	 * Full bar options
	 */
	private function init_full_bar_types()
	{
		$type = 'full_bar';
		
		$this->overlay_types[ $type ] = array();
		$this->overlay_types[ $type ]['label'] = $this->get_label( 'Full bar' );
		$this->overlay_types[ $type ]['options'] = array();
		
		//options
		$this->overlay_types[ $type ]['options']['main'] = array();
		$this->overlay_types[ $type ]['options']['main']['label'] = $this->get_label( 'Overlay Options' );
		$this->overlay_types[ $type ]['options']['main']['items'] = array();
		
		//position
		$this->overlay_types[ $type ]['options']['main']['items']['position'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['position']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['position']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['position']['options'] = array( 'otw-top-sticky' => $this->get_label( 'Header' ), 'otw-bottom-sticky' => $this->get_label( 'Footer' ), 'otw-left-sticky' => $this->get_label( 'Left' ), 'otw-right-sticky' => $this->get_label( 'Right' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['position']['label'] = $this->get_label( 'Position' );
		$this->overlay_types[ $type ]['options']['main']['items']['position']['default'] = 'otw-top-sticky';
		$this->overlay_types[ $type ]['options']['main']['items']['position']['description'] = $this->get_label( 'Choose the position of your overlay.' );
		
		//push content
		$this->overlay_types[ $type ]['options']['main']['items']['push_content'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['push_content']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['push_content']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['push_content']['options'] = array( '' => $this->get_label( 'No (default)' ), 'otw-push-content' => $this->get_label( 'Yes' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['push_content']['label'] = $this->get_label( 'Push Content' );
		$this->overlay_types[ $type ]['options']['main']['items']['push_content']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['push_content']['description'] = $this->get_label( 'If this is enabled the overlay will push the site content with its size. If this is disabled the overlay will go over the site content.' );
		
		//overlay
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround']['options'] = array( '' => $this->get_label( 'None (default)' ), 'otw-with-ovbackground' => $this->get_label( 'Regular background' ), 'otw-with-ovbackground otw-overlay-pattern-1' => $this->get_label( 'Cream Pixels' ), 'otw-with-ovbackground otw-overlay-pattern-2' => $this->get_label( 'Dimension' ), 'otw-with-ovbackground otw-overlay-pattern-3' => $this->get_label( 'Grey' ), 'otw-with-ovbackground otw-overlay-pattern-4' => $this->get_label( 'Greyzz' ), 'otw-with-ovbackground otw-overlay-pattern-5' => $this->get_label( 'Pw Pattern' ), 'otw-with-ovbackground otw-overlay-pattern-6' => $this->get_label( 'Skelatal Weave' ), 'otw-with-ovbackground otw-overlay-pattern-7' => $this->get_label( 'Stitch' ), 'otw-with-ovbackground otw-overlay-pattern-8' => $this->get_label( 'Dubtle Grunge' ), 'otw-with-ovbackground otw-overlay-pattern-9' => $this->get_label( 'Swirl' ), 'otw-with-ovbackground otw-overlay-pattern-10' => $this->get_label( 'Wood Pattern' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround']['label'] = $this->get_label( 'Overlay pattern' );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_backround']['description'] = $this->get_label( 'Enable background' );
		
		//type
		$this->overlay_types[ $type ]['options']['main']['items']['type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['type']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['type']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['type']['options'] = array( 'fixed-position' => $this->get_label( 'Fixed (default)' ), 'scrolling-position' => $this->get_label( 'Scrolling' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['type']['label'] = $this->get_label( 'Type' );
		$this->overlay_types[ $type ]['options']['main']['items']['type']['default'] = 'fixed-position';
		$this->overlay_types[ $type ]['options']['main']['items']['type']['description'] = $this->get_label( 'Fixed means the overlay will stay on one place while you scroll. Scrolling means the overlay will scroll with the site.' );
		
		//animation
		$this->overlay_types[ $type ]['options']['main']['items']['animation'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['options'] = array( 'otw-slide-animation' => $this->get_label( 'Slide Animation (default)' ), 'otw-fade-animation' => $this->get_label( 'Fade Animation' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['label'] = $this->get_label( 'Animation' );
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['default'] = 'otw-slide-animation';
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['description'] = $this->get_label( 'Choose animation type.' );
		
		//open_type
		$this->overlay_types[ $type ]['options']['main']['items']['open_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['type'] = 'select_subfields';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['subfields'] = array( 'delay' => array( 'option' => 'otw-show-sticky-delay', 'type' => 'text_input', 'label' => $this->get_label( 'On Page Load with Delay' ), 'default' => '1000' ), 'loads' => array( 'option' => 'otw-show-sticky-loads', 'type' => 'text_input', 'label' => $this->get_label( 'After a Number of Page Views' ), 'default' => '1' ), 'seconds' => array( 'option' => 'otw-show-sticky-seconds', 'type' => 'text_input', 'label' => $this->get_label( 'After Number of Seconds Spent on the Site' ), 'default' => '60' ), 'scroll' => array(  'option' => 'otw-show-sticky-scroll', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Bar Percent' ), 'default' => '50' ), 'scrollto' => array(  'option' => 'otw-show-sticky-scrollto', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Element #id or .class' ), 'default' => '' ), 'clickon' => array(  'option' => 'otw-show-sticky-clickon', 'type' => 'text_input', 'label' => $this->get_label( 'Click On Element #id or .class' ), 'default' => '' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['options'] = array( 'otw-show-sticky-load' => $this->get_label( 'On Page Load (default)' ), 'otw-show-sticky-delay' => $this->get_label( 'On Page Load with Delay' ), 'otw-show-sticky-loads' => $this->get_label( 'After a Number of Page Views' ), 'otw-show-sticky-seconds' => $this->get_label( 'After Number of Seconds Spent on the Site' ), 'otw-show-sticky-mouse' => $this->get_label( 'On Exit Intent' ), 'otw-show-sticky-wooab' => $this->get_label( 'WooCommerce abandoners' ), 'otw-show-sticky-scroll' => $this->get_label( 'Scroll Bar Percent' ), 'otw-show-sticky-scrollto' => $this->get_label( 'Scroll to Element #id or .class' ), 'otw-show-sticky-clickon' => $this->get_label( 'Click on Element #id or .class' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['label'] = $this->get_label( 'Overlay Load Event' );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['default'] = 'otw-show-sticky-load';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['description'] = $this->get_label( 'Choose the event that will open your overlay. Most popular is On Page Load. <br>On Page Load with Delay is the milliseconds before the loading of the overlay. <br>After a number of page views means the overlay will be loaded after the entered number of page views for the user, not on the first page view. <br>After Number of Seconds Spent on the Site means the user will have to spend the entered number of seconds before the overlay is loaded. <br>On Exist Intent can be used for showing something to the users that intend to leave your site.<br>WooCommerce abandoners will load the overlay if the site user intends to leave and he has something in his WooCommerce cart.<br> Scroll Bar Percent 30 means that the overlay will be triggered when the user scrolls down to 30% of the page. <br>Scroll/Click Element #id or .class means the overlay will be triggered when the user scrolls/clicks on an #id or .class that is in the page\'s HTML structure.' );
		
		//opened
		$this->overlay_types[ $type ]['options']['main']['items']['opened'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['options'] = array( 'otw-first-show-sticky otw-hide-sticky' => $this->get_label( 'Opened (default)' ), 'otw-hide-sticky' => $this->get_label( 'Closed' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['label'] = $this->get_label( 'Overlay First Load' );
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['default'] = 'otw-first-show-sticky otw-hide-sticky';
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['description'] = $this->get_label( 'Once the overlay is loaded based on Overlay Load Event above this option will allow you to choose if you want the overlay loaded opened or closed on its first load. Closed means it will have just a Show button visible so the site user can open it if he wants to.' );
		
		//close_type
		$this->overlay_types[ $type ]['options']['main']['items']['close_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['type'] = 'select_subfields';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['subfields'] = array( 'loads' => array( 'option' => 'otw-close-loads', 'type' => 'text_input', 'label' => $this->get_label( 'Number Of Page Loads' ), 'default' => '5' ), 'days' => array( 'option' => 'otw-close-days', 'type' => 'text_input', 'label' => $this->get_label( 'Number Of Days' ), 'default' => '7' ), 'scroll' => array(  'option' => 'otw-close-sticky-scroll', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Bar Percent' ), 'default' => '50' ), 'scrollto' => array(  'option' => 'otw-close-sticky-scrollto', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Element #id or .class' ), 'default' => '' ), 'clickon' => array(  'option' => 'otw-show-sticky-clickon', 'type' => 'text_input', 'label' => $this->get_label( 'Click On Element #id or .class' ), 'default' => '' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['options'] = array( 'otw-close-button' => $this->get_label( 'Show/Hide Button (default)' ), 'otw-close-forever' => $this->get_label( 'Close for ever' ), 'otw-close-page' => $this->get_label( 'Close until next page load' ), 'otw-close-loads' => $this->get_label( 'Close for number of page loads' ), 'otw-close-days' => $this->get_label( 'Close for number of days' ), 'otw-never-close' => $this->get_label( 'Never close' ), 'otw-close-sticky-scroll' => $this->get_label( 'Scroll Bar Percent' ), 'otw-close-sticky-scrollto' => $this->get_label( 'Scroll to Element #id or .class' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['label'] = $this->get_label( 'Overlay Close Options' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['default'] = 'otw-close-button';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['description'] = $this->get_label( 'Show/Hide Button will place Show/Hide button for Full Bar and Side Box overlay types. The rest of the close options are user session based. Meaning that if a user closes an ovelay it closes for him only. If another user loads the same page he sees the overlay until he decides to close it.' );
		
		//show_button_label
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['label'] = $this->get_label( 'Show Button Label' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['default'] = $this->get_label( 'Show' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['description'] = $this->get_label( 'Change the label for the Show button. If this field is left empty the button will be labeled \'Show\'. HTML is allowed.' );
		
		//button_label_orientation
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['target'] = 'show_button_class';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['options'] = array( 'otw-btn-horizontal' => $this->get_label( 'Horizontal (default)' ), 'otw-btn-vertical' => $this->get_label( 'Vertical' )  );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['label'] = $this->get_label( 'Show Button Label Orientation' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['default'] = 'otw-btn-horizontal';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['description'] = $this->get_label( 'Text orientation' );
		
		//show_button_label_icon
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['options'] = $this->settings['icon_types'];
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['label'] = $this->get_label( 'Show Button Label Icon' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['default'] = $this->settings['default_icon_type'];
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['description'] = $this->get_label( 'Choose Show Button Label Icon.' );
		
		//close_button_label
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['label'] = $this->get_label( 'Hide Button Label' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['default'] = html_entity_decode( '&times;' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['description'] = $this->get_label( 'Change the label for the Hide Button. If this field is left empty the default "X" close button will be displayed. HTML is allowed.' );
		
		//close_button_label_icon
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['options'] = $this->settings['icon_types'];
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['label'] = $this->get_label( 'Hide Button Label Icon' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['default'] = $this->settings['default_icon_type'];
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['description'] = $this->get_label( 'Choose Hide Button Label Icon' );
		
		//content_width
		$this->overlay_types[ $type ]['options']['main']['items']['content_width'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['type'] = 'content_width';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['subfields'] =  array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => 'px' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['label'] = $this->get_label( 'Content Width' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['description'] = $this->get_label( 'The width of your content in px or %. If left empty this means the content is fluid.' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['options'] = array();
		
		//content_position
		$this->overlay_types[ $type ]['options']['main']['items']['content_position'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['options'] = array( 'otw-align-left' => $this->get_label( 'Left (default)' ), 'otw-align-center' => $this->get_label( 'Center' ), 'otw-align-right' => $this->get_label( 'Right' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['label'] = $this->get_label( 'Content Position' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['default'] = 'otw-align-left';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['description'] = $this->get_label( 'Choose the position of the content inside of the container.' );
		
		//devices
		$this->overlay_types[ $type ]['options']['main']['items']['devices'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['type'] = 'checkboxes';
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['options'] = array( 'device_large' => 'Large Screens', 'device_small' => 'Small Screens' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['label'] = $this->get_label( 'Enable Overlay on Devices' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['default'] = array( 'device_large' => 'yes', 'device_small' => 'no' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['description'] = $this->get_label( 'Large Screens means display on screens above 768 px. Small Screens means display on screens smaller than 768 px.' );
		
		//enable_content_scrolling
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['options'] = array( '' => $this->get_label( 'No (default)' ), 'otw-small-csr' => $this->get_label( 'Yes' )  );
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['label'] = $this->get_label( 'Scrolling content' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['description'] = $this->get_label( 'Scrolling content for screens smaller than the popup content' );
		
		//Show Powered by link
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['label'] = $this->get_label( 'Show Powered by link' );
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['description'] = $this->get_label( 'Want to make some money and help us spread the word for this wonderful plugin? Enter your CodeCanyon.net username and we will build and place a referral link for you at the bottom of your overlay. You earn money from all users that purchase anything from the market. <a href="http://codecanyon.net/make_money/affiliate_program" target="_blank">More info</a>.' );
		
		//shortcode link text
		$this->overlay_types[ $type ]['options']['main']['items']['link_text'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['label'] = $this->get_label( 'Shortcode Link and Button Text' );
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['default'] = 'Click to open';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['description'] = $this->get_label( 'Every overlay has a shortcodes that you can copy form the list of all overlays. The shortcodes generate a link or a button that when clicked open the overlay. This option allows you to change the text in the link and the button. The following options will not affect the overlay when the site user click on a shortcode link: Visibility Options, Overlay Load Event, Overlay First Load and Overlay Close Options.' );
		
		//z-index
		$this->overlay_types[ $type ]['options']['main']['items']['zindex'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['label'] = $this->get_label( 'z-Index' );
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['description'] = $this->get_label( 'The z-index specifies the stack order of an overlay. An overlay with greater stack order is always in front of an overlay with a lower stack order. This can be used when you show more than one overlay on the same page.' );
		
		//active_period
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['type'] = 'active_periods';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['label'] = $this->get_label( 'Active Periods' );
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['description'] = $this->get_label( 'Set up as many activation periods as you need. The overlay will be visible on your site for the periods you add here. If no period is set this means the overlay is active all the time. Your current server date and time is: ' ).date( 'd.m.Y H:i T' );
		
		//styling
		$this->overlay_types[ $type ]['options']['styling'] = array();
		$this->overlay_types[ $type ]['options']['styling']['label'] = $this->get_label( 'Styling Options' );
		$this->overlay_types[ $type ]['options']['styling']['items'] = array();
		
		//shadow
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['target'] = 'section_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['options'] = array( '' => $this->get_label( 'None' ), 'otw-sticky-shadow-small' => $this->get_label( 'Small (default)' ), 'otw-sticky-shadow-large' => $this->get_label( 'Large' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['label'] = $this->get_label( 'Shadow' );
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['default'] = 'otw-sticky-shadow-small';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['description'] = $this->get_label( 'Choose shadow type.' );
		
		//border
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['options'] = array( '' => $this->get_label( '0px (default)' ), '1' => $this->get_label( '1px' ), '2' => $this->get_label( '2px' ), '3' => $this->get_label( '3px' ), '4' => $this->get_label( '4px' ), '5' => $this->get_label( '5px' ), '6' => $this->get_label( '6px' ), '7' => $this->get_label( '7px' ), '8' => $this->get_label( '8px' ), '9' => $this->get_label( '9px' ), '10' => $this->get_label( '10px' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['label'] = $this->get_label( 'Border Width' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['description'] = $this->get_label( 'Choose border width.' );
		
		//border_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['options'] = array( 'otw-sticky-border-black' => $this->get_label( 'Black (default)' ), 'otw-sticky-border-white' => $this->get_label( 'White' ), 'otw-sticky-border-red' => $this->get_label( 'Red' ), 'otw-sticky-border-orange' => $this->get_label( 'Orange' ), 'otw-sticky-border-green' => $this->get_label( 'Green' ), 'otw-sticky-border-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-border-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-border-blue' => $this->get_label( 'Blue' ), 'otw-sticky-border-pink' => $this->get_label( 'Pink' ), 'otw-sticky-border-purple' => $this->get_label( 'Purple' ), 'otw-sticky-border-silver' => $this->get_label( 'Silver' ), 'otw-sticky-border-brown' => $this->get_label( 'Brown' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['label'] = $this->get_label( 'Border Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['default'] = 'otw-sticky-border-black';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['description'] = $this->get_label( 'Choose border color.' );
		
		//border_style_class
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['options'] = array( 'otw-sticky-border-type-solid' => $this->get_label( 'solid (default)' ), 'otw-sticky-border-type-dashed' => $this->get_label( 'dashed' ), 'otw-sticky-border-type-dotted' => $this->get_label( 'dotted' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['label'] = $this->get_label( 'Border Style' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['default'] = 'otw-sticky-border-type-solid';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['description'] = $this->get_label( 'Choose border style.' );
		
		//rounded_corners
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-sticky-rounded-border-3' => $this->get_label( '3px' ), 'otw-sticky-rounded-border-5' => $this->get_label( '5px' ), 'otw-sticky-rounded-border-10' => $this->get_label( '10px' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['label'] = $this->get_label( 'Rounded Corners' );
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['description'] = $this->get_label( 'Choose rounded corners.' );
		
		//background_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['target'] = 'section_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['options'] = array( 'otw-sticky-transparent' => $this->get_label( 'Transparent' ), 'otw-sticky-background-red' => $this->get_label( 'Red' ), 'otw-sticky-background-orange' => $this->get_label( 'Orange' ), 'otw-sticky-background-green' => $this->get_label( 'Green' ), 'otw-sticky-background-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-background-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-background-blue' => $this->get_label( 'Blue' ), 'otw-sticky-background-pink' => $this->get_label( 'Pink' ), 'otw-sticky-background-purple' => $this->get_label( 'Purple' ), 'otw-sticky-background-silver' => $this->get_label( 'Silver' ), 'otw-sticky-background-brown' => $this->get_label( 'Brown' ), 'otw-sticky-background-black' => $this->get_label( 'Black' ), 'otw-sticky-background-white' => $this->get_label( 'White (default)' ), 'otw-sticky-background-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-background-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-background-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-background-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-background-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-background-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-background-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-background-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-background-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-background-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-background-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-background-light-white' => $this->get_label( 'Light White' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['label'] = $this->get_label( 'Background Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['default'] = 'otw-sticky-background-white';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['description'] = $this->get_label( 'Choose background color.' );
		
		//background_pattern_class
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['target'] = 'section_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-sticky-background-pattern-1' => $this->get_label( 'Cream Pixels' ), 'otw-sticky-background-pattern-2' => $this->get_label( 'Dimension' ), 'otw-sticky-background-pattern-3' => $this->get_label( 'Grey' ), 'otw-sticky-background-pattern-4' => $this->get_label( 'Greyzz' ), 'otw-sticky-background-pattern-5' => $this->get_label( 'Pw Pattern' ), 'otw-sticky-background-pattern-6' => $this->get_label( 'Skelatal Weave' ), 'otw-sticky-background-pattern-7' => $this->get_label( 'Stitch' ), 'otw-sticky-background-pattern-8' => $this->get_label( 'Dubtle Grunge' ), 'otw-sticky-background-pattern-9' => $this->get_label( 'Swirl' ), 'otw-sticky-background-pattern-10' => $this->get_label( 'Wood Pattern' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['label'] = $this->get_label( 'Background Pattern' );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['description'] = $this->get_label( 'Choose a background pattern.' );
		
		//show_hide_background_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['target'] = 'show_hide_button_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['options'] = array( 'otw-sticky-background-red' => $this->get_label( 'Red' ), 'otw-sticky-background-orange' => $this->get_label( 'Orange' ), 'otw-sticky-background-green' => $this->get_label( 'Green' ), 'otw-sticky-background-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-background-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-background-blue' => $this->get_label( 'Blue' ), 'otw-sticky-background-pink' => $this->get_label( 'Pink' ), 'otw-sticky-background-purple' => $this->get_label( 'Purple' ), 'otw-sticky-background-silver' => $this->get_label( 'Silver' ), 'otw-sticky-background-brown' => $this->get_label( 'Brown' ), 'otw-sticky-background-black' => $this->get_label( 'Black (default)' ), 'otw-sticky-background-white' => $this->get_label( 'White' ), 'otw-sticky-background-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-background-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-background-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-background-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-background-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-background-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-background-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-background-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-background-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-background-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-background-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-background-light-white' => $this->get_label( 'Light White' ), 'otw-sticky-transparent' => $this->get_label( 'Transparent' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['label'] = $this->get_label( 'Show/Hide Button Background Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['default'] = 'otw-sticky-background-black';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['description'] = $this->get_label( 'Choose a background color for the show/hide buttons.' );
		
		//show_hide_text_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['target'] = 'show_hide_button_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['options'] = array( 'otw-sticky-text-red' => $this->get_label( 'Red' ), 'otw-sticky-text-orange' => $this->get_label( 'Orange' ), 'otw-sticky-text-green' => $this->get_label( 'Green' ), 'otw-sticky-text-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-text-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-text-blue' => $this->get_label( 'Blue' ), 'otw-sticky-text-pink' => $this->get_label( 'Pink' ), 'otw-sticky-text-purple' => $this->get_label( 'Purple' ), 'otw-sticky-text-silver' => $this->get_label( 'Silver' ), 'otw-sticky-text-brown' => $this->get_label( 'Brown' ), 'otw-sticky-text-black' => $this->get_label( 'Black' ), 'otw-sticky-text-white' => $this->get_label( 'White (default)' ), 'otw-sticky-text-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-text-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-text-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-text-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-text-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-text-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-text-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-text-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-text-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-text-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-text-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-text-light-white' => $this->get_label( 'Light White' ), 'otw-sticky-transparent' => $this->get_label( 'Transparent' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['label'] = $this->get_label( 'Show/Hide Button Text Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['default'] = 'otw-sticky-text-white';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['description'] = $this->get_label( 'Choose a text color for the show/hide buttons.' );
		
		//content top padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['label'] = $this->get_label( 'Content Top Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['description'] = '';
		
		//content right padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['label'] = $this->get_label( 'Content Right Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['description'] = '';
		
		//content bottom padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['label'] = $this->get_label( 'Content Bottom Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['description'] = '';
		
		//content left padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['label'] = $this->get_label( 'Content Left Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['description'] = $this->get_label( 'Add some space between your content and the box.' );
		
		//custom options
		$this->overlay_types[ $type ]['options']['custom'] = array();
		$this->overlay_types[ $type ]['options']['custom']['label'] = $this->get_label( 'Custom Styling Options' );
		$this->overlay_types[ $type ]['options']['custom']['items'] = array();
		
		//border_color
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['label'] = $this->get_label( 'Border Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['description'] = $this->get_label( 'Choose a custom border color.' );
		
		//background_color
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['label'] = $this->get_label( 'Background Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['description'] = $this->get_label( 'Choose a custom background color.' );
		
		//background_pattern_url
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['label'] = $this->get_label( 'Background Pattern URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['description'] = $this->get_label( 'Choose a custom background pattern.' );
		
		//show_hide_background_color
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['label'] = $this->get_label( 'Show/Hide Button Background Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['description'] = $this->get_label( 'Choose a custom background color for the show/hide buttons.' );
		
		//show_hide_text_color
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['label'] = $this->get_label( 'Show/Hide Button Text Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['description'] = $this->get_label( 'Choose a custom text color for the show/hide buttons.' );
		
		//show button custon icon
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['label'] = $this->get_label( 'Show Button Lable Icon URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['description'] = $this->get_label( 'Choose a custom icon.' );
		
		//close button custon icon
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['label'] = $this->get_label( 'Hide Button Lable Icon URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['description'] = $this->get_label( 'Choose a custom icon.' );
		
		//overlay_pattern_url
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['label'] = $this->get_label( 'Overlay Background Pattern URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['description'] = $this->get_label( 'Choose a custom background pattern for the overlay.' );
		
		//overlay pattern repeat
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['options'] = array( '' => $this->get_label( 'Yes (default)' ), 'otw-ovr-bkg-norepeat' => $this->get_label( 'No' ) );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['label'] = $this->get_label( 'Overlay Background Pattern Repeat' );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['description'] = $this->get_label( 'Repeat image on background pattern' );
		
		//css_class_name
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['target'] = 'wrapper_class';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['label'] = $this->get_label( 'CSS Class' );
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['description'] = $this->get_label( 'If you\'d like to style this element separately enter a name here. A CSS class with this name will be available for you to style this particular element.' );
	}
	
	/**
	 * Side box options
	 */
	private function init_side_box_types()
	{
		$type = 'side_box';
		
		$this->overlay_types[ $type ] = array();
		$this->overlay_types[ $type ]['label'] = $this->get_label( 'Side box' );
		$this->overlay_types[ $type ]['options'] = array();
		
		//options
		$this->overlay_types[ $type ]['options']['main'] = array();
		$this->overlay_types[ $type ]['options']['main']['label'] = $this->get_label( 'Overlay Options' );
		$this->overlay_types[ $type ]['options']['main']['items'] = array();
		
		//position
		$this->overlay_types[ $type ]['options']['main']['items']['position'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['position']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['position']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['position']['options'] = array( 'otw-top-sticky' => $this->get_label( 'Header' ), 'otw-bottom-sticky' => $this->get_label( 'Footer' ), 'otw-left-sticky' => $this->get_label( 'Left' ), 'otw-right-sticky' => $this->get_label( 'Right' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['position']['label'] = $this->get_label( 'Position' );
		$this->overlay_types[ $type ]['options']['main']['items']['position']['default'] = 'otw-top-sticky';
		$this->overlay_types[ $type ]['options']['main']['items']['position']['description'] = $this->get_label( 'Choose the position of your overlay.' );
		
		//type
		$this->overlay_types[ $type ]['options']['main']['items']['type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['type']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['type']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['type']['options'] = array( 'fixed-position' => $this->get_label( 'Fixed (default)' ), 'scrolling-position' => $this->get_label( 'Scrolling' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['type']['label'] = $this->get_label( 'Type' );
		$this->overlay_types[ $type ]['options']['main']['items']['type']['default'] = 'fixed-position';
		$this->overlay_types[ $type ]['options']['main']['items']['type']['description'] = $this->get_label( 'Fixed means the overlay will stay on one place while you scroll. Scrolling means the overlay will scroll with the site.' );
		
		//animation
		$this->overlay_types[ $type ]['options']['main']['items']['animation'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['options'] = array( 'otw-slide-animation' => $this->get_label( 'Slide Animation (default)' ), 'otw-fade-animation' => $this->get_label( 'Fade Animation' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['label'] = $this->get_label( 'Animation' );
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['default'] = 'otw-slide-animation';
		$this->overlay_types[ $type ]['options']['main']['items']['animation']['description'] = $this->get_label( 'Choose animation type.' );
		
		//open_type
		$this->overlay_types[ $type ]['options']['main']['items']['open_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['type'] = 'select_subfields';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['subfields'] = array( 'delay' => array( 'option' => 'otw-show-sticky-delay', 'type' => 'text_input', 'label' => $this->get_label( 'On Page Load with Delay' ), 'default' => '1000' ), 'loads' => array( 'option' => 'otw-show-sticky-loads', 'type' => 'text_input', 'label' => $this->get_label( 'After a Number of Page Views' ), 'default' => '1' ), 'seconds' => array( 'option' => 'otw-show-sticky-seconds', 'type' => 'text_input', 'label' => $this->get_label( 'After Number of Seconds Spent on the Site' ), 'default' => '60' ), 'scroll' => array(  'option' => 'otw-show-sticky-scroll', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Bar Percent' ), 'default' => '50' ), 'scrollto' => array(  'option' => 'otw-show-sticky-scrollto', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Element #id or .class' ), 'default' => '' ), 'clickon' => array(  'option' => 'otw-show-sticky-clickon', 'type' => 'text_input', 'label' => $this->get_label( 'Click On Element #id or .class' ), 'default' => '' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['options'] = array( 'otw-show-sticky-load' => $this->get_label( 'On Page Load (default)' ), 'otw-show-sticky-delay' => $this->get_label( 'On Page Load with Delay' ), 'otw-show-sticky-loads' => $this->get_label( 'After a Number of Page Views' ), 'otw-show-sticky-seconds' => $this->get_label( 'After Number of Seconds Spent on the Site' ), 'otw-show-sticky-mouse' => $this->get_label( 'On Exit Intent' ), 'otw-show-sticky-wooab' => $this->get_label( 'WooCommerce abandoners' ), 'otw-show-sticky-scroll' => $this->get_label( 'Scroll Bar Percent' ), 'otw-show-sticky-scrollto' => $this->get_label( 'Scroll to Element #id or .class' ), 'otw-show-sticky-clickon' => $this->get_label( 'Click on Element #id or .class' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['label'] = $this->get_label( 'Overlay Load Event' );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['default'] = 'otw-show-sticky-load';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['description'] = $this->get_label( 'Choose the event that will open your overlay. Most popular is On Page Load. <br>On Page Load with Delay is the milliseconds before the loading of the overlay. <br>After a number of page views means the overlay will be loaded after the entered number of page views for the user, not on the first page view. <br>After Number of Seconds Spent on the Site means the user will have to spend the entered number of seconds before the overlay is loaded. <br>On Exist Intent can be used for showing something to the users that intend to leave your site.<br>WooCommerce abandoners will load the overlay if the site user intends to leave and he has something in his WooCommerce cart. <br>Scroll Bar Percent 30 means that the overlay will be triggered when the user scrolls down to 30% of the page. <br>Scroll/Click Element #id or .class means the overlay will be triggered when the user scrolls/clicks on an #id or .class that is in the page\'s HTML structure.' );
		
		//opened
		$this->overlay_types[ $type ]['options']['main']['items']['opened'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['options'] = array( 'otw-first-show-sticky otw-hide-sticky' => $this->get_label( 'Opened (default)' ), 'otw-hide-sticky' => $this->get_label( 'Closed' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['label'] = $this->get_label( 'Overlay First Load' );
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['default'] = 'otw-first-show-sticky otw-hide-sticky';
		$this->overlay_types[ $type ]['options']['main']['items']['opened']['description'] = $this->get_label( 'Once the overlay is loaded based on Overlay Load Event above this option will allow you to choose if you want the overlay loaded opened or closed on its first load. Closed means it will have just a Show button visible so the site user can open it if he wants to.' );
		
		//close_type
		$this->overlay_types[ $type ]['options']['main']['items']['close_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['type'] = 'select_subfields';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['subfields'] = array( 'loads' => array( 'option' => 'otw-close-loads', 'type' => 'text_input', 'label' => $this->get_label( 'Number Of Page Loads' ), 'default' => '5' ), 'days' => array( 'option' => 'otw-close-days', 'type' => 'text_input', 'label' => $this->get_label( 'Number Of Days' ), 'default' => '7' ), 'scroll' => array(  'option' => 'otw-close-sticky-scroll', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Bar Percent' ), 'default' => '50' ), 'scrollto' => array(  'option' => 'otw-close-sticky-scrollto', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Element #id or .class' ), 'default' => '' ), 'clickon' => array(  'option' => 'otw-show-sticky-clickon', 'type' => 'text_input', 'label' => $this->get_label( 'Click On Element #id or .class' ), 'default' => '' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['options'] = array( 'otw-close-button' => $this->get_label( 'Show/Hide Button (default)' ), 'otw-close-forever' => $this->get_label( 'Close for ever' ), 'otw-close-page' => $this->get_label( 'Close until next page load' ), 'otw-close-loads' => $this->get_label( 'Close for number of page loads' ), 'otw-close-days' => $this->get_label( 'Close for number of days' ), 'otw-never-close' => $this->get_label( 'Never close' ), 'otw-close-sticky-scroll' => $this->get_label( 'Scroll Bar Percent' ), 'otw-close-sticky-scrollto' => $this->get_label( 'Scroll to Element #id or .class' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['label'] = $this->get_label( 'Overlay Close Options' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['default'] = 'otw-close-button';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['description'] = $this->get_label( 'Show/Hide Button will place Show/Hide button for Full Bar and Side Box overlay types. The rest of the close options are user session based. Meaning that if a user closes an ovelay it closes for him only. If another user loads the same page he sees the overlay until he decides to close it.' );
		
		//show_button_label
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['label'] = $this->get_label( 'Show Button Label' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label']['description'] = $this->get_label( 'Change the label for the Show button. If this field is left empty the button will be labeled \'Show\'. HTML is allowed.' );
		
		//button_label_orientation
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['target'] = 'show_button_class';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['options'] = array( 'otw-btn-horizontal' => $this->get_label( 'Horizontal (default)' ), 'otw-btn-vertical' => $this->get_label( 'Vertical' )  );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['label'] = $this->get_label( 'Show Button Label Orientation' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['default'] = 'otw-btn-horizontal';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_orientation']['description'] = $this->get_label( 'Text orientation' );
		
		//button_label_icon
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['options'] = $this->settings['icon_types'];
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['label'] = $this->get_label( 'Show Button Label Icon' );
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['default'] = $this->settings['default_icon_type'];
		$this->overlay_types[ $type ]['options']['main']['items']['show_button_label_icon']['description'] = $this->get_label( 'Choose Show Button Label Icon.' );
		
		//close_button_label
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['label'] = $this->get_label( 'Hide Button Label' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['default'] = html_entity_decode( '&times;' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label']['description'] = $this->get_label( 'Change the label for the Hide Button. If this field is left empty the default "X" close button will be displayed. HTML is allowed.' );
		
		//close_button_label_icon
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['options'] = $this->settings['icon_types'];
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['label'] = $this->get_label( 'Hide Button Label Icon' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['default'] = $this->settings['default_icon_type'];
		$this->overlay_types[ $type ]['options']['main']['items']['close_button_label_icon']['description'] = $this->get_label( 'Choose Hide Button Label Icon' );
		
		//height_from_top
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['type'] = 'height_from';
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['subfields'] = array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => '%' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['label'] = $this->get_label( 'Height from Top' );
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_top']['description'] = '';
		
		//height_from_bottom
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['type'] = 'height_from';
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['subfields'] = array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => '%' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['label'] = $this->get_label( 'Height from Bottom' );
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['height_from_bottom']['description'] = $this->get_label( 'Position your overlay on for example 10% of the screen height from the top or from the bottom of the screen. Or 10px from top or bottom of the page. Height from top has priority over Height from bottom.' );
		
		//content_width
		$this->overlay_types[ $type ]['options']['main']['items']['content_width'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['type'] = 'content_width';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['subfields'] =  array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => 'px' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['label'] = $this->get_label( 'Content Width' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['description'] = $this->get_label( 'The width of your content in px or %. If left empty this means the content is fluid.' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['options'] = array();
		
		//content_position
		$this->overlay_types[ $type ]['options']['main']['items']['content_position'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['options'] = array( 'otw-align-left' => $this->get_label( 'Left (default)' ), 'otw-align-center' => $this->get_label( 'Center' ), 'otw-align-right' => $this->get_label( 'Right' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['label'] = $this->get_label( 'Content Position' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['default'] = 'otw-align-left';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['description'] = $this->get_label( 'Choose the position of the content inside of the container.' );
		
		//devices
		$this->overlay_types[ $type ]['options']['main']['items']['devices'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['type'] = 'checkboxes';
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['options'] = array( 'device_large' => 'Large Screens', 'device_small' => 'Small Screens' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['label'] = $this->get_label( 'Enable Overlay on Devices' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['default'] = array( 'device_large' => 'yes', 'device_small' => 'no' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['description'] = $this->get_label( 'Large Screens means display on screens above 768 px. Small Screens means display on screens smaller than 768 px.' );
		
		//enable_content_scrolling
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['options'] = array( '' => $this->get_label( 'No (default)' ), 'otw-small-csr' => $this->get_label( 'Yes' )  );
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['label'] = $this->get_label( 'Scrolling content' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['description'] = $this->get_label( 'Scrolling content for screens smaller than the popup content' );
		
		//Show Powered by link
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['label'] = $this->get_label( 'Show Powered by Link' );
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['description'] = $this->get_label( 'Want to make some money and help us spread the word for this wonderful plugin? Enter your CodeCanyon.net username and we will build and place a referral link for you at the bottom of your overlay. You earn money from all users that purchase anything from the market. <a href="http://codecanyon.net/make_money/affiliate_program" target="_blank">More info</a>.' );
		
		//shortcode link text
		$this->overlay_types[ $type ]['options']['main']['items']['link_text'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['label'] = $this->get_label( 'Shortcode Link and Button Text' );
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['default'] = 'Click to open';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['description'] = $this->get_label( 'Every overlay has a shortcodes that you can copy form the list of all overlays. The shortcodes generate a link or a button that when clicked open the overlay. This option allows you to change the text in the link and the button. The following options will not affect the overlay when the site user click on a shortcode link: Visibility Options, Overlay Load Event, Overlay First Load and Overlay Close Options.' );
		
		//z-index
		$this->overlay_types[ $type ]['options']['main']['items']['zindex'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['label'] = $this->get_label( 'z-Index' );
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['description'] = $this->get_label( 'The z-index specifies the stack order of an overlay. An overlay with greater stack order is always in front of an overlay with a lower stack order. This can be used when you show more than one overlay on the same page.' );
		
		//active_period
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['type'] = 'active_periods';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['label'] = $this->get_label( 'Active Periods' );
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['description'] = $this->get_label( 'Set up as many activation periods as you need. The overlay will be visible on your site for the periods you add here. If no period is set this means the overlay is active all the time. Your current server date and time is: ' ).date( 'd.m.Y H:i T' );
		
		//styling
		$this->overlay_types[ $type ]['options']['styling'] = array();
		$this->overlay_types[ $type ]['options']['styling']['label'] = $this->get_label( 'Styling Options' );
		$this->overlay_types[ $type ]['options']['styling']['items'] = array();
		
		//shadow
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['target'] = 'section_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['options'] = array( '' => $this->get_label( 'None' ), 'otw-sticky-shadow-small' => $this->get_label( 'Small (default)' ), 'otw-sticky-shadow-large' => $this->get_label( 'Large' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['label'] = $this->get_label( 'Shadow' );
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['default'] = 'otw-sticky-shadow-small';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['description'] = $this->get_label( 'Choose shadow type.' );
		
		//border
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['options'] = array( '' => $this->get_label( '0px (default)' ), '1' => $this->get_label( '1px' ), '2' => $this->get_label( '2px' ), '3' => $this->get_label( '3px' ), '4' => $this->get_label( '4px' ), '5' => $this->get_label( '5px' ), '6' => $this->get_label( '6px' ), '7' => $this->get_label( '7px' ), '8' => $this->get_label( '8px' ), '9' => $this->get_label( '9px' ), '10' => $this->get_label( '10px' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['label'] = $this->get_label( 'Border Width' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['description'] = $this->get_label( 'Choose border width.' );
		
		//border_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['options'] = array( 'otw-sticky-border-black' => $this->get_label( 'Black (default)' ), 'otw-sticky-border-white' => $this->get_label( 'White' ), 'otw-sticky-border-red' => $this->get_label( 'Red' ), 'otw-sticky-border-orange' => $this->get_label( 'Orange' ), 'otw-sticky-border-green' => $this->get_label( 'Green' ), 'otw-sticky-border-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-border-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-border-blue' => $this->get_label( 'Blue' ), 'otw-sticky-border-pink' => $this->get_label( 'Pink' ), 'otw-sticky-border-purple' => $this->get_label( 'Purple' ), 'otw-sticky-border-silver' => $this->get_label( 'Silver' ), 'otw-sticky-border-brown' => $this->get_label( 'Brown' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['label'] = $this->get_label( 'Border Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['default'] = 'otw-sticky-border-black';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['description'] = $this->get_label( 'Choose border color.' );
		
		//border_style_class
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['options'] = array( 'otw-sticky-border-type-solid' => $this->get_label( 'solid (default)' ), 'otw-sticky-border-type-dashed' => $this->get_label( 'dashed' ), 'otw-sticky-border-type-dotted' => $this->get_label( 'dotted' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['label'] = $this->get_label( 'Border Style' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['default'] = 'otw-sticky-border-type-solid';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['description'] = $this->get_label( 'Choose border style.' );
		
		//rounded_corners
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-sticky-rounded-border-3' => $this->get_label( '3px' ), 'otw-sticky-rounded-border-5' => $this->get_label( '5px' ), 'otw-sticky-rounded-border-10' => $this->get_label( '10px' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['label'] = $this->get_label( 'Rounded Corners' );
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['description'] = $this->get_label( 'Choose rounded corners.' );
		
		//background_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['target'] = 'section_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['options'] = array( 'otw-sticky-transparent' => $this->get_label( 'Transparent' ), 'otw-sticky-background-red' => $this->get_label( 'Red' ), 'otw-sticky-background-orange' => $this->get_label( 'Orange' ), 'otw-sticky-background-green' => $this->get_label( 'Green' ), 'otw-sticky-background-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-background-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-background-blue' => $this->get_label( 'Blue' ), 'otw-sticky-background-pink' => $this->get_label( 'Pink' ), 'otw-sticky-background-purple' => $this->get_label( 'Purple' ), 'otw-sticky-background-silver' => $this->get_label( 'Silver' ), 'otw-sticky-background-brown' => $this->get_label( 'Brown' ), 'otw-sticky-background-black' => $this->get_label( 'Black' ), 'otw-sticky-background-white' => $this->get_label( 'White (default)' ), 'otw-sticky-background-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-background-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-background-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-background-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-background-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-background-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-background-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-background-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-background-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-background-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-background-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-background-light-white' => $this->get_label( 'Light White' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['label'] = $this->get_label( 'Background Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['default'] = 'otw-sticky-background-white';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['description'] = $this->get_label( 'Choose background color.' );
		
		//background_pattern_class
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['target'] = 'section_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-sticky-background-pattern-1' => $this->get_label( 'Cream Pixels' ), 'otw-sticky-background-pattern-2' => $this->get_label( 'Dimension' ), 'otw-sticky-background-pattern-3' => $this->get_label( 'Grey' ), 'otw-sticky-background-pattern-4' => $this->get_label( 'Greyzz' ), 'otw-sticky-background-pattern-5' => $this->get_label( 'Pw Pattern' ), 'otw-sticky-background-pattern-6' => $this->get_label( 'Skelatal Weave' ), 'otw-sticky-background-pattern-7' => $this->get_label( 'Stitch' ), 'otw-sticky-background-pattern-8' => $this->get_label( 'Dubtle Grunge' ), 'otw-sticky-background-pattern-9' => $this->get_label( 'Swirl' ), 'otw-sticky-background-pattern-10' => $this->get_label( 'Wood Pattern' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['label'] = $this->get_label( 'Background Pattern' );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['description'] = $this->get_label( 'Choose a background pattern.' );
		
		//show_hide_background_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['target'] = 'show_hide_button_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['options'] = array( 'otw-sticky-background-red' => $this->get_label( 'Red' ), 'otw-sticky-background-orange' => $this->get_label( 'Orange' ), 'otw-sticky-background-green' => $this->get_label( 'Green' ), 'otw-sticky-background-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-background-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-background-blue' => $this->get_label( 'Blue' ), 'otw-sticky-background-pink' => $this->get_label( 'Pink' ), 'otw-sticky-background-purple' => $this->get_label( 'Purple' ), 'otw-sticky-background-silver' => $this->get_label( 'Silver' ), 'otw-sticky-background-brown' => $this->get_label( 'Brown' ), 'otw-sticky-background-black' => $this->get_label( 'Black (default)' ), 'otw-sticky-background-white' => $this->get_label( 'White' ), 'otw-sticky-background-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-background-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-background-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-background-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-background-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-background-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-background-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-background-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-background-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-background-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-background-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-background-light-white' => $this->get_label( 'Light White' ), 'otw-sticky-transparent' => $this->get_label( 'Transparent' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['label'] = $this->get_label( 'Show/Hide Button Background Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['default'] = 'otw-sticky-background-black';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_background_color_class']['description'] = $this->get_label( 'Choose a background color for the show/hide buttons.' );
		
		//show_hide_text_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['target'] = 'show_hide_button_class';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['options'] = array( 'otw-sticky-text-red' => $this->get_label( 'Red' ), 'otw-sticky-text-orange' => $this->get_label( 'Orange' ), 'otw-sticky-text-green' => $this->get_label( 'Green' ), 'otw-sticky-text-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-text-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-text-blue' => $this->get_label( 'Blue' ), 'otw-sticky-text-pink' => $this->get_label( 'Pink' ), 'otw-sticky-text-purple' => $this->get_label( 'Purple' ), 'otw-sticky-text-silver' => $this->get_label( 'Silver' ), 'otw-sticky-text-brown' => $this->get_label( 'Brown' ), 'otw-sticky-text-black' => $this->get_label( 'Black' ), 'otw-sticky-text-white' => $this->get_label( 'White (default)' ), 'otw-sticky-text-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-text-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-text-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-text-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-text-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-text-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-text-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-text-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-text-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-text-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-text-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-text-light-white' => $this->get_label( 'Light White' ), 'otw-sticky-transparent' => $this->get_label( 'Transparent' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['label'] = $this->get_label( 'Show/Hide Button Text Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['default'] = 'otw-sticky-text-white';
		$this->overlay_types[ $type ]['options']['styling']['items']['show_hide_text_color_class']['description'] = $this->get_label( 'Choose a text color for the show/hide buttons.' );
		
		//content top padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['label'] = $this->get_label( 'Content Top Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['description'] = '';
		
		//content right padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['label'] = $this->get_label( 'Content Right Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['description'] = '';
		
		//content bottom padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['label'] = $this->get_label( 'Content Bottom Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['description'] = '';
		
		//content left padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['label'] = $this->get_label( 'Content Left Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['description'] = $this->get_label( 'Add some space between your content and the box.' );
		
		//custom options
		$this->overlay_types[ $type ]['options']['custom'] = array();
		$this->overlay_types[ $type ]['options']['custom']['label'] = $this->get_label( 'Custom Styling Options' );
		$this->overlay_types[ $type ]['options']['custom']['items'] = array();
		
		//border_color
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['label'] = $this->get_label( 'Border Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['description'] = $this->get_label( 'Choose a custom border color.' );
		
		//background_color
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['label'] = $this->get_label( 'Background Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['description'] = $this->get_label( 'Choose a custom background color.' );
		
		//background_pattern_url
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['label'] = $this->get_label( 'Background Pattern URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['description'] = $this->get_label( 'Choose a custom background pattern.' );
		
		//show_hide_background_color
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['label'] = $this->get_label( 'Show/Hide Button Background Bolor Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_background_color']['description'] = $this->get_label( 'Choose a custom background color for the show/hide buttons.' );
		
		//show_hide_text_color
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['label'] = $this->get_label( 'Show/Hide Button Text Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_hide_text_color']['description'] = $this->get_label( 'Choose a custom text color for the show/hide buttons.' );
		
		//show button custon icon
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['label'] = $this->get_label( 'Show Button Lable Icon URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['show_button_label_icon_url']['description'] = $this->get_label( 'Choose a custom icon.' );
		
		//close button custon icon
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['label'] = $this->get_label( 'Hide Button Lable Icon URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['close_button_label_icon_url']['description'] = $this->get_label( 'Choose a custom icon.' );
		
		//css_class_name
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['target'] = 'wrapper_class';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['label'] = $this->get_label( 'CSS Class' );
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['description'] = $this->get_label( 'If you\'d like to style this element separately enter a name here. A CSS class with this name will be available for you to style this particular element.' );
		
	}
	
	/**
	 * light box options
	 */
	private function init_lightbox_types()
	{
		$type = 'lightbox';
		
		$this->overlay_types[ $type ] = array();
		$this->overlay_types[ $type ]['label'] = $this->get_label( 'Lightbox' );
		$this->overlay_types[ $type ]['options'] = array();
		
		//options
		$this->overlay_types[ $type ]['options']['main'] = array();
		$this->overlay_types[ $type ]['options']['main']['label'] = $this->get_label( 'Overlay Options' );
		$this->overlay_types[ $type ]['options']['main']['items'] = array();
		
		//open_type
		$this->overlay_types[ $type ]['options']['main']['items']['open_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['type'] = 'select_subfields';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['subfields'] = array( 'delay' => array( 'option' => 'otw-show-sticky-delay', 'type' => 'text_input', 'label' => $this->get_label( 'On Page Load with Delay' ), 'default' => '1000' ), 'loads' => array( 'option' => 'otw-show-sticky-loads', 'type' => 'text_input', 'label' => $this->get_label( 'After a Number of Page Views' ), 'default' => '1' ), 'seconds' => array( 'option' => 'otw-show-sticky-seconds', 'type' => 'text_input', 'label' => $this->get_label( 'After Number of Seconds Spent on the Site' ), 'default' => '60' ), 'scroll' => array(  'option' => 'otw-show-sticky-scroll', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Bar Percent' ), 'default' => '50' ), 'scrollto' => array(  'option' => 'otw-show-sticky-scrollto', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Element #id or .class' ), 'default' => '' ), 'clickon' => array(  'option' => 'otw-show-sticky-clickon', 'type' => 'text_input', 'label' => $this->get_label( 'Click On Element #id or .class' ), 'default' => '' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['options'] = array( 'otw-show-sticky-load' => $this->get_label( 'On Page Load (default)' ), 'otw-show-sticky-delay' => $this->get_label( 'On Page Load with Delay' ), 'otw-show-sticky-loads' => $this->get_label( 'After a Number of Page Views' ), 'otw-show-sticky-seconds' => $this->get_label( 'After Number of Seconds Spent on the Site' ), 'otw-show-sticky-mouse' => $this->get_label( 'On Exit Intent' ), 'otw-show-sticky-wooab' => $this->get_label( 'WooCommerce abandoners' ), 'otw-show-sticky-scroll' => $this->get_label( 'Scroll Bar Percent' ), 'otw-show-sticky-scrollto' => $this->get_label( 'Scroll to Element #id or .class' ), 'otw-show-sticky-clickon' => $this->get_label( 'Click on Element #id or .class' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['label'] = $this->get_label( 'Overlay Load Event' );
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['default'] = 'otw-show-sticky-load';
		$this->overlay_types[ $type ]['options']['main']['items']['open_type']['description'] = $this->get_label( 'Choose the event that will open your overlay. Most popular is On Page Load. <br>On Page Load with Delay is the milliseconds before the loading of the overlay. <br>After a number of page views means the overlay will be loaded after the entered number of page views for the user, not on the first page view. <br>After Number of Seconds Spent on the Site means the user will have to spend the entered number of seconds before the overlay is loaded. <br>On Exist Intent can be used for showing something to the users that intend to leave your site.<br>WooCommerce abandoners will load the overlay if the site user intends to leave and he has something in his WooCommerce cart. <br>Scroll Bar Percent 30 means that the overlay will be triggered when the user scrolls down to 30% of the page. <br>Scroll/Click Element #id or .class means the overlay will be triggered when the user scrolls/clicks on an #id or .class that is in the page\'s HTML structure.' );
		
		//close_type
		$this->overlay_types[ $type ]['options']['main']['items']['close_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['type'] = 'select_subfields';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['subfields'] = array( 'loads' => array( 'option' => 'otw-close-loads', 'type' => 'text_input', 'label' => $this->get_label( 'Number Of Page Loads' ), 'default' => '5' ), 'days' => array( 'option' => 'otw-close-days', 'type' => 'text_input', 'label' => $this->get_label( 'Number Of Days' ), 'default' => '7' ), 'scroll' => array(  'option' => 'otw-close-sticky-scroll', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Bar Percent' ), 'default' => '50' ), 'scrollto' => array(  'option' => 'otw-close-sticky-scrollto', 'type' => 'text_input', 'label' => $this->get_label( 'Scroll Element #id or .class' ), 'default' => '' ), 'clickon' => array(  'option' => 'otw-show-sticky-clickon', 'type' => 'text_input', 'label' => $this->get_label( 'Click On Element #id or .class' ), 'default' => '' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['options'] = array( 'otw-close-forever' => $this->get_label( 'Close for ever (default)' ), 'otw-close-page' => $this->get_label( 'Close until next page load' ), 'otw-close-loads' => $this->get_label( 'Close for number of page loads' ), 'otw-close-days' => $this->get_label( 'Close for number of days' ), 'otw-never-close' => $this->get_label( 'Never close' ), 'otw-close-sticky-scroll' => $this->get_label( 'Scroll Bar Percent' ), 'otw-close-sticky-scrollto' => $this->get_label( 'Scroll to Element #id or .class' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['label'] = $this->get_label( 'Overlay Close Options' );
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['default'] = 'otw-close-forever';
		$this->overlay_types[ $type ]['options']['main']['items']['close_type']['description'] = $this->get_label( 'All of the close options are user session based. Meaning that if a user closes an ovelay it closes for him only. If another user loads the same page he sees the overlay until he decides to close it.' );
		
		//enable close button
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button']['options'] = array( '' => $this->get_label( 'Yes (default)' ), 'otw-no-close-button' => $this->get_label( 'No' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button']['label'] = $this->get_label( 'Enable Close Button' );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_button']['description'] = $this->get_label( 'Enables the close button.' );
		
		//enble close on content
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content']['options'] = array( 'otw-close-on-content' => $this->get_label( 'Yes' ), '' => $this->get_label( 'No (default)' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content']['label'] = $this->get_label( 'Enable Close on Content Click' );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_content']['description'] = $this->get_label( 'Closes the popup on content click.' );
		
		//enble close on background
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background']['options'] = array( '' => $this->get_label( 'Yes (default)' ), 'otw-no-close-bkg' => $this->get_label( 'No' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background']['label'] = $this->get_label( 'Enable Close on Background Click' );
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['enable_close_on_background']['description'] = $this->get_label( 'Closes the popup on click on the background outside of the content.' );
		
		//content_width
		$this->overlay_types[ $type ]['options']['main']['items']['content_width'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['type'] = 'content_width';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['subfields'] =  array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => 'px' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['label'] = $this->get_label( 'Content Width' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['default'] = '500';
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['description'] = $this->get_label( 'The width of your content in px or %. If left empty this means the content is fluid.' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_width']['options'] = array();
		
		//min_content_width
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['type'] = 'min_content_width';
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['subfields'] =  array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => 'px' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['label'] = $this->get_label( 'Minimum Content Width' );
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['description'] = $this->get_label( 'The minimum width of your content in px or %.' );
		$this->overlay_types[ $type ]['options']['main']['items']['min_content_width']['options'] = array();
		
		//max_content_width
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['type'] = 'max_content_width';
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['subfields'] =  array( 'unit' => array( 'options' => array( '%' => $this->get_label( '%' ), 'px' => $this->get_label( 'px' ) ), 'default' => 'px' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['label'] = $this->get_label( 'Maximum Content Width' );
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['description'] = $this->get_label( 'The maximum width of your content in px or %.' );
		$this->overlay_types[ $type ]['options']['main']['items']['max_content_width']['options'] = array();
		
		//content_position
		$this->overlay_types[ $type ]['options']['main']['items']['content_position'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['options'] = array( 'otw-align-left' => $this->get_label( 'Left (default)' ), 'otw-align-center' => $this->get_label( 'Center' ), 'otw-align-right' => $this->get_label( 'Right' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['label'] = $this->get_label( 'Content Position' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['default'] = 'otw-align-left';
		$this->overlay_types[ $type ]['options']['main']['items']['content_position']['description'] = $this->get_label( 'Choose the position of the content inside of the container.' );
		
		//animation type
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type']['options'] = array( '' => $this->get_label( 'None' ), 'mfp-zoom-in' => $this->get_label( 'Zoom in(default)' ), 'mfp-newspaper' => $this->get_label( 'Newspaper' ), 'mfp-move-horizontal' => $this->get_label( 'Move Horizontal' ), 'mfp-move-from-top' => $this->get_label( 'Move from Top' ), 'mfp-3d-unfold' => $this->get_label( '3D Unfold' ), 'mfp-zoom-out' => $this->get_label( 'Zoom out' ), 'hinge' => $this->get_label( 'Hinge' ) );
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type']['label'] = $this->get_label( 'Animation Type' );
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type']['default'] = 'mfp-zoom-in';
		$this->overlay_types[ $type ]['options']['main']['items']['animation_type']['description'] = $this->get_label( 'Choose the type of the animation.' );
		
		//devices
		$this->overlay_types[ $type ]['options']['main']['items']['devices'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['type'] = 'checkboxes';
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['options'] = array( 'device_large' => 'Large Screens', 'device_small' => 'Small Screens' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['label'] = $this->get_label( 'Enable Overlay on Devices' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['default'] = array( 'device_large' => 'yes', 'device_small' => 'no' );
		$this->overlay_types[ $type ]['options']['main']['items']['devices']['description'] = $this->get_label( 'Large Screens means display on screens above 768 px. Small Screens means display on screens smaller than 768 px.' );
		
		//enable_content_scrolling
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['options'] = array( '' => $this->get_label( 'No (default)' ), 'otw-small-csr' => $this->get_label( 'Yes' )  );
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['label'] = $this->get_label( 'Scrolling content' );
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['content_scrolling']['description'] = $this->get_label( 'Scrolling content for screens smaller than the popup content' );
		
		//Show Powered by link
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['label'] = $this->get_label( 'Show Powered by Link' );
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['affiliate_username']['description'] = $this->get_label( 'Want to make some money and help us spread the word for this wonderful plugin? Enter your CodeCanyon.net username and we will build and place a referral link for you at the bottom of your overlay. You earn money from all users that purchase anything from the market. <a href="http://codecanyon.net/make_money/affiliate_program" target="_blank">More info</a>.' );
		
		//shortcode link text
		$this->overlay_types[ $type ]['options']['main']['items']['link_text'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['label'] = $this->get_label( 'Shortcode Link and Button Text' );
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['default'] = 'Click to open';
		$this->overlay_types[ $type ]['options']['main']['items']['link_text']['description'] = $this->get_label( 'Every overlay has a shortcodes that you can copy form the list of all overlays. The shortcodes generate a link or a button that when clicked open the overlay. This option allows you to change the text in the link and the button. The following options will not affect the overlay when the site user click on a shortcode link: Visibility Options, Overlay Load Event, Overlay First Load and Overlay Close Options.' );
		
		//z-index
		$this->overlay_types[ $type ]['options']['main']['items']['zindex'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['options'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['label'] = $this->get_label( 'z-Index' );
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['zindex']['description'] = $this->get_label( 'The z-index specifies the stack order of an overlay. An overlay with greater stack order is always in front of an overlay with a lower stack order. This can be used when you show more than one overlay on the same page.' );
		
		//active_period
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods'] = array();
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['type'] = 'active_periods';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['label'] = $this->get_label( 'Active Periods' );
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['default'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['target'] = '';
		$this->overlay_types[ $type ]['options']['main']['items']['active_periods']['description'] = $this->get_label( 'Set up as many activation periods as you need. The overlay will be visible on your site for the periods you add here. If no period is set this means the overlay is active all the time. Your current server date and time is: ' ).date( 'd.m.Y H:i T' );
		
		//styling
		$this->overlay_types[ $type ]['options']['styling'] = array();
		$this->overlay_types[ $type ]['options']['styling']['label'] = $this->get_label( 'Styling Options' );
		$this->overlay_types[ $type ]['options']['styling']['items'] = array();
		
		//shadow
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['options'] = array( '' => $this->get_label( 'None' ), 'otw-sticky-shadow-small' => $this->get_label( 'Small (default)' ), 'otw-sticky-shadow-large' => $this->get_label( 'Large' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['label'] = $this->get_label( 'Shadow' );
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['default'] = 'otw-sticky-shadow-small';
		$this->overlay_types[ $type ]['options']['styling']['items']['shadow']['description'] = $this->get_label( 'Choose Shadow Type.' );
		
		//border
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['options'] = array( '' => $this->get_label( '0px (default)' ), '1' => $this->get_label( '1px' ), '2' => $this->get_label( '2px' ), '3' => $this->get_label( '3px' ), '4' => $this->get_label( '4px' ), '5' => $this->get_label( '5px' ), '6' => $this->get_label( '6px' ), '7' => $this->get_label( '7px' ), '8' => $this->get_label( '8px' ), '9' => $this->get_label( '9px' ), '10' => $this->get_label( '10px' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['label'] = $this->get_label( 'Border Width' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_width']['description'] = $this->get_label( 'Choose border width.' );
		
		//border_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['options'] = array( 'otw-sticky-border-black' => $this->get_label( 'Black (default)' ), 'otw-sticky-border-white' => $this->get_label( 'White' ), 'otw-sticky-border-red' => $this->get_label( 'Red' ), 'otw-sticky-border-orange' => $this->get_label( 'Orange' ), 'otw-sticky-border-green' => $this->get_label( 'Green' ), 'otw-sticky-border-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-border-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-border-blue' => $this->get_label( 'Blue' ), 'otw-sticky-border-pink' => $this->get_label( 'Pink' ), 'otw-sticky-border-purple' => $this->get_label( 'Purple' ), 'otw-sticky-border-silver' => $this->get_label( 'Silver' ), 'otw-sticky-border-brown' => $this->get_label( 'Brown' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['label'] = $this->get_label( 'Border Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['default'] = 'otw-sticky-border-black';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_color_class']['description'] = $this->get_label( 'Choose border color.' );
		
		//border_style_class
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['options'] = array( 'otw-sticky-border-type-solid' => $this->get_label( 'solid (default)' ), 'otw-sticky-border-type-dashed' => $this->get_label( 'dashed' ), 'otw-sticky-border-type-dotted' => $this->get_label( 'dotted' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['label'] = $this->get_label( 'Border Style' );
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['default'] = 'otw-sticky-border-type-solid';
		$this->overlay_types[ $type ]['options']['styling']['items']['border_style_class']['description'] = $this->get_label( 'Choose border style.' );
		
		//rounded_corners
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-sticky-rounded-border-3' => $this->get_label( '3px' ), 'otw-sticky-rounded-border-5' => $this->get_label( '5px' ), 'otw-sticky-rounded-border-10' => $this->get_label( '10px' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['label'] = $this->get_label( 'Rounded Corners' );
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['rounded_corners']['description'] = $this->get_label( 'Choose rounded corners.' );
		
		//background_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['options'] = array( 'otw-sticky-transparent' => $this->get_label( 'Transparent' ), 'otw-sticky-background-red' => $this->get_label( 'Red' ), 'otw-sticky-background-orange' => $this->get_label( 'Orange' ), 'otw-sticky-background-green' => $this->get_label( 'Green' ), 'otw-sticky-background-greenish' => $this->get_label( 'Greenish' ), 'otw-sticky-background-aqua' => $this->get_label( 'Aqua' ), 'otw-sticky-background-blue' => $this->get_label( 'Blue' ), 'otw-sticky-background-pink' => $this->get_label( 'Pink' ), 'otw-sticky-background-purple' => $this->get_label( 'Purple' ), 'otw-sticky-background-silver' => $this->get_label( 'Silver' ), 'otw-sticky-background-brown' => $this->get_label( 'Brown' ), 'otw-sticky-background-black' => $this->get_label( 'Black' ), 'otw-sticky-background-white' => $this->get_label( 'White (default)' ), 'otw-sticky-background-light-red' => $this->get_label( 'Light Red' ), 'otw-sticky-background-light-orange' => $this->get_label( 'Light Orange' ), 'otw-sticky-background-light-green' => $this->get_label( 'Light Green' ), 'otw-sticky-background-light-greenish' => $this->get_label( 'Light Greenish' ), 'otw-sticky-background-light-aqua' => $this->get_label( 'Light Aqua' ), 'otw-sticky-background-light-blue' => $this->get_label( 'Light Blue' ), 'otw-sticky-background-light-pink' => $this->get_label( 'Light Pink' ), 'otw-sticky-background-light-purple' => $this->get_label( 'Light Purple' ), 'otw-sticky-background-light-silver' => $this->get_label( 'Light Silver' ), 'otw-sticky-background-light-brown' => $this->get_label( 'Light Brown' ), 'otw-sticky-background-light-black' => $this->get_label( 'Light Black' ), 'otw-sticky-background-light-white' => $this->get_label( 'Light White' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['label'] = $this->get_label( 'Background Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['default'] = 'otw-sticky-background-white';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_color_class']['description'] = $this->get_label( 'Choose background color.' );
		
		//background_pattern_class
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-sticky-background-pattern-1' => $this->get_label( 'Cream Pixels' ), 'otw-sticky-background-pattern-2' => $this->get_label( 'Dimension' ), 'otw-sticky-background-pattern-3' => $this->get_label( 'Grey' ), 'otw-sticky-background-pattern-4' => $this->get_label( 'Greyzz' ), 'otw-sticky-background-pattern-5' => $this->get_label( 'Pw Pattern' ), 'otw-sticky-background-pattern-6' => $this->get_label( 'Skelatal Weave' ), 'otw-sticky-background-pattern-7' => $this->get_label( 'Stitch' ), 'otw-sticky-background-pattern-8' => $this->get_label( 'Dubtle Grunge' ), 'otw-sticky-background-pattern-9' => $this->get_label( 'Swirl' ), 'otw-sticky-background-pattern-10' => $this->get_label( 'Wood Pattern' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['label'] = $this->get_label( 'Background Pattern' );
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['background_pattern_class']['description'] = $this->get_label( 'Choose a background pattern.' );
		
		//content top padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['label'] = $this->get_label( 'Content Top Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_top']['description'] = '';
		
		//content right padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['label'] = $this->get_label( 'Content Right Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_right']['description'] = '';
		
		//content bottom padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['label'] = $this->get_label( 'Content Bottom Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_bottom']['description'] = '';
		
		//content left padding
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['target'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['options'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['label'] = $this->get_label( 'Content Left Padding' );
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['content_padding_left']['description'] = $this->get_label( 'Add some space between your content and the box.' );
		
		//overlay_color_class
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class']['target'] = 'data-effect';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-black-overlay' => $this->get_label( 'Black' ), 'otw-white-overlay' => $this->get_label( 'White' ), 'otw-red-overlay' => $this->get_label( 'Red' ), 'otw-orange-overlay' => $this->get_label( 'Orange' ), 'otw-green-overlay' => $this->get_label( 'Green' ), 'otw-greenish-overlay' => $this->get_label( 'Greenish' ), 'otw-aqua-overlay' => $this->get_label( 'Aqua' ), 'otw-blue-overlay' => $this->get_label( 'Blue' ), 'otw-pink-overlay' => $this->get_label( 'Pink' ), 'otw-purple-overlay' => $this->get_label( 'Purple' ), 'otw-silver-overlay' => $this->get_label( 'Silver' ), 'otw-brown-overlay' => $this->get_label( 'Brown' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class']['label'] = $this->get_label( 'Overlay Color' );
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_color_class']['description'] = $this->get_label( 'Choose the overlay color.' );
		
		//overlay_pattern_class
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class']['target'] = 'data-effect';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class']['options'] = array( '' => $this->get_label( 'none (default)' ), 'otw-overlay-pattern-1' => $this->get_label( 'Cream Pixels' ), 'otw-overlay-pattern-2' => $this->get_label( 'Dimension' ), 'otw-overlay-pattern-3' => $this->get_label( 'Grey' ), 'otw-overlay-pattern-4' => $this->get_label( 'Greyzz' ), 'otw-overlay-pattern-5' => $this->get_label( 'Pw Pattern' ), 'otw-overlay-pattern-6' => $this->get_label( 'Skelatal Weave' ), 'otw-overlay-pattern-7' => $this->get_label( 'Stitch' ), 'otw-overlay-pattern-8' => $this->get_label( 'Dubtle Grunge' ), 'otw-overlay-pattern-9' => $this->get_label( 'Swirl' ), 'otw-overlay-pattern-10' => $this->get_label( 'Wood Pattern' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class']['label'] = $this->get_label( 'Overlay Pattern' );
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class']['default'] = '';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_pattern_class']['description'] = $this->get_label( 'Choose the overlay pattern.' );
		
		//overlay_opacity_class
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class'] = array();
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class']['target'] = 'data-effect';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class']['options'] = array( 'otw-opacity-0' => $this->get_label( '0' ), 'otw-opacity-10' => $this->get_label( '0.1' ), 'otw-opacity-20' => $this->get_label( '0.2' ), 'otw-opacity-30' => $this->get_label( '0.3' ), 'otw-opacity-40' => $this->get_label( '0.4 (default)' ), 'otw-opacity-50' => $this->get_label( '0.5' ), 'otw-opacity-60' => $this->get_label( '0.6' ), 'otw-opacity-70' => $this->get_label( '0.7' ), 'otw-opacity-80' => $this->get_label( '0.8' ), 'otw-opacity-90' => $this->get_label( '0.9' ), 'otw-opacity-100' => $this->get_label( '1' ) );
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class']['label'] = $this->get_label( 'Overlay Opacity' );
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class']['default'] = 'otw-opacity-40';
		$this->overlay_types[ $type ]['options']['styling']['items']['overlay_opacity_class']['description'] = $this->get_label( 'Choose the overlay opacity.' );
		
		//custom options
		$this->overlay_types[ $type ]['options']['custom'] = array();
		$this->overlay_types[ $type ]['options']['custom']['label'] = $this->get_label( 'Custom Styling Options' );
		$this->overlay_types[ $type ]['options']['custom']['items'] = array();
		
		//border_color
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['label'] = $this->get_label( 'Border Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['border_color']['description'] = $this->get_label( 'Choose a custom border color.' );
		
		//background_color
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['label'] = $this->get_label( 'Background Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_color']['description'] = $this->get_label( 'Choose a custom background color.' );
		
		//background_pattern_url
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['label'] = $this->get_label( 'Background Pattern URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['background_pattern_url']['description'] = $this->get_label( 'Choose a custom background pattern.' );
		
		//overlay_color
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color']['type'] = 'color_picker';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color']['label'] = $this->get_label( 'Overlay Color Custom' );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_color']['description'] = $this->get_label( 'Choose a custom background color for the overlay.' );
		
		//overlay_pattern_url
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['type'] = 'uploader';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['label'] = $this->get_label( 'Overlay Background Pattern URL' );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_url']['description'] = $this->get_label( 'Choose a custom background pattern for the overlay.' );
		
		//overlay pattern repeat
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['type'] = 'select';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['target'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['options'] = array( '' => $this->get_label( 'Yes (default)' ), 'otw-ovr-bkg-norepeat' => $this->get_label( 'No' ) );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['label'] = $this->get_label( 'Overlay Background Pattern Repeat' );
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['overlay_pattern_repeat']['description'] = $this->get_label( 'Repeat image on background pattern' );
		
		//css_class_name
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['type'] = 'input_text';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['target'] = 'class';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['options'] = array();
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['label'] = $this->get_label( 'CSS Class' );
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['default'] = '';
		$this->overlay_types[ $type ]['options']['custom']['items']['css_class_name']['description'] = $this->get_label( 'If you\'d like to style this element separately enter a name here. A CSS class with this name will be available for you to style this particular element.' );
	}
	
	/**
	 * Overlay shortcode link
	 */
	public function shortcode_overlay_link( $params, $content ){
		
		$link = '<a';
		
		if( isset( $params['id'] ) ){
			
			$link .= ' href="#'.$params['id'].'"';
			
			$attributes = array();
			
			$overlays = get_option( $this->option_name );
			
			if( is_array( $overlays ) && array_key_exists( $params['id'], $overlays ) ){
				
				$overlay = $overlays[ $params['id'] ];
				
				if( isset( $overlay['status'] )  && ( $overlay['status' ] == 'active' ) ){
				
					$s_attributes = $this->get_shortcode_link_attributes( $overlay );
					
					foreach( $s_attributes as $s_name => $s_value ){
					
						if( isset( $attributes[ $s_name ] ) && strlen( $attributes[ $s_name ] ) ){
							$attributes[ $s_name ] = $attributes[ $s_name ].' '.$s_value;
						}else{
							$attributes[ $s_name ] = $s_value;
						}
					}
					
				}
			}
		}
		
		foreach( $attributes as $a_key => $a_value ){
			$link .= ' '.$a_key.'="'.$a_value.'"';
		}
		
		$link .= '>';
		
		$link .= $content;
		
		$link .= '</a>';
		
		return $link;
	}
	
	/**
	 * Overlay shortcode button
	 */
	public function shortcode_overlay_button( $params, $content ){
		
		$link = '<a ';
		
		if( isset( $params['id'] ) ){
			
			$link .= ' href="#'.$params['id'].'"';
			
			$attributes = array();
			
			$overlays = get_option( $this->option_name );
			
			if( is_array( $overlays ) && array_key_exists( $params['id'], $overlays ) ){
				
				$overlay = $overlays[ $params['id'] ];
				
				if( isset( $overlay['status'] )  && ( $overlay['status' ] == 'active' ) ){
				
					$s_attributes = $this->get_shortcode_link_attributes( $overlay );
					
					foreach( $s_attributes as $s_name => $s_value ){
					
						if( isset( $attributes[ $s_name ] ) && strlen( $attributes[ $s_name ] ) ){
							$attributes[ $s_name ] = $attributes[ $s_name ].' '.$s_value;
						}else{
							$attributes[ $s_name ] = $s_value;
						}
					}
					
				}
			}
			$attributes['class'] = $attributes['class'].' button';
		}
		
		foreach( $attributes as $a_key => $a_value ){
			$link .= ' '.$a_key.'="'.$a_value.'"';
		}
		
		$link .= '>';
		
		$link .= $content;
		
		$link .= '</a>';
		
		return $link;
	}
	
	/**
	 * Output the outlays
	 *
	 */
	public function display_overlays(){
		
		$overlays = get_option( $this->option_name );
		
		if( is_array( $overlays ) ){
			
			$requested_objects = $this->get_current_object();
			
			foreach( $overlays as $overlay ){
			
				$is_active = $this->is_active( $overlay, $requested_objects );
				
				if( $is_active['active'] ){
				
					$this->_display_overlay( $overlay );
					
				}elseif( strlen( $is_active['replacement'] ) ){
					echo $is_active['replacement'];
				}
			}
		}
	}
	
	private function _display_overlay( $overlay, $from_link = false ){
	
	
					if( isset( $this->views[ $overlay['type'] ] ) ){
						
						$overlay_vars = array();
						$overlay_vars['id'] = $overlay['id'];
						$overlay_vars['show_label'] = 'Show';
						$overlay_vars['show_label_prefix'] = '';
						$overlay_vars['close_label'] = '&times;';
						$overlay_vars['close_label_prefix'] = '';
						$overlay_vars['close_button'] = true;
						$overlay_vars['content'] = '';
						$overlay_vars['class'] = $overlay['id'];
						$overlay_vars['style'] = '';
						$overlay_vars['data-effect'] = '';
						$overlay_vars['data-style'] = '';
						$overlay_vars['data-close-effect'] = '';
						$overlay_vars['wrapper_class'] = 'otw-sticky-wrapoer';
						$overlay_vars['section_class'] = 'otw-sticky-content';
						$overlay_vars['show_hide_button_class'] = '';
						$overlay_vars['show_hide_button_style'] = '';
						$overlay_vars['show_button_class'] = '';
						$overlay_vars['section_style'] = '';
						$overlay_vars['content_inner_style'] = '';
						$overlay_vars['data_param'] = '';
						$overlay_vars['data_index'] = '';
						$overlay_vars['affiliate_username'] = '';
						
						if( $overlay['type'] == 'lightbox' ){
							$overlay_vars['class'] = $this->append_attribute( $overlay_vars['class'], 'otw-white-popup mfp-with-anim' );
						}
						
						if( isset( $this->overlay_types[ $overlay['type'] ] ) && isset( $this->overlay_types[ $overlay['type'] ]['options'] ) ){
							
							foreach( $this->overlay_types[ $overlay['type'] ]['options'] as $option_type => $option_data ){
							
								foreach( $option_data['items'] as $element_name => $element_data ){
									
									//apply default value for not saved options
									switch( $element_name ){
										
										case 'show_button_label_orientation':
												if( !isset( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ){
													$overlay['options'][ $overlay['type'].'_'.$element_name ] = $element_data['default'];
												}
											break;
									}
									if( isset( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ){
									
										if( strlen( $element_data['target'] ) ){
											
											switch( $element_name ){
												
												case 'close_type':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
														
															switch( $overlay['type'] ){
																
																case 'lightbox':
																		switch( $overlay['options'][ $overlay['type'].'_'.$element_name ] ){
																			
																			case 'otw-never-close':
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					$overlay_vars['close_button'] = false;
																				break;
																			case 'otw-close-sticky-scrollto':
																					
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'] ) ){
																						$overlay_vars['data_param'] = ' data-closeparam="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'].'"';
																					}
																					
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-close-sticky-scroll':
																					
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'] ) ){
																						$overlay_vars['data_param'] = ' data-closeparam="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'].'"';
																					}
																					
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			default:
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																				break;
																		}
																	break;
																default:
																		switch( $overlay['options'][ $overlay['type'].'_'.$element_name ] ){
																			
																			case 'otw-never-close':
																					$overlay_vars['close_button'] = false;
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																				break;
																			case 'otw-close-sticky-scroll':
																					
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'] ) ){
																						$overlay_vars['data_param'] = ' data-closeparam="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'].'"';
																					}
																				break;
																			case 'otw-close-sticky-scrollto':
																					
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'] ) ){
																						$overlay_vars['data_param'] = ' data-closeparam="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'].'"';
																					}
																				break;
																			default:
																					$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																				break;
																		}
																	break;
															}
														}
													break;
												default:
														$overlay_vars[ $element_data['target'] ] = $this->append_attribute( $overlay_vars[ $element_data['target'] ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
													break;
											}
										}
										else
										{
											switch( $element_name ){
												
												case 'zindex':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															switch( $overlay['type'] ){
																case 'lightbox':
																		$overlay_vars['data_index'] = $this->append_attribute( $overlay_vars['data_index'], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																	break;
																default:
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'z-index: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
																	break;
															}
														}
													break;
												case 'background_pattern_url':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															switch( $overlay['type'] ){
																case 'lightbox':
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'background-image: url(\''.$overlay['options'][ $overlay['type'].'_'.$element_name ].'\');' );
																	break;
																default:
																		$overlay_vars['section_style'] = $this->append_attribute( $overlay_vars['section_style'], 'background-image: url(\''.$overlay['options'][ $overlay['type'].'_'.$element_name ].'\');' );
																	break;
															}
														}
													break;
												case 'border_color_class':
												case 'border_style_class':
												case 'rounded_corners':
														
														switch( $overlay['type'] ){
														
															case 'lightbox':
																	$target = 'class';
																break;
															default:
																	$target = 'section_class';
																break;
														}
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) && isset( $overlay['options'][ $overlay['type'].'_border_width'] ) && ( $overlay['options'][ $overlay['type'].'_border_width'] > 0 ) ){
															
															$overlay_vars[ $target ] = $this->append_attribute( $overlay_vars[ $target ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
														}
													break;
												case 'border_color':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) && isset( $overlay['options'][ $overlay['type'].'_border_width'] ) && ( $overlay['options'][ $overlay['type'].'_border_width'] > 0 ) ){
															switch( $overlay['type'] ){
																case 'lightbox':
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'border-color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
																	break;
																default:
																		$overlay_vars['section_style'] = $this->append_attribute( $overlay_vars['section_style'], 'border-color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
																	break;
															}
														}
													break;
												case 'show_hide_background_color':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['show_hide_button_style'] = $this->append_attribute( $overlay_vars['show_hide_button_style'], 'background-color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
														}
													break;
												case 'show_hide_text_color':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['show_hide_button_style'] = $this->append_attribute( $overlay_vars['show_hide_button_style'], 'color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
														}
													break;
												case 'background_color':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															switch( $overlay['type'] ){
																case 'lightbox':
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'background-color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
																	break;
																default:
																		$overlay_vars['section_style'] = $this->append_attribute( $overlay_vars['section_style'], 'background-color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
																	break;
															}
														}
													break;
												case 'content_padding_top':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															
															switch( $overlay['type'] ){
																default:
																		$overlay_vars['content_inner_style'] = $this->append_attribute( $overlay_vars['content_inner_style'], 'padding-top: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].'px;' );
																	break;
															}
														}
													break;
												case 'content_padding_right':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															switch( $overlay['type'] ){
																default:
																		$overlay_vars['content_inner_style'] = $this->append_attribute( $overlay_vars['content_inner_style'], 'padding-right: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].'px;' );
																	break;
															}
														}
													break;
												case 'content_padding_bottom':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															switch( $overlay['type'] ){
																default:
																		$overlay_vars['content_inner_style'] = $this->append_attribute( $overlay_vars['content_inner_style'], 'padding-bottom: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].'px;' );
																	break;
															}
														}
													break;
												case 'content_padding_left':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															switch( $overlay['type'] ){
																default:
																		$overlay_vars['content_inner_style'] = $this->append_attribute( $overlay_vars['content_inner_style'], 'padding-left: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].'px;' );
																	break;
															}
														}
													break;
												case 'height_from_top':
														switch( $overlay['type'] ){
															
															case 'side_box':
																	if( isset( $overlay['options'][ $overlay['type'].'_position'] ) && in_array( $overlay['options'][ $overlay['type'].'_position'], array( 'otw-left-sticky', 'otw-right-sticky') ) ){
																	
																		$top = false;
																		$bottom = false;
																		
																		$top_unit = '%';
																		$bottom_unit = '%';
																		
																		if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ] ) ){
																			$top_unit = $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ];
																		}
																		
																		if( !empty( $overlay['options'][ $overlay['type'].'_height_from_bottom_unit' ] ) ){
																			$bottom_unit = $overlay['options'][ $overlay['type'].'_height_from_bottom_unit' ];
																		}
																		
																		if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
																			$top = $overlay['options'][ $overlay['type'].'_'.$element_name ].$top_unit;
																			$bottom = 'auto';
																		}elseif( isset( $overlay['options'][ $overlay['type'].'_height_from_bottom' ] ) && strlen( trim( $overlay['options'][ $overlay['type'].'_height_from_bottom' ] ) ) ){
																			$top = 'auto';
																			$bottom = $overlay['options'][ $overlay['type'].'_height_from_bottom' ].$bottom_unit;
																		}
																		if( $top && $bottom ){
																			$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'top: '.$top.'; bottom: '.$bottom.';' );
																		}
																	}
																break;
														}
													break;
												case 'content_position':
														switch( $overlay['type'] ){
															case 'lightbox':
																	if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
																	
																		$overlay_vars['class'] = $this->append_attribute( $overlay_vars['class'], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																	}
																break;
															default:
																	
																	if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
																		
																		if( isset( $overlay['options'][ $overlay['type'].'_position'] ) && in_array( $overlay['options'][ $overlay['type'].'_position'], array( 'otw-top-sticky', 'otw-bottom-sticky', 'otw-left-sticky', 'otw-right-sticky') ) ){
																			$overlay_vars['class'] = $this->append_attribute( $overlay_vars['class'], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																		}
																	}
																break;
														}
													break;
												case 'content_width':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															
															$unit = 'px';
															
															if( isset( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ] ) && in_array( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ], array( 'px', '%' ) ) ){
																$unit = $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ];
															}
															
															switch( $overlay['type'] ){
															
																case 'full_bar':
																		$overlay_vars['content_inner_style'] = $this->append_attribute( $overlay_vars['content_inner_style'], 'width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].$unit.';' );
																	break;
																case 'side_box':
																		if( isset( $overlay['options'][ $overlay['type'].'_position'] ) && in_array( $overlay['options'][ $overlay['type'].'_position'], array( 'otw-top-sticky', 'otw-bottom-sticky') ) ){
																			$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].$unit.';' );
																		}else{
																			$overlay_vars['content_inner_style'] = $this->append_attribute( $overlay_vars['content_inner_style'], 'width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].$unit.';' );
																		}
																	break;
																case 'lightbox':
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].$unit.';' );
																	break;
															}
														}
													break;
												case 'min_content_width':
														
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
														
															$unit = 'px';
															
															if( isset( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ] ) && in_array( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ], array( 'px', '%' ) ) ){
																$unit = $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ];
															}
														
															switch( $overlay['type'] ){
															
																case 'lightbox':
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'min-width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].$unit.';' );
																	break;
															}
														}
													break;
												case 'max_content_width':
														
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
														
															$unit = 'px';
															
															if( isset( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ] ) && in_array( $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ], array( 'px', '%' ) ) ){
																$unit = $overlay['options'][ $overlay['type'].'_'.$element_name.'_unit' ];
															}
														
															switch( $overlay['type'] ){
															
																case 'lightbox':
																		$overlay_vars['style'] = $this->append_attribute( $overlay_vars['style'], 'max-width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].$unit.';' );
																	break;
															}
														}
													break;
												case 'show_button_label':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['show_label'] = otw_stripslashes( $overlay['options'][ $overlay['type'].'_'.$element_name ] );
														}
													break;
												case 'show_button_label_icon':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['show_label_prefix'] .= '<i class="'.$overlay['options'][ $overlay['type'].'_'.$element_name ].' otw_btn_icon"> </i>';
														}
													break;
												case 'show_button_label_icon_url':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['show_label_prefix'] .= '<img src="'.$overlay['options'][ $overlay['type'].'_'.$element_name ].'" alt="" title="" class="otw_btn_img" />';
														}
													break;
												case 'close_button_label':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['close_label'] = otw_stripslashes( $overlay['options'][ $overlay['type'].'_'.$element_name ] );
														}
													break;
												case 'close_button_label_icon':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['close_label_prefix'] .= '<i class="'.$overlay['options'][ $overlay['type'].'_'.$element_name ].' otw_btn_icon"> </i>';
														}
													break;
												case 'close_button_label_icon_url':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['close_label_prefix'] .= '<img src="'.$overlay['options'][ $overlay['type'].'_'.$element_name ].'" alt="" title="" class="otw_btn_img" />';
														}
													break;
												case 'open_type':
														
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
														
															switch( $overlay['type'] ){
															
																case 'lightbox':
																		switch( $overlay['options'][ $overlay['type'].'_'.$element_name ] ){
																		
																			case 'otw-show-sticky-load':
																			case 'otw-show-sticky-loads':
																			case 'otw-show-sticky-seconds':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-show-sticky-delay':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_delay'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_delay'].'"';
																					}
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-show-sticky-mouse':
																					
																					if( !isset( $_COOKIE ) || !isset( $_COOKIE['otw_ovom_'.md5( $overlay['id'] )] ) || !$_COOKIE['otw_ovom_'.md5( $overlay['id'] )] ){
																					
																					}
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-show-sticky-wooab':
																					
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-show-sticky-scroll':
																					
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'].'"';
																					}
																					
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-show-sticky-scrollto':
																					
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'].'"';
																					}
																					
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																			case 'otw-show-sticky-clickon':
																					
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'lh-'.$overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_clickon'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_clickon'].'"';
																					}
																					
																					if( !$from_link ){
																						$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'mfp-hide' );
																					}
																				break;
																		}
																	break;
																default:
																		switch( $overlay['options'][ $overlay['type'].'_'.$element_name ] ){
																			
																			case 'otw-show-sticky-mouse':
																					
																					if( !isset( $_COOKIE ) || !isset( $_COOKIE['otw_ovom_'.md5( $overlay['id'] )] ) || !$_COOKIE['otw_ovom_'.md5( $overlay['id'] )] ){
																					
																					}
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																				break;
																			case 'otw-show-sticky-wooab':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																				break;
																			case 'otw-show-sticky-scroll':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scroll'].'"';
																					}
																				break;
																			case 'otw-show-sticky-scrollto':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_scrollto'].'"';
																					}
																				break;
																			case 'otw-show-sticky-clickon':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_clickon'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_clickon'].'"';
																					}
																				break;
																			case 'otw-show-sticky-loads':
																			case 'otw-show-sticky-seconds':
																					
																					$overlay_vars[ 'wrapper_class' ] = $this->append_attribute( $overlay_vars[ 'wrapper_class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					$overlay_vars[ 'wrapper_class' ] = $this->append_attribute( $overlay_vars[ 'wrapper_class' ], 'otw-hide-sticky' );
																				break;
																			case 'otw-show-sticky-delay':
																					
																					$overlay_vars[ 'wrapper_class' ] = $this->append_attribute( $overlay_vars[ 'wrapper_class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																					$overlay_vars[ 'wrapper_class' ] = $this->append_attribute( $overlay_vars[ 'wrapper_class' ], 'otw-hide-sticky' );
																					
																					if( !empty( $overlay['options'][ $overlay['type'].'_'.$element_name.'_delay'] ) ){
																						$overlay_vars['data_param'] = ' data-param="'.$overlay['options'][ $overlay['type'].'_'.$element_name.'_delay'].'"';
																					}
																				break;
																			case 'otw-show-sticky-link':
																					$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																				break;
																		}
																	break;
															}
														}
													break;
												case 'affiliate_username':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars['affiliate_username']  = $overlay['options'][ $overlay['type'].'_'.$element_name ];
															$overlay_vars[ 'section_class' ] = $this->append_attribute( $overlay_vars[ 'section_class' ], 'otw-affiliate' );
														}
													break;
												case 'border_width':
														
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
														
															switch( $overlay['type'] ){
															
																case 'lightbox':
																		$overlay_vars[ 'style' ] = $this->append_attribute( $overlay_vars[ 'style' ], 'border-width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].'px;' );
																	break;
																default:
																		$overlay_vars[ 'section_style' ] = $this->append_attribute( $overlay_vars[ 'section_style' ], 'border-width: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].'px;' );
																	break;
															}
														}
													break;
												case 'animation_type':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
														
															switch( $overlay['options'][ $overlay['type'].'_'.$element_name ] ){
																case 'hinge':
																		$overlay_vars[ 'data-close-effect' ] = $this->append_attribute( $overlay_vars[ 'data-close-effect' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																	break;
																default:
																		$overlay_vars[ 'data-effect' ] = $this->append_attribute( $overlay_vars[ 'data-effect' ], $overlay['options'][ $overlay['type'].'_'.$element_name ] );
																	break;
															}
														}
													break;
												case 'overlay_color':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars[ 'data-style' ] = $this->append_attribute( $overlay_vars[ 'data-style' ], 'background-color: '.$overlay['options'][ $overlay['type'].'_'.$element_name ].';' );
														}
													break;
												case 'overlay_pattern_url':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars[ 'data-style' ] = $this->append_attribute( $overlay_vars[ 'data-style' ], 'background-image: url('.$overlay['options'][ $overlay['type'].'_'.$element_name ].');' );
															
															if( $overlay['type'] == 'full_bar' )
															{
																$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'otw-with-ovbackground' );
															}
														}
													break;
												case 'overlay_pattern_repeat':
														if( strlen( trim( $overlay['options'][ $overlay['type'].'_'.$element_name ] ) ) ){
															$overlay_vars[ 'data-style' ] = $this->append_attribute( $overlay_vars[ 'data-style' ], 'background-repeat: no-repeat;' );
														}
													break;
											}
										}
									}else{
										switch( $element_name ){
										
											case 'devices':
													foreach( $element_data['options'] as $ch_option_key => $ch_option_value ){
														if( isset( $overlay['options'][ $overlay['type'].'_'.$ch_option_key ] ) && ( $overlay['options'][ $overlay['type'].'_'.$ch_option_key ] == 'no' ) ){
															$overlay_vars[ 'class' ] = $this->append_attribute( $overlay_vars[ 'class' ], 'otw_no_'.$ch_option_key );
														}
													}
												break;
										}
									}
								}
							}
						}
						
						if( strlen( $overlay_vars['show_hide_button_class'] ) ){
							$overlay_vars['show_hide_button_class'] =  ' '.$overlay_vars['show_hide_button_class'];
						}
						
						if( strlen( $overlay_vars['show_button_class'] ) ){
							$overlay_vars['show_button_class'] =  ' '.$overlay_vars['show_button_class'];
						}
						if( strlen( $overlay_vars[ 'show_hide_button_style' ] ) ){
							$overlay_vars[ 'show_hide_button_style' ] = ' style="'.esc_attr( $overlay_vars[ 'show_hide_button_style' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'content_inner_style' ] ) ){
							$overlay_vars[ 'content_inner_style' ] = ' style="'.esc_attr( $overlay_vars[ 'content_inner_style' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'section_style' ] ) ){
							$overlay_vars[ 'section_style' ] = ' style="'.esc_attr( $overlay_vars[ 'section_style' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'style' ] ) ){
							$overlay_vars[ 'style' ] = ' style="'.esc_attr( $overlay_vars[ 'style' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'data-effect' ] ) ){
							$overlay_vars[ 'data-effect' ] = ' data-effect="'.esc_attr( $overlay_vars[ 'data-effect' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'data-style' ] ) ){
							$overlay_vars[ 'data-style' ] = ' data-style="'.esc_attr( $overlay_vars[ 'data-style' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'data_index' ] ) ){
							$overlay_vars[ 'data_index' ] = ' data-index="'.esc_attr( $overlay_vars[ 'data_index' ] ).'"';
						}
						if( strlen( $overlay_vars[ 'data-close-effect' ] ) ){
							$overlay_vars[ 'data-close-effect' ] = ' data-ceffect="'.esc_attr( $overlay_vars[ 'data-close-effect' ] ).'"';
						}
						
						if( $this->grid_manager_component_object ){
						
							$overlay_content = $this->grid_manager_component_object->decode_grid_content( 'ogm_'.$overlay['id'], otw_stripslashes( $overlay['grid_content'] ) );
							
							$overlay_vars['content'] = $this->otw_shortcode_remove_wpautop( $overlay_content );
						}
						
						$view_type = $this->views[ $overlay['type'] ];
						
						if( ( $overlay['type'] == 'full_bar' ) && isset( $overlay['options'] ) && isset( $overlay['options']['full_bar_push_content'] ) && ( $overlay['options']['full_bar_push_content'] == 'otw-push-content' ) ){
							$view_type = $this->views[ $overlay['type'].'_man' ];
						}
						
						include( $view_type.'.view.php' );
					}
	}
	
	/**
	 * Check if the overlays is active
	 */
	private function is_active( $overlay, $requested_objects ){
		
		$result = array();
		$result['active'] = false;
		$result['replacement'] = '';
		
		if( $overlay['status'] == 'active' ){
			
			//check for active_perriod values
			if( isset( $overlay['options'] ) && isset( $overlay['options'][ $overlay['type'].'_active_period_from' ] ) ){
			
				if( preg_match( "/^(\d{2})\.(\d{2})\.(\d{4}) (\d{2})\:(\d{2})/", $overlay['options'][ $overlay['type'].'_active_period_from' ], $from_matches ) ){
				
					if( checkdate( $from_matches[2], $from_matches[1], $from_matches[3] ) ){
						
						if( strtotime( $overlay['options'][ $overlay['type'].'_active_period_from' ] ) > time() ){
							return $result;
						}
					}
				}
			}
			if( isset( $overlay['options'] ) && isset( $overlay['options'][ $overlay['type'].'_active_period_to' ] ) ){
			
				if( preg_match( "/^(\d{2})\.(\d{2})\.(\d{4}) (\d{2})\:(\d{2})/", $overlay['options'][ $overlay['type'].'_active_period_to' ], $to_matches ) ){
				
					if( checkdate( $to_matches[2], $to_matches[1], $to_matches[3] ) ){
						
						if( strtotime( $overlay['options'][ $overlay['type'].'_active_period_to' ] ) < time() ){
							return $result;
						}
					}
				}
			}
			
			//check active perids
			if( isset( $overlay['options'] ) && isset( $overlay['options'][ $overlay['type'].'_active_periods' ] ) && strlen( $overlay['options'][ $overlay['type'].'_active_periods' ] ) ){
				
				$active_periods = json_decode( otw_stripslashes( $overlay['options'][ $overlay['type'].'_active_periods' ] ) );
				
				if( is_array( $active_periods ) ){
					
					$active_in_periods = array();
					
					foreach( $active_periods as $a_period_key => $a_period ){
						
						$active_in_periods[ $a_period_key ] = 1;
						
						if( $active_in_periods[ $a_period_key ] ){
							//check start settings
							if( !isset( $a_period->period_from_now ) || ( $a_period->period_from_now != 1 ) ){
								
								if( isset( $a_period->period_from_date ) && strlen( $a_period->period_from_date ) ){
									
									if( strtotime( $a_period->period_from_date ) > time() ){ //the start date is in the future
										$active_in_periods[ $a_period_key ] = 0;
									}
								}
							}
						}
						
						if( $active_in_periods[ $a_period_key ] ){
							//check end settings
							if( !isset( $a_period->period_to_never ) || ( $a_period->period_to_never != 1 ) ){
								
								if( isset( $a_period->period_to_date ) && strlen( $a_period->period_to_date ) ){
									
									if( strtotime( $a_period->period_to_date ) < time() ){ //the end date is in the past
										$active_in_periods[ $a_period_key ] = 0;
									}
								}
							}
						}
						
						if( $active_in_periods[ $a_period_key ] ){
							//check days of the weeek
							if( isset( $a_period->days ) && is_array( $a_period->days ) && count( $a_period->days ) ){
							
								$current_day = date( 'w' );
								
								if( !in_array( $current_day, $a_period->days ) ){
									$active_in_periods[ $a_period_key ] = 0;
								}
							}
						}
						
						if( $active_in_periods[ $a_period_key ] ){
							//check time of the day
							if( !isset( $a_period->period_time_all ) || ( $a_period->period_time_all != 1 ) ){
							
								$current_hour = intval( date( 'H' ) );
								$current_min  = intval( date( 'i' ) );
								
								$period_from_hour = intval( $a_period->period_from_hour );
								
								if( $a_period->period_from_mer == 'pm' ){
									$period_from_hour = $period_from_hour + 12;
									
									if( $period_from_hour == 24 ){
										$period_from_hour = 0;
									}
								}
								
								if( intval( $period_from_hour ) > $current_hour ){
									$active_in_periods[ $a_period_key ] = 0;
								}elseif( ( intval( $period_from_hour ) == $current_hour ) && ( intval( $a_period->period_from_min ) > $current_min ) ){
									$active_in_periods[ $a_period_key ] = 0;
								}
								
								$period_to_hour = intval( $a_period->period_to_hour );
								
								if( $a_period->period_to_mer == 'pm' ){
									$period_to_hour = $period_to_hour + 12;
									
									if( $period_to_hour == 24 ){
										$period_to_hour = 0;
									}
								}
								
								if( intval( $period_to_hour ) < $current_hour ){
									$active_in_periods[ $a_period_key ] = 0;
								}elseif( ( intval( $period_to_hour ) == $current_hour ) && ( intval( $a_period->period_to_min ) < $current_min ) ){
									$active_in_periods[ $a_period_key ] = 0;
								}
							}
						}
					}
					
					if( count( $active_in_periods ) && !in_array( 1, $active_in_periods ) ){
						return $result;
					}
				}
			}
			
			//check if its closed forever
			if( isset( $_COOKIE ) && isset( $_COOKIE['otw_ovcf_'.md5( $overlay['id'] ) ] ) && ( isset( $overlay['options'] ) ) && isset( $overlay['options'][ $overlay['type'].'_close_type' ] ) && ( $overlay['options'][ $overlay['type'].'_close_type' ] == 'otw-close-forever' ) ){
				
				$result['active'] = false;
				$result['replacement'] = '<div id="ovcf_'.esc_attr( $overlay['id'] ).'" class="otcl_track"></div>';
				return $result;
			}
			
			if( isset( $overlay['validfor'] ) && count( $overlay['validfor'] ) ){
				
				foreach( $requested_objects as $objects ){
					
					list( $object, $object_id, $object_type ) = $objects;
					
					if( $object && $object_id && $object_type ){
					
						if( $this->validate_overlay_object( $overlay, $object, $object_id ) ){
							
							$result['active'] = true;
							
							//check if is closed for number of page loads
							if( isset( $_COOKIE ) && isset( $_COOKIE['otw_ovcl_'.md5( $overlay['id'] ) ] ) && intval( $_COOKIE['otw_ovcl_'.md5( $overlay['id'] ) ] ) && ( isset( $overlay['options'] ) ) && isset( $overlay['options'][ $overlay['type'].'_close_type' ] ) && ( $overlay['options'][ $overlay['type'].'_close_type' ] == 'otw-close-loads' ) ){
								
								$result['active'] = false;
								$result['replacement'] = '<div id="ovcl_'.esc_attr( $overlay['id'] ).'" class="otcl_track"></div>';
								
							}
							if( isset( $_COOKIE ) && isset( $_COOKIE['otw_ovcd_'.md5( $overlay['id'] ) ] ) && intval( $_COOKIE['otw_ovcd_'.md5( $overlay['id'] ) ] ) && ( isset( $overlay['options'] ) ) && isset( $overlay['options'][ $overlay['type'].'_close_type' ] ) && ( $overlay['options'][ $overlay['type'].'_close_type' ] == 'otw-close-days' ) ){
								
								$result['active'] = false;
								$result['replacement'] = '';
							}
						}
					}//end has object id, type
					
				}//end loop requested objects
				
			}//end has valid for
			
		}//end has status active
		
		return $result;
	}
	
	/** get current requested object
	 *
	 *  @return array
	 */
	 
	private function get_current_object(){
		
		global $current_user;
		
		if( isset( $GLOBALS['wp_query'] ) ){
			$wp_query = $GLOBALS['wp_query'];
		}else{
			return array( array( '', 0, 'flow' ) );
		}
		
		$object_key = 0;
		
		$pre_objects = 0;
		
		$object = '';
		$object_id = 0;
		$object_type = 'flow';
	
		$current_object_key = $object_key;
		$objects[$current_object_key][0] = '';
		$objects[$current_object_key][1] = 0;
		$objects[$current_object_key][2] = 'flow';
		
		wp_reset_query();
		
		if( otw_installed_plugin( 'buddypress' ) ){
			global $bp;
		}
		
		if( is_page() ){
			$object = 'page';
			$query_object = $wp_query->get_queried_object();
			
			$object_id = $query_object->ID;
			
			if( otw_installed_plugin( 'buddypress' ) ){
				
				if( isset( $bp->pages->activity ) && ( $bp->pages->activity->id == $object_id ) ){
					$object = 'buddypress_page';
				}elseif( isset( $bp->pages->members ) && ( $bp->pages->members->id  == $object_id ) ){
					$object = 'buddypress_page';
				}
			}
			
			if( is_page_template() ){
				$template_string = get_page_template();
				$template_parts = explode( "/", $template_string );
				$o_id = $template_parts[ count( $template_parts ) - 1 ];
				if( $o_id != 'page.php' ){
					$objects[ $current_object_key + 1 ][0] = 'pagetemplate';
					$objects[ $current_object_key + 1 ][1] = $o_id;
					$objects[ $current_object_key + 1 ][2] = 'flow';
				}
			}
			
			
			$custom_taxonomies = get_taxonomies( array(  'public'   => true, '_builtin' => false ), 'object' );
			if( is_array( $custom_taxonomies ) && count( $custom_taxonomies ) ){
				
				foreach( $custom_taxonomies as $c_type => $c_type_info ){
					
					$post_taxonomies = wp_get_object_terms( $object_id, $c_type );
					
					if( is_array( $post_taxonomies ) && count( $post_taxonomies ) ){
						
						foreach( $post_taxonomies as $p_tax ){
							$object_key = count( $objects );
							$objects[ $object_key ][0] = 'page_in_ctx_'.$c_type;
							$objects[ $object_key ][1] = $p_tax->term_id;
							$objects[ $object_key ][2] = 'flow';
						}
					}
				}
			}
			
		}elseif( is_single() ){
			$post_type = get_post_type();
			
			$custom_post_types = get_post_types( array(  'public'   => true, '_builtin' => false ), 'object' );
			
			if( array_key_exists( $post_type, $custom_post_types )  ){
				
				$object = 'cpt_'.$post_type;
				$query_object = $wp_query->get_queried_object();
				
				if( $query_object->ID ){
					$object_id = $query_object->ID;
				}else{
					$object_name = get_query_var('pagename');
					if( $object_name ){
						$posts = get_posts( array( 'name' => $object_name, 'post_type' => $post_type, 'numberposts' => -1 ) );
					}elseif( $object_slug = get_query_var( $post_type ) ){
						$posts = get_posts( array( 'name' => $object_slug, 'post_type' => $post_type, 'numberposts' => -1 ) );
					}
					
					if( is_array( $posts ) && count( $posts ) ){
						$object_id = $posts[0]->ID;
					}
				}
				
				$custom_taxonomies = get_taxonomies( array(  'public'   => true, '_builtin' => false ), 'object' );
				if( is_array( $custom_taxonomies ) && count( $custom_taxonomies ) ){
					
					foreach( $custom_taxonomies as $c_type => $c_type_info ){
						
						$post_taxonomies = wp_get_object_terms( $object_id, $c_type );
						
						if( is_array( $post_taxonomies ) && count( $post_taxonomies ) ){
							
							foreach( $post_taxonomies as $p_tax ){
								$object_key = count( $objects );
								$objects[ $object_key ][0] = $post_type.'_in_ctx_'.$c_type;
								$objects[ $object_key ][1] = $p_tax->term_id;
								$objects[ $object_key ][2] = 'flow';
							}
						}
					}
				}
			}else{
				$object = 'post';
				$query_object = $wp_query->get_queried_object();
				
				$object_id = $query_object->ID;
				
				if( $object_id ){
					$post_categories = wp_get_post_categories( $object_id );
					
					if( is_array( $post_categories ) && count( $post_categories ) ){
						foreach( $post_categories as $p_cat ){
							
							$object_key = count( $objects );
							
							$objects[ $object_key ][0] = 'postsincategory';
							$objects[ $object_key ][1] = $p_cat;
							$objects[ $object_key ][2] = 'flow';
						}
					}
					$post_tags = wp_get_post_tags( $object_id );
					if( is_array( $post_tags ) && count( $post_tags ) ){
						foreach( $post_tags as $p_tag ){
							$object_key = count( $objects );
							
							$objects[ $object_key ][0] = 'postsintag';
							$objects[ $object_key ][1] = $p_tag->term_id;
							$objects[ $object_key ][2] = 'flow';
						}
					}
					$custom_taxonomies = get_taxonomies( array(  'public'   => true, '_builtin' => false ), 'object' );
					if( is_array( $custom_taxonomies ) && count( $custom_taxonomies ) ){
						
						foreach( $custom_taxonomies as $c_type => $c_type_info ){
							
							$post_taxonomies = wp_get_object_terms( $object_id, $c_type );
							
							if( is_array( $post_taxonomies ) && count( $post_taxonomies ) ){
								
								foreach( $post_taxonomies as $p_tax ){
									$object_key = count( $objects );
									$objects[ $object_key ][0] = 'post_in_ctx_'.$c_type;
									$objects[ $object_key ][1] = $p_tax->term_id;
									$objects[ $object_key ][2] = 'flow';
								}
							}
						}
					}
				}
			}
		}elseif( is_home() ){
			
			$query_object = $wp_query->get_queried_object();
			
			if( isset( $query_object->post_type ) ){
				$object = $query_object->post_type;
				$object_id = $query_object->ID;
			}
		}elseif( is_category() ){
			$object = 'category';
			$query_object = $wp_query->get_queried_object();
			$object_id = $query_object->term_id;
			
		}elseif( is_tag() ){
			$object = 'posttag';
			$query_object = $wp_query->get_queried_object();
			$object_id = $query_object->term_id;
		}elseif( is_archive() ){
		
			
			$object = 'archive';
			$object_id = 0;
			
			
			if( is_author() ){
				$q_object = $wp_query->get_queried_object();
				
				$object = 'author_archive';
				$object_id = $q_object->data->ID;
			}elseif( is_tax() ){
				$q_object = $wp_query->get_queried_object();
				
				$object = 'ctx_'.$q_object->taxonomy;
				$object_id = $q_object->term_id;
			}
			elseif( isset( $wp_query->query['year'] ) && isset( $wp_query->query['monthnum'] ) && isset( $wp_query->query['daily'] ) ){
				$object_id = 'daily';
			}
			elseif( isset( $wp_query->query['year'] ) && isset( $wp_query->query['monthnum'] ) ){
				$object_id = 'monthly';
			}
			elseif( isset( $wp_query->query['year'] ) ){
				
				$object_id = 'yearly';
				
			}elseif( function_exists( 'is_shop' ) && function_exists( 'woocommerce_get_page_id' ) && is_shop() && woocommerce_get_page_id('shop') ){
				//woocommerce pages
				$object = 'page';
				$object_id = woocommerce_get_page_id('shop');
				
			}elseif( otw_installed_plugin( 'bbpress' ) && isset( $wp_query->post ) && $wp_query->post->ID == 0 && isset( $wp_query->queried_object_id ) && ( $wp_query->queried_object_id == 0 ) && isset( $wp_query->queried_object ) && ( $wp_query->queried_object->name == 'forum' ) ){
				//bbpress pages
				$object = 'bbp_page';
				$object_id = 'forums';
			}elseif( otw_installed_plugin( 'buddypress' ) && isset( $wp_query->post ) && isset( $wp_query->queried_object )&& isset( $wp_query->queried_object->ID ) && $wp_query->queried_object->ID && isset( $bp->pages->activity ) && ( $bp->pages->activity->id == $wp_query->queried_object->ID ) ){
				$object = 'buddypress_page';
				$object_id = $wp_query->queried_object->ID;
			}elseif( otw_installed_plugin( 'buddypress' ) && isset( $wp_query->post ) && isset( $wp_query->queried_object ) && isset( $wp_query->queried_object->ID ) && $wp_query->queried_object->ID && isset( $bp->pages->members ) && ( $bp->pages->members->id == $wp_query->queried_object->ID ) ){
				$object = 'buddypress_page';
				$object_id = $wp_query->queried_object->ID;
			}
			
		}else{
			if( !$object ){
				if( isset( $wp_query->queried_object ) && is_object(  $wp_query->queried_object ) && isset( $wp_query->queried_object->taxonomy ) && isset( $wp_query->queried_object->term_taxonomy_id ) && $wp_query->queried_object->term_taxonomy_id  ){
					$object = 'ctx_'.$wp_query->queried_object->taxonomy;
					$object_id = $wp_query->queried_object->term_taxonomy_id;
				}elseif( otw_installed_plugin( 'bbpress' ) && isset( $wp_query->bbp_is_search ) && $wp_query->bbp_is_search ){
					$object = 'bbp_page';
					$object_id = 'search';
				}elseif( otw_installed_plugin( 'bbpress' ) && isset( $wp_query->bbp_is_view ) && $wp_query->bbp_is_view && isset( $wp_query->query ) && isset( $wp_query->query['bbp_view'] ) && (  $wp_query->query['bbp_view'] == 'no-replies' )  ){
					$object = 'bbp_page';
					$object_id = 'noreplies';
				}elseif( otw_installed_plugin( 'bbpress' ) && isset( $wp_query->bbp_is_view ) && $wp_query->bbp_is_view && isset( $wp_query->query ) && isset( $wp_query->query['bbp_view'] ) && (  $wp_query->query['bbp_view'] == 'popular' ) ){
					$object = 'bbp_page';
					$object_id = 'mostpopular';
				}elseif( otw_installed_plugin( 'bbpress' ) && isset( $wp_query->bbp_is_single_user ) && $wp_query->bbp_is_single_user ){
					$object = 'bbp_page';
					$object_id = 'singleuser';
				}
			}
		}
		
		$objects[ $current_object_key ][0] = $object;
		$objects[ $current_object_key ][1] = $object_id;
		$objects[ $current_object_key ][2] = 'flow';
		
		//add Template Hierarchy as next object
		$object_key = count( $objects );
		
		if( ( $object_key == ( $pre_objects + 1 ) ) && !$objects[ $current_object_key ][0] ){
			$object_key = $current_object_key;
		}
		
		if( is_front_page() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'front';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_home() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'home';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_404() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = '404';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_search() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'search';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_date() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'date';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_author() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'author';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_category() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'category';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_tag() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'tag';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_tax() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'taxonomy';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_archive() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'archive';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_single() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'single';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_attachment() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'attachment';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		if( is_page() ){
			$objects[ $object_key ][0] = 'templatehierarchy';
			$objects[ $object_key ][1] = 'page';
			$objects[ $object_key ][2] = 'flow';
			$object_key++;
		}
		
		return $objects;
	}
	
	/** check if given pverlay is valid for the given object and object_id
	  *  @param string
	  *  @param string
	  *  @param string
	  *  @return string
	  */
	private function validate_overlay_object( $overlay, $object, $object_id ){
	
		$valid = false;
		
		if( isset( $overlay['validfor'][ $object ][ $object_id ] ) || isset( $overlay['validfor'][ $object ][ 'all' ] ) ){
			
			if(  is_single() && isset( $overlay['validfor'][ $object ][ $object_id ] ) && isset( $overlay['exclude_posts_for'] ) && isset( $overlay['exclude_posts_for'][ $object ] ) ){
			
				global $wp_query;
				
				$query_object = $wp_query->get_queried_object();
				
				$post_id = $query_object->ID;
				
				if( $this->check_from_excluded_items( 'post', $post_id, $overlay['exclude_posts_for'][ $object ] ) ){
					
					$valid = true;
				}
			}else{
				$valid = true;
			}
			
		}elseif( preg_match( "/^cpt\_(.*)/", $object, $matches ) ){
			
			$cpt_object = 'customposttype';
			$cpt_object_id = $matches[1];
			
			if( isset( $overlay['validfor'][ $cpt_object ][ $cpt_object_id ] ) || isset( $overlay['validfor'][ $cpt_object ][ 'all' ] ) ){
				$valid = true;
			}
		}
		
		if( $valid ){
			
			$filters = $this->get_strict_filters();
			
			if( is_array( $filters ) && count( $filters ) ){
				
				foreach( $filters as $filter ){
					
					switch( $filter[2] ){
						
						case 'any':
								$match_any = false;
								
								if( isset( $overlay['validfor'] ) && isset( $overlay['validfor'][ $filter[0] ] ) && is_array( $overlay['validfor'][ $filter[0] ] ) && count( $overlay['validfor'][ $filter[0] ] ) ){
									
									if( isset( $overlay[ $filter[0] ]['all'] ) ){
										$match_any = true;
									}else{
										foreach( $filter[1] as $s_filter ){
											
											if( array_key_exists( $s_filter, $overlay['validfor'][ $filter[0] ] ) ){
											
												$match_any = true;
												break;
											}
										}
									}
								}
								
								if( !$match_any ){
									$valid = false;
								}
							break;
						case 'all':
								$dont_match_one = false;
								
								foreach( $filter[1] as $s_filter ){
								
									if( isset( $overlay['validfor'][ $filter[0] ] ) && is_array( $overlay['validfor'][ $filter[0] ] ) && count( $overlay['validfor'][ $filter[0] ] ) ){
										
										if( !isset( $overlay['validfor'][ $filter[0] ]['all'] ) ){
											
											if( !array_key_exists( $s_filter, $overlay['validfor'][ $filter[0] ] ) ){
												$dont_match_one = true;
												break;
											}
										}
									}else{
										$dont_match_one = true;
										break;
									}
								}
								if( $dont_match_one ){
									$valid = false;
								}
							break;
					}
				}
			}
		}
		
		return $valid;
	}
	
	/**
	 * get strict filters
	 */
	private function get_strict_filters(){
		
		
		global $current_user;
		$filters = array();
		
		//apply user roles
		if ( function_exists('wp_get_current_user') ){
			wp_get_current_user();
		}
		
		if( isset( $current_user->ID ) && intval( $current_user->ID ) && isset( $current_user->roles ) && is_array( $current_user->roles ) && count( $current_user->roles ) ){
			
			$filter_key = count( $filters );
			$filters[ $filter_key ][0] = 'userroles';
			$filters[ $filter_key ][1] = array();
			foreach( $current_user->roles as $u_role ){
				$filters[ $filter_key ][1][] = $u_role;
			}
			$filters[ $filter_key ][2] = 'any';
		}
		else
		{
			$filter_key = count( $filters );
			$filters[ $filter_key ][0] = 'userroles';
			$filters[ $filter_key ][1] = array();
			$filters[ $filter_key ][1][] = 'notlogged';
			$filters[ $filter_key ][2] = 'any';
		}
		
		if( otw_installed_plugin( 'wpml' ) && defined( 'ICL_LANGUAGE_CODE' ) ){
			
			$filter_key = count( $filters );
			$filters[ $filter_key ][0] = 'wpmllanguages';
			$filters[ $filter_key ][1] = array();
			$filters[ $filter_key ][1][] = ICL_LANGUAGE_CODE;
			$filters[ $filter_key ][2] = 'all';
		}
		return $filters;
	}
	
	/**
	 * Resolve excluded items give list of ids or slugs
	*/
	private function check_from_excluded_items( $object, $object_id, $items ){
		
		$valid = true;
		
		$excluded_items = array();
		
		if( isset( $items ) && strlen( $items ) ){
			$excluded_items = explode( ",", $items );
			
			if( count( $excluded_items ) ){
				$excluded_items = array_map( 'trim', $excluded_items );
			}
		}
		
		if( in_array( $object_id, $excluded_items ) ){
			$valid = false;
		}else{
			switch( $object ){
				case 'post':
						$post_info = get_post( $object_id );
						
						if( isset( $post_info->post_name ) ){
							
							if( in_array( $post_info->post_name, $excluded_items ) ){
								$valid = false;
							}
						}
					break;
			}
		}
		return $valid;
		
	}
	
	/** append attribute to existing list with attributes
	 *
	 *  @param string
	 *  @param string
	 *  @return string
	 */
	public function append_attribute( $append_to, $attribute ){
		
		$result = $append_to;
		
		if( strlen( $result ) ){
			$result .= ' '.$attribute;
		}else{
			$result .= $attribute;
		}
		return $result;
	}
	
	public function action_meta_metaboxes()
	{
		add_meta_box( 'otw_overlay_nav_menu', $this->get_label('OTW Popup/Overlay'), array( &$this, 'build_nav_meta_box' ), 'nav-menus', 'side', 'default');
	}
	
	/**
	 *  Render meta box content
	 */
	public function build_nav_meta_box(){
	
		global $_nav_menu_placeholder, $nav_menu_selected_id;
		
		$_nav_menu_placeholder = 0 > $_nav_menu_placeholder ? $_nav_menu_placeholder - 1 : -1;
		
		$html = '<div class="otwoverlaydiv" id="otwoverlaydiv">';
		$html .= '<input type="hidden" value="custom" name="menu-item['.$_nav_menu_placeholder.'][menu-item-type]" />';
		
		$overlays = get_option( $this->option_name );
		
		if( is_array( $overlays ) && count( $overlays ) ){
			
			foreach( $overlays as $overlay ){
			
				$html .= '<p>';
				$html .= '<label for="otw_custom_menu_overlay_'.esc_attr( $overlay['id'] ).'" class="menu-item-title">';
				$html .= '<input id="otw_custom_menu_overlay_'.esc_attr( $overlay['id'] ).'" class="menu-item-checkbox" type="checkbox" value="'.esc_attr( $overlay['id'] ).'" name="menu-item[-1][menu-item-object-id]">';
				$html .= '<span>'.$overlay['title'].'</span>';
				$html .= '</label>';
				
				$html .= '</p>';
			
			}
			$html .= '<p class="button-controls">
					<span class="add-to-menu">
						<input type="submit"'.wp_nav_menu_disabled_check( $nav_menu_selected_id ).' class="button-secondary submit-add-to-menu right" value="'.$this->get_label('Add to Menu').'" name="add-otw-overlay-menu-item" id="submit-otwoverlaydiv" />
						<span class="spinner"></span>
					</span>
				</p>';
			
		}else{
			$html .= $this->get_label( 'No Avalilable Popup/Overlays found' );
		}
		
		$html .= '</div>';
		
		echo $html;
	}
	
	/**
	 * Return attrubte for the shortcode link
	 *
	 */
	public function get_shortcode_link_attributes( $overlay ){
	
		$class = '';
		$data_effect = '';
		
		switch( $overlay['type'] ){
			
			case 'lightbox':
						$class = 'otw-display-popup-link';
						
						if( isset( $overlay['options'] ) ){
							
							if( isset( $overlay['options'][ $overlay['type'].'_animation_type' ] ) && strlen( $overlay['options'][ $overlay['type'].'_animation_type' ] ) ){
								
								switch( $overlay['options'][ $overlay['type'].'_animation_type' ] ){
								
									case 'hinge';
											$class = 'otw-display-hinge';
										break;
									default:
											$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_animation_type' ] );
										break;
									}
								}
								if( isset( $overlay['options'][ $overlay['type'].'_overlay_color_class' ] ) && strlen( $overlay['options'][ $overlay['type'].'_overlay_color_class' ] ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_overlay_color_class' ] );
								}
								if( isset( $overlay['options'][ $overlay['type'].'_enable_close_button' ] ) && strlen( $overlay['options'][ $overlay['type'].'_enable_close_button' ] ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_enable_close_button' ] );
								}
								if( isset( $overlay['options'][ $overlay['type'].'_enable_close_on_content' ] ) && strlen( $overlay['options'][ $overlay['type'].'_enable_close_on_content' ] ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_enable_close_on_content' ] );
								}
								if( isset( $overlay['options'][ $overlay['type'].'_enable_close_on_background' ] ) && strlen( $overlay['options'][ $overlay['type'].'_enable_close_on_background' ] ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_enable_close_on_background' ] );
								}
								if( isset( $overlay['options'][ $overlay['type'].'_overlay_pattern_class' ] ) && strlen( $overlay['options'][ $overlay['type'].'_overlay_pattern_class' ] ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_overlay_pattern_class' ] );
								}
								if( isset( $overlay['options'][ $overlay['type'].'_overlay_opacity_class' ] ) && strlen( $overlay['options'][ $overlay['type'].'_overlay_opacity_class' ] ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_overlay_opacity_class' ] );
								}
								if( isset( $overlay['options'][ $overlay['type'].'_close_type' ] ) && strlen( $overlay['options'][ $overlay['type'].'_close_type' ] ) && ( $overlay['options'][ $overlay['type'].'_close_type' ] == 'otw-never-close' ) ){
									$data_effect = $this->append_attribute( $data_effect, $overlay['options'][ $overlay['type'].'_close_type' ] );
								}
							}
					break;
				default:
						$class = 'otw-display-overlay';
					break;
		}
		
		$attributes = array();
		
		if( strlen( $class ) ){
			$attributes['class'] = $class;
		}
		if( strlen( $data_effect ) ){
			$attributes['data-effect'] = $data_effect;
		}
		return $attributes;
	}
	
	/**
	 * filter nav menu links
	 *
	 */
	public function add_nav_menu_shortcodes( $attributes ){
		
		if( isset( $attributes['href'] ) && preg_match( "/^\#otw\-overlay\-([0-9]+)$/", $attributes['href'], $matches ) ){
			
			if( !is_array( $this->overlays ) ){
			 
				$this->overlays = get_option( $this->option_name );
				
				if( !is_array( $this->overlays ) ){
					$this->overlays = array();
				}
			
			}
			
			if( is_array( $this->overlays ) && isset( $this->overlays['otw-overlay-'.$matches[1] ] ) ){
				
				$s_attributes = $this->get_shortcode_link_attributes( $this->overlays[ 'otw-overlay-'.$matches[1] ] );
				
				foreach( $s_attributes as $s_name => $s_value ){
				
					if( isset( $attributes[ $s_name ] ) && strlen( $attributes[ $s_name ] ) ){
						$attributes[ $s_name ] = $attributes[ $s_name ].' '.$s_value;
					}else{
						$attributes[ $s_name ] = $s_value;
					}
				}
			
			}
		}
		
		return $attributes;
	}
}
?>
